\\ Copyright 2014, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


\\ Centroid of right-side enclosed area


check_equal(got,want) =
{
  if(got!=want, print("wrong\n","got\n",got,"\nwant\n",want);
                quit(1),
                print("ok"));
}

sqrt3i = quadgen(4*-3);
w6 = 1/2 + 1/2*sqrt3i;
check_equal(w6^3, -1)
check_equal(w6^6, 1)
w3 = -1/2 + 1/2*sqrt3i;
check_equal(w3^3, 1)

w3 = w6^2;
b = w6 + 1;

AR(k) = if(k==0,0, 3^(k-1)-2^(k-1));
J(k) = if(k<0,error("J(k) no k<0"), k==0,0, 2^(k-1));
GRT(k) = 1/13*(7 - 2*w6) * b^k  + 1/39*(5 - 7*w6) * (conj(w6)/2)^k;
GJ(k) = b^(k+1) - 2*w6*GRT(k);
GR_powers(k) = GRT(k) + w6/3 * (b/2)^k;
GR(k) = if(k==0,return(1/2)); GR_powers(k);

GARN_samples_by_path = { 1/6 * [
   (3) + (5)*sqrt3i,   /* k=2 */
   (-12) + (46)*sqrt3i,   /* k=3 */
   (-306) + (248)*sqrt3i,   /* k=4 */
   (-2769) + (799)*sqrt3i,   /* k=5 */
   (-17277) + (-385)*sqrt3i,   /* k=6 */
   (-80199) + (-28301)*sqrt3i,   /* k=7 */
   (-244227) + (-253717)*sqrt3i,   /* k=8 */
   (28590) + (-1536860)*sqrt3i,   /* k=9 */
   (7088076) + (-6973474)*sqrt3i   /* k=10 */
]};

GAR(k) = {
  1/(3^k - 3*2^(k-1))
  * (3^k*1/2*b^k
     - 3*2^(k-1)*(1/13*(7 - 2*w6) * b^k
                  + 1/39*(5 - 7*w6) * (conj(w6)/2)^k
                  + w6/3 * (b/2)^k));
}
check_equal(vector(length(GARN_samples_by_path),k,my(k=k+1); AR(k)*GAR(k)), \
            GARN_samples_by_path)  /* k>=2 */


GAR(k) = {
  1/(3^k - 3*2^(k-1))
  * (3^k*1/2*b^k
     - 3*2^(k-1)*1/13*(7 - 2*w6) * b^k
     - 3*2^(k-1)*1/39*(5 - 7*w6) * (conj(w6)/2)^k
     - 3*2^(k-1)*w6/3 * (b/2)^k);
}
check_equal(vector(length(GARN_samples_by_path),k,my(k=k+1); AR(k)*GAR(k)), \
            GARN_samples_by_path)  /* k>=2 */


GAR(k) = {
  1/(3^k - 3*2^(k-1))
  * (3^k*1/2*b^k
     - 3/13*2^(k-1)*(7 - 2*w6) * b^k
     - 1/13*2^(k-1)*(5 - 7*w6) * (conj(w6)/2)^k
     -      2^(k-1)*w6         * (b/2)^k);
}
check_equal(vector(length(GARN_samples_by_path),k,my(k=k+1); AR(k)*GAR(k)), \
            GARN_samples_by_path)  /* k>=2 */

GAR(k) = {
  1/(3^k - 3*2^(k-1))
  * (3^k*1/2*b^k
     -      2^(k-1)*w6         * (b/2)^k
     - 3/13*2^(k-1)*(7 - 2*w6) * b^k
     - 1/13*2^(k-1)*(5 - 7*w6) * (conj(w6)/2)^k
    );
}
check_equal(vector(length(GARN_samples_by_path),k,my(k=k+1); AR(k)*GAR(k)), \
            GARN_samples_by_path)  /* k>=2 */

GAR(k) = {
  1/2*b^k
  +
  1/(3^k - 3*2^(k-1))
  * (- (3^k - 3*2^(k-1)) * 1/2*b^k
     + 1/2*3^k * b^k
     - 3/26*2^k*(7 - 2*w6) * b^k
     - 1/2*w6  * b^k
     - 1/13*2^(k-1)*(5 - 7*w6) * (conj(w6)/2)^k
    );
}
check_equal(vector(length(GARN_samples_by_path),k,my(k=k+1); AR(k)*GAR(k)), \
            GARN_samples_by_path)  /* k>=2 */

GAR(k) = {
  1/2*b^k
  +
  1/(3^k - 3*2^(k-1))
  * (+ (-3/52 + 3/13*w6) * 2^k * b^k
     - 1/2*w6  * b^k
     - 1/13*2^(k-1)*(5 - 7*w6) * (conj(w6)/2)^k
    );
}
check_equal(vector(length(GARN_samples_by_path),k,my(k=k+1); AR(k)*GAR(k)), \
            GARN_samples_by_path)  /* k>=2 */

GAR(k) = {
  1/2*b^k
  +
  1/3 * 1/(3^(k-1) - 2^(k-1))
  * (+ 1/52*(-3 + 12*w6) * 2^k * b^k
     - 1/2 *w6  * b^k
     - 1/26*(5 - 7*w6) * conj(w6)^k
    );
}
check_equal(vector(length(GARN_samples_by_path),k,my(k=k+1); AR(k)*GAR(k)), \
            GARN_samples_by_path)  /* k>=2 */

GAR(k) = {
  1/2*b^k
  +
  1/3 * 1/(3^(k-1) - 2^(k-1))
  * (+ 1/52*(9 + 12*w3) * 2^k * b^k
     - 1/2 *w6  * b^k
     - 1/26*(5 - 7*w6) * (-w3)^k
    );
}
check_equal(vector(length(GARN_samples_by_path),k,my(k=k+1); AR(k)*GAR(k)), \
            GARN_samples_by_path)  /* k>=2 */

\\-----------------------------------------------------------------------------
\\ with join

check_equal(vector(100,k, 3*AR(k-1) + J(k-1)), \
            vector(100,k, AR(k)))

GAR_by_join(k) = {
  1/AR(k) * (
      AR(k-1) *                  GAR(k-1)
    + AR(k-1) * (   b^(k-1) + w3*GAR(k-1))
    + AR(k-1) * (w6*b^(k-1) +    GAR(k-1))
    +  J(k-1) * (b^k - GJ(k-1))
  );
}
check_equal(vector(length(GARN_samples_by_path)-1,k,my(k=k+2); \
                   AR(k)*GAR_by_join(k)), \
            GARN_samples_by_path[^1])  /* k>=2 */

GAR_by_join(k) = {
  1/AR(k) * (
      AR(k-1) * (GAR(k-1) + b^(k-1) + w3*GAR(k-1) + w6*b^(k-1) +    GAR(k-1))
    +  J(k-1) * (b^k - GJ(k-1))
  );
}
check_equal(vector(length(GARN_samples_by_path)-1,k,my(k=k+2); \
                   AR(k)*GAR_by_join(k)), \
            GARN_samples_by_path[^1])  /* k>=2 */

GAR_by_join(k) = {
  1/AR(k) * (
      AR(k-1) * (b*GAR(k-1) + b^k)
    +  J(k-1) * (b^k - GJ(k-1))
  );
}
check_equal(vector(length(GARN_samples_by_path)-1,k,my(k=k+2); \
                   AR(k)*GAR_by_join(k)), \
            GARN_samples_by_path[^1])  /* k>=2 */

GAR_by_join(k) = {
  1/AR(k) *AR(k-1) *b*GAR(k-1)
  + 1/AR(k) * (
      AR(k-1) * b^k
    +  J(k-1) * (b^k - GJ(k-1))
  );
}
check_equal(vector(length(GARN_samples_by_path)-1,k,my(k=k+2); \
                   AR(k)*GAR_by_join(k)), \
            GARN_samples_by_path[^1])  /* k>=2 */

GAR_by_join(k) = {
  1/AR(k) *AR(k-1) *b*GAR(k-1)
  + 1/AR(k) * (
      AR(k-1) * b^k
    +  J(k-1) * b^k
    -  J(k-1) * GJ(k-1)
  );
}
check_equal(vector(length(GARN_samples_by_path)-1,k,my(k=k+2); \
                   AR(k)*GAR_by_join(k)), \
            GARN_samples_by_path[^1])  /* k>=2 */

GAR_by_join(k) = {
  1/AR(k) *AR(k-1) *b*GAR(k-1)
  + 1/AR(k) * (
      (3^(k-2) - 2^(k-2)) * b^k
    +  2^(k-2) * b^k
    -  J(k-1) * GJ(k-1)
  );
}
check_equal(vector(length(GARN_samples_by_path)-1,k,my(k=k+2); \
                   AR(k)*GAR_by_join(k)), \
            GARN_samples_by_path[^1])  /* k>=2 */

GAR_by_join(k) = {
  AR(k-1)/AR(k) * b * GAR(k-1)
  + 1/AR(k) * (
      3^(k-2) * b^k
    - 2^(k-2) * GJ(k-1)
  );
}
check_equal(vector(length(GARN_samples_by_path)-1,k,my(k=k+2); \
                   AR(k)*GAR_by_join(k)), \
            GARN_samples_by_path[^1])  /* k>=2 */
