/* Copyright 2015 Kevin Ryde

   This file is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 3, or (at your option) any later
   version.

   This file is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.

   You should have received a copy of the GNU General Public License along
   with this file.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdio.h>
#include <limits.h>

int neighbours[][7] = {};

int
main (void)
{
  int num_vertices = sizeof(neighbours) / sizeof(neighbours[0]);
  int distance[num_vertices];

  int v;
  for (v = 0; v < num_vertices; v++)
    distance[v] = INT_MAX;
  distance[0] = 0;

  printf("%d vertices\n", num_vertices);
  int passes = 0;
  for (;;) {
    int updates = 0;
    passes++;

    for (v = 0; v < num_vertices; v++) {
      int dv = distance[v];
      if (dv == INT_MAX) continue;
      dv++;
      /* printf ("dv %d\n", dv); */
      
      int i;
      for (i = 0; ; i++) {
        int t = neighbours[v][i];
        if (t < 0) break;
        /* printf ("neighbour %d\n", t); */
        if (distance[t] > dv) {
          /* printf ("  update from %d to %d\n", distance[t], dv); */
          distance[t] = dv;
          updates++;
        }
      }
    }
    printf ("%d updates\n", updates);
    if (! updates) break;
  }

  printf ("from %d to %d by %d passes\n",
          distance[0],
          distance[num_vertices-1],
          passes);
  return 0;
}
