#!/usr/bin/perl -w

# Copyright 2014, 2015, 2016 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.

use 5.004;
use strict;
use FindBin;
use Math::PlanePath::TerdragonCurve 117; # v.117 for level_to_n_range()

use FindBin;
BEGIN { unshift @INC, $FindBin::Bin }
use MyTerdragon ':all';
use MyPrintwrap ':all';

# uncomment this to run the ### lines
use Smart::Comments;


my $level = 8;

if (@ARGV) { $level = shift @ARGV; }
print "  % generated by tools/$FindBin::Script\n";

my $path = Math::PlanePath::TerdragonCurve->new;
my ($n_lo, $n_hi) = $path->level_to_n_range($level);
my ($x_hi,$y_hi) = $path->n_to_xy($n_hi);

print "  \\begin{scope}[rotate={-atan2($y_hi*sqrt(3),$x_hi)},yscale=sqrt(3),scale={1/2*1/sqrt(3)^$level}]\n";

$Printwrap = 2;
printwrap("\\fill[my gray] ");
$Printwrap += 2;
my $B = 0;
my $join = '';
foreach my $rotate (0, 1) {
  foreach my $n ($n_lo .. $n_hi-1) {
    $path->_UNDOCUMENTED__n_segment_is_right_boundary($n) or next;
    $B++;

    my ($x,$y) = $path->n_to_xy($n);
    if ($rotate) {
      ($x,$y) = (-$x,-$y);  # rotate 180
      $x += $x_hi;
      $y += $y_hi;
    }
    printwrap("$join($x,$y)");
    $join = '--';
  }
}
printwrap("${join}cycle;\n");

print "% GP-Test  B($level) == $B\n";
print "  \\end{scope}\n";
print "  % end generated\n";
exit 0;
