#!/usr/bin/perl -w

# Copyright 2014 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.


use 5.004;
use strict;
use Math::PlanePath::R5DragonCurve;

use FindBin;
BEGIN { unshift @INC, $FindBin::Bin }
use MyTerdragon ':all';
use MyPrintwrap ':all';

# uncomment this to run the ### lines
# use Smart::Comments;


my ($x_min,$x_max) = (0, 13);
my ($y_min,$y_max) = (0, 3);
my $shorten = .35;
printwrap("  % generated by tools/$FindBin::Script\n");

my @dir3_to_dx = (2,-1, -1);
my @dir3_to_dy = (0, 1, -1);

$Printwrap = 2;
foreach my $y ($y_min .. $y_max) {
  my $x = $x_min;
  if (($x&1) != ($y&1)) { $x++; }
  for ( ; $x <= $x_max; $x+=2) {

    my $m2 = $x - 3*$y;
    $m2 % 2 == 0 or die;
    my $m = ($m2 / 2) % 3;
    printwrap("\\node at ($x,{$y*sqrt(3)}) [draw,circle] (P) {$m};\n");

    foreach my $i (0 .. $#dir3_to_dx) {
      my $dx = $dir3_to_dx[$i];
      my $dy = $dir3_to_dy[$i];
      my $angle = $i*120;
      my $x2 = $x + $dx*(1-$shorten);
      my $y2 = $y + $dy*(1-$shorten);
      printwrap("\\draw[->] (P.$angle) -- ($x2,{$y2*sqrt(3)});\n");
    }
  }
}

print "  % end generated\n";
exit 0;
