\\ Copyright 2014, 2015, 2016, 2017, 2018, 2019, 2020, 2021 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


\\ THIS IS A GENERATED FILE
\\ Extracted from terdragon.tex by gp-inline.
\\
\\ These are Pari/GP functions and definitions used in terdragon.tex for
\\ various self-tests and formula checking there.  Names and styles are
\\ highly specific to the calculations there, and many things will change or
\\ disappear, etc, but some of the functions might be useful for
\\ experimenting or testing.
/* ------------------------------------------------------------------------- */
/* gp-inline test boilerplate begin */
gp_inline__location = "";
gp_inline__good = 0;
gp_inline__bad = 0;
gp_inline__check(location,bool) =
{
  gp_inline__location = location;
  check(bool);
}
/* this is thinking about a check() for use in loops or "GP-Inline ..."
   testing, but it's not settled so don't rely on it */
check(bool) =
{
  /* use "===" so that a vector like [1] or float 1.0 not reckoned success */
  if(bool===1, gp_inline__good++,
     bool===0, gp_inline__bad++;
               print(gp_inline__location": gp-inline fail"),
     gp_inline__bad++;
     print(gp_inline__location": gp-inline expected result 0 or 1, got ",
           bool));
}
/* gp-inline test boilerplate end */
/* ------------------------------------------------------------------------- */

gp_inline__location="../terdragon.tex:182";
 default(strictargs,1);

gp_inline__location="../terdragon.tex:186";
 \\ my http://user42.tuxfamily.org/pari-geom/index.html
 iferr(read("tools/geom.gp"), e, \
    read("../tools/geom.gp"));
 iferr(read("tools/geom-inertia.gp"), e, \
    read("../tools/geom-inertia.gp"));
 iferr(read("tools/geom-wip.gp"), e, \
    read("../tools/geom-wip.gp"));

gp_inline__location="../terdragon.tex:194";
 \\ my http://user42.tuxfamily.org/pari-vpar/index.html
 iferr(read("tools/vpar.gp"),      e,read("../tools/vpar.gp"));
 iferr(read("tools/vpar-wip.gp"),  e,read("../tools/vpar-wip.gp"));

gp_inline__location="../terdragon.tex:198";
 iferr(read("tools/vecper.gp"),e, \
    read("../tools/vecper.gp"));
 iferr(read("tools/terdragon-oeis-samples.gp"),e, \
    read("../tools/terdragon-oeis-samples.gp"));

gp_inline__location="../terdragon.tex:203";
 nearly_equal_epsilon = 1e-15;
 nearly_equal(x,y, epsilon=nearly_equal_epsilon) = {
   \\ print(type(x)," ",type(y)," ",x," ",y);
   my(d=x-y); \\ ensure compatible types
   if(type(x)=="t_MAT",x=Vec(x);y=Vec(y));
   if(type(x)=="t_VEC" || type(x)=="t_COL",
        sum(i=1,max(#x,#y), !nearly_equal(x[i],y[i],epsilon)) == 0,
      type(x)=="t_QUAD" || type(x)=="t_COMPLEX",
           nearly_equal(real(x-y),0,epsilon)
        && nearly_equal(imag(x-y),0,epsilon),
      abs(d) < epsilon);
 }

gp_inline__location="../terdragon.tex:216";
 degrees(x) = x/180*Pi;
 to_degrees(x) = x/Pi*180;

gp_inline__location="../terdragon.tex:219";
 sqrt3  = geom_sqrt_as_quad(3);
 sqrt3i = geom_sqrt_as_quad(-3);
 sqrt21 = geom_sqrt_as_quad(21);
 sqrt37 = geom_sqrt_as_quad(37);
 sqrt57 = geom_sqrt_as_quad(57);

gp_inline__location="../terdragon.tex:255";
 w6 = 1/2 + 1/2*sqrt3i;
 w3 = w6^2;
 b = 1 + w6;
 w12_times_sqrt3 = 1+w6;   /* w12 * sqrt(3) */

gp_inline__location="../terdragon.tex:260";
 w3_inexact = (-1 + I*sqrt(3))/2; /* 3rd root of unity */

gp_inline__location="../terdragon.tex:266";
 w6_inexact = (1 + sqrt(3)*I)/2;  /* 6th root of unity */

gp_inline__location="../terdragon.tex:272";
 w12_inexact = (sqrt(3) + I)/2;

gp_inline__location="../terdragon.tex:278";
 z_to_w3(z) = {
   my(y=2*imag(z), x = z-w3*y);
   if(imag(x),error("z_to_w3() oops ",x));
   [x,y];
 }

gp_inline__location="../terdragon.tex:294";
 z_to_w6(z) = {
   my(y=2*imag(z), x = z-w6*y);
   if(imag(x),error("z_to_w6() oops ",x));
   [x,y];
 }

gp_inline__location="../terdragon.tex:300";
 \\      *      height = sqrt(3)/2
 \\     / \     area = 1/2*1*sqrt(3)/2 = sqrt(3)/4
 \\    /   \
 \\   *-----*
 \\      1
 \\ area of an equilateral triangle of unit side
 unit_triangle_area = sqrt3/4;

gp_inline__location="../terdragon.tex:314";
 floor_of_quad(z) = {   \\ for re,im >= 0
   my(disc = z.disc,
      a = numerator(real(z)), b = denominator(real(z)),
      c = numerator(imag(z)), d = denominator(imag(z)),
      bc = b*c);
   (2*a*d + if(disc%4,bc) + sqrtint(bc^2 * disc))
   \ (2*b*d);
 }

gp_inline__location="../terdragon.tex:328";
 select_first_n(f,n) = {
   my(l=List([]), i=0);
   while(#l<n, if(f(i),listput(l,i)); i++);
   Vec(l);
 }

gp_inline__location="../terdragon.tex:334";
 digits_join_high_to_low(v,base=10) = subst(Pol(v),'x,base);
 digits_join_low_to_high(v,base=10) = subst(Polrev(v),'x,base);

gp_inline__location="../terdragon.tex:337";
 \\ n is an integer.  Return an integer whose decimal digits
 \\ are the bits of n.
 to_binary(n)=fromdigits(binary(n))*sign(n);

gp_inline__location="../terdragon.tex:345";
 \\ n is an integer with decimal digits representing bits.
 \\ Return the value of those bits.
 from_binary(n) = fromdigits(digits(n),2);

gp_inline__location="../terdragon.tex:351";
 \\ Return integer whose decimal digits are the ternary digits of n.
 to_ternary(n) = fromdigits(digits(n,3),10);

gp_inline__location="../terdragon.tex:357";
 \\ n is an integer whose decimal digits are in the range 0-2
 \\ and are taken to be ternary.  The return is their value
 \\ in ternary.
 from_ternary(n)=fromdigits(digits(n,10),3);

gp_inline__location="../terdragon.tex:374";
 A081502(n) = 3*(n\10) + (n % 10);  \\ Michel Marcus

gp_inline__location="../terdragon.tex:395";
 \\ n is an integer with decimal digits representing bits.
 \\ Return the value of those bits.
 from_base4(n) = fromdigits(digits(n),4);

gp_inline__location="../terdragon.tex:403";
 \\ n is an integer.  Return an integer whose decimal digits
 \\ are the bits of n.
 to_base4(n)=fromdigits(digits(n,4));

gp_inline__location="../terdragon.tex:412";
 \\ Return integer whose decimal digits are the base-9 digits of n.
 to_base9(n) = fromdigits(digits(n,9),10);

gp_inline__location="../terdragon.tex:417";
 \\ is 2*A116178
 LowestNonOne(n) = {
   n>=0 || error("LowestNonOne() is for n>=0");
   while((n%3)==1,n=n\3); n%3;
 }

gp_inline__location="../terdragon.tex:425";
 A116178(n) = LowestNonOne(n)/2;

gp_inline__location="../terdragon.tex:429";
 \\ number of low 0 digits of n in ternary
 CountLowZeros(n) = {
   n>=0 || error("CountLowZeros() is for n>=1");
   valuation(n,3);
 }

gp_inline__location="../terdragon.tex:435";
 \\ number of low 2 digits of n in ternary
 CountLowTwos(n) = {
   n>=0 || error("CountLowTwos() is for n>=0");
   CountLowZeros(n+1);
 }

gp_inline__location="../terdragon.tex:443";
 \\ Return the number of digits of n in radix equal to "digit".
 count_digits(n,radix,digit) = {
   my(v=digits(n,radix));
   sum(i=1,#v, v[i]==digit);
 }

gp_inline__location="../terdragon.tex:450";
 \\ using floor() since it is an error on quads (and will do the
 \\ right thing in GP 2.13 up) whereas round() silently does nothing
 is_integer(n) = n=simplify(n); n==floor(n);

gp_inline__location="../terdragon.tex:460";
 is_0_or_1(n) = (n==0 || n==1);

gp_inline__location="../terdragon.tex:462";
 \\ Return 1 if x is an integer power of 2, so 2^0, 2^1, etc.
 \\ Return 0 if not.
 is_power_of_2(x) = is_integer(x) && x>=1 && x==2^valuation(x,2);

gp_inline__location="../terdragon.tex:474";
 \\ v is a vector of fractional decimal digits high to low.
 \\ Eg. [1,2,3] is 123/1000 = 0.123
 \\ Return them as a rational like 12981/10^5.
 \\ If v is longer than the current floating point precision(),
 \\ less a little, then use only that much of v.
 \\ "point" is how many digits before the decimal point.
 \\ "add" is an amount to add at the low end of the digits.
 fromdigits_to_precision(v,point=0, add=0) = \
   my(p = precision(1.0) - 4); \
   if(#v>p, v = v[1..p]); \
   (fromdigits(v)+add) / 10^(#v-point);

gp_inline__location="../terdragon.tex:489";
 \\ v is a vector.  Return it with leading 0s added to make its
 \\ equal to k.
 vector_leading_pad0(v,k) = concat(vector(max(0,k-#v)),v);

gp_inline__location="../terdragon.tex:493";
 \\ Like digits() but pad with high 0s to make k many digits.
 \\ Must have n < base^k.
 digits_padded(n,k,base=10) = {
   my(v = digits(n,base));
   if(#v>k, error("digits_padded() n=",n," bigger than k=",k," digits"));
   vector_leading_pad0(v,k);
 }

gp_inline__location="../terdragon.tex:505";
 \\ Return a vector which is vector v repeated n times.
 \\ n=0 gives an empty vector.
 concat_repeat(v,n) = concat(vector(n+1,i,if(i==1,[],v)));

gp_inline__location="../terdragon.tex:511";
 \\ Return element number i from vector v.
 \\ The first element is i=0 and at the end of the vector
 \\ i is taken modulo length(v).
 vector_modulo(v,i) = v[(i% #v)+1];

gp_inline__location="../terdragon.tex:516";
 \\ Return a vector of the first n coefficients of
 \\ generating function g, starting from term x^0.
 \\ g is normally a polynomial fraction (type t_RFRAC)
 \\ but a plain polynomial is accepted too and returns
 \\ its lowest n coefficients.
 gf_terms(g,n) = {
   my(x = variable(g),
      zeros = min(n,valuation(g,x)),
      v = Vec(g + O(x^n)));
   if(zeros>=0, concat(vector(zeros,i,0), v),
                v[-zeros+1 .. #v]);
 }

gp_inline__location="../terdragon.tex:536";
 gf_term(g,n) = gf_terms(g,n+1)[n+1];

gp_inline__location="../terdragon.tex:538";
 \\ n is an integer.  Return is ternary as a vector
 \\ high to low padded with high 0s to make k many digits.
 \\ n must fit within k bits, ie. 0 <= n < 2^k.
 ternary_padded(n,k) = {
   my(v = digits(n,3));
   if(#v>k, error("ternary_padded() n=",n,
                  " is bigger than k=",k," digits"));
   concat(vector(max(0,k-#v)),v);
 }

gp_inline__location="../terdragon.tex:551";
 \\ n is an integer.  Return its bits as a vector high to low
 \\ padded out with high 0s to make k many bits.
 \\ n must fit within k bits, ie. 0 <= n < 2^k.
 binary_padded(n,k) = {
   my(v = binary(n));
   if(#v>k, error("binary_padded() n=",n,
                  " is bigger than k=",k," bits"));
   concat(vector(max(0,k-#v)),v);
 }

gp_inline__location="../terdragon.tex:564";
 \\ Return a vector of digits high to low of n in negaternary,
 \\ so each digit -1,0,1.  n can be negative.
 negaternary_digits(n) = {
   is_integer(n)
     || error("negaternary_digits() is for integer n, got ",n);
   my(l=List([]));
   while(n,
         my(a=n%3);
         if(a==2, a=-1);
         listput(l,a);
         n=(n-a)/3);
   Vecrev(l);
 }

gp_inline__location="../terdragon.tex:589";
 \\ Return the last non-zero element v[i]
 \\ or return 0 if no non-zeros.
 vector_last_non_zero(v) = \
   forstep(i=#v,1,-1, if(v[i],return(v[i]))); \
   0;

gp_inline__location="../terdragon.tex:600";
 vector_differences(v) = \
   if(#v==0,[], vector(#v-1,i,v[i+1]-v[i]));

gp_inline__location="../terdragon.tex:606";
 \\ vector_unique(v) returns the unique elements from vector v.
 \\ Elements are compared with ==.  Elements can be in any order.
 \\ The first of each distinct element is kept for the return,
 \\ and in the original order of v.
 vector_unique(v) = {
   my(seen=List([]), result=List([]));
   for(i=1,#v,
       my(pos=setsearch(seen,v[i],1));  \\ where to insert
       if(pos,
          listinsert(seen,v[i], pos);
          listput(result,v[i])));
   Vec(result);
 }

gp_inline__location="../terdragon.tex:624";
 vector_run_lengths(v) = {
   if(#v==0,return([]));
   my(l=List([]),run=1);
   for(i=2,#v, if(v[i]==v[i-1],run++, listput(l,run);run=1));
   listput(l,run);
   Vec(l);
 }

gp_inline__location="../terdragon.tex:636";
 char_space=Vecsmall(" ")[1];
 \\ str is a string, return it with spaces removed
 str_strip_spaces(str) = \
   Strchr(select(c->c!=char_space,Vec(Vecsmall(str))));

gp_inline__location="../terdragon.tex:642";
 \\ table is a matrix where each row is state transitions.
 \\ So table[state,digit] = new_state.
 \\ Return a vector where v[state] = generating function for how
 \\ many digit strings are in state after k steps.
 \\ initial is the starting state.  The k=0 terms of the gfs are
 \\ 1 in v[initial] and 0 everywhere else.
 state_table_to_gfs(table,initial=1) = {
   my(m=state_table_to_matrix(table), l=matsize(m)[1]);
   Vec(matsolve(matid(l)-m*x,vectorv(l,i,i==initial)));
 }
 state_table_to_matrix(table) = {
   my(l=matsize(table)[1], w=matsize(table)[2], m=matrix(l,l));
   for(i=1,l, for(digit=1,w, m[table[i,digit],i]++));
   m;
 }

gp_inline__location="../terdragon.tex:661";
 rotate_plus120(z) = z*w3;

gp_inline__location="../terdragon.tex:663";
 \\ Return a vector of the successive points of terdragon k.
 \\ This is 3^k+1 points.
 terdragon_points(k) = {
   k>=0 || error("terdragon_points() is for k>=0");
   my(e=1,v=[0]);
   for(i=1,k,
      my(p2 = e*w6);
      v = concat(v,
                 concat(apply(z->e+rotate_plus120(z), v),
                        apply(z->p2+z,                v)));
      e *= b);
   concat(v,[e]);
 }
 terdragon_end(k) = b^k;
 terdragon_centroid(k) = terdragon_end(k)/2;

gp_inline__location="../terdragon.tex:679";
 \\ Return a vector of the successive midpoints of each segment
 \\ in terdragon k.  This is 3^k points.
 terdragon_midpoints(k) = {
   my(e=1,v=[1/2]);
   for(i=1,k,
      my(p2 = e*w6);
      v = concat(v,
                 concat(apply(z->e+rotate_plus120(z), v),
                        apply(z->p2+z,                v)));
      e *= b);
   v;
 }

gp_inline__location="../terdragon.tex:2134";
 \\ A060236
 LowestNonZero(n) = {
   n>=1 || error("LowestNonZero() is for n>=1");
   (n / 3^valuation(n,3)) % 3;
 }

gp_inline__location="../terdragon.tex:2142";
 LowestNonTwo(n) = {
   n>=0 || error("LowestNonTwo() is for n>=0");
   while((n%3)==2,n=n\3); n%3;
 }

gp_inline__location="../terdragon.tex:2149";
 gLowestNonZero_term(x,k) = \
   (x^(3^k) + 2*x^(2*3^k)) / (1 - x^(3^(k+1)));
 gLowestNonZero(x,limit) = sum(k=0,limit, gLowestNonZero_term(x,k));

gp_inline__location="../terdragon.tex:2172";
 turn(n) = {
   if(n<1,error("turn() is only for n>=1"));
   if(LowestNonZero(n)==1, 1, -1);
 }

gp_inline__location="../terdragon.tex:2223";
 LowestNonZero_samples = {[1,2,1,1,2,2,1,2,1,1,2]};

gp_inline__location="../terdragon.tex:2234";
 A060236(n) = LowestNonZero(n);  /* OFFSET=1 */

gp_inline__location="../terdragon.tex:2249";
 next_turn(n) = {
   n>=0 || error("next_turn() is for n>=0");
   if(LowestNonTwo(n)==0, 1, -1);
 }

gp_inline__location="../terdragon.tex:2262";
 LowestNonTwo_samples = {[0,1,0,0,1,1,0,1,0,0,1,0]};

gp_inline__location="../terdragon.tex:2275";
 A080846(n) = {
   n>=1 || error("A080846() is for n>=1");
   LowestNonZero(n) - 1;
 }

gp_inline__location="../terdragon.tex:2287";
 A060032(n) = {
   n>=0 || error();
   if(n==0,1,
        (1 + 10^(2*3^(n-1))) * A060032(n-1)
      + 10^(3^(n-1))         * (A060032(n-1) + 1) );
 }

gp_inline__location="../terdragon.tex:2364";
 n_to_nbits_table = [0,1,3];
 n_to_nbits(n) = {
   fromdigits(apply(d->n_to_nbits_table[d+1], digits(n,3)),
              4);
 }

gp_inline__location="../terdragon.tex:2374";
 nbits_validate(nbits) = {
   #select(d->d==2,digits(nbits,4)) == 0
     || error("invalid nbits = ",nbits);
 }

gp_inline__location="../terdragon.tex:2385";
 turn_of_nbits(nbits) = if(BitAboveLowestOne(nbits)==0,1,-1);

gp_inline__location="../terdragon.tex:2393";
 nbits_increment(nbits) = nbits_PostIncFix(nbits+1);

gp_inline__location="../terdragon.tex:2412";
 nbits_PostIncFix_mask =  /* limited to 16 bits */  \
   fromdigits([0,1,0,1, 0,1,0,1, 0,1,0,1, 0,1,0,1], 2);
 nbits_PostIncFix(n) = {
   n < 2^16 || error("nbits_PostIncFix() too big");
   bitor(n, bitand(nbits_PostIncFix_mask, n\2));
 }

gp_inline__location="../terdragon.tex:2441";
 BitAboveLowestOne(n) = {
   if(n<1, error("BitAboveLowestOne() is for n>=1, got ",n));
   bittest(n, valuation(n,2)+1);
 }
 BitAboveLowestOne_by_mask(n) = \
   if(bitand(n, MaskAboveLowestOne(n)), 1,0);

gp_inline__location="../terdragon.tex:2452";
 BitAboveLowestOne_samples = {[0,0,1,0,0,1,1,0,0,0,1,1,0,1,1,0]};

gp_inline__location="../terdragon.tex:2467";
 MaskAboveLowestOne(n) = 1 + bitxor(n,n-1);

gp_inline__location="../terdragon.tex:2470";
 MaskAboveLowestOne_samples = {[2,4,2,8,2,4,2,16,2,4,2,8,2,4,2,32]};

gp_inline__location="../terdragon.tex:2498";
 TurnLpred(n) = n>=1 && LowestNonZero(n)==1;

gp_inline__location="../terdragon.tex:2502";
 TurnLpred_samples = {[1,0,1,1,0,0,1,0,1,1,0,1,1,0,0,1,0]};

gp_inline__location="../terdragon.tex:2514";
 A137893(n) = {
   n>=1 || error("A137893() is for n>=1");
   TurnLpred(n);
 }

gp_inline__location="../terdragon.tex:2527";
 TurnRpred(n) = n>=1 && LowestNonZero(n)==2;

gp_inline__location="../terdragon.tex:2531";
 TurnRpred_samples = {[0,1,0,0,1,1,0,1,0,0,1,0,0,1,1,0,1]};

gp_inline__location="../terdragon.tex:2581";
 gTurnLpred_term(x,k) = x^(3^k) / (1 - x^(3^(k+1)));
 gTurnLpred(x,k) = sum(j=0,k, gTurnLpred_term(x,j));

gp_inline__location="../terdragon.tex:2590";
 gTurnRpred_term(x,k) = x^(2*3^k) / (1 - x^(3^(k+1)));
 gTurnRpred(x,k) = sum(j=0,k, gTurnRpred_term(x,j));

gp_inline__location="../terdragon.tex:2629";
 gturn_term(x,k) = (x^(3^k) - x^(2*3^k)) / (1 - x^(3^(k+1)));
 gturn_to_k(x,k) = sum(j=0,k, gturn_term(x,j));
 gturn(x) = gturn_to_k(x,6);

gp_inline__location="../terdragon.tex:2638";
 gturnS_term(x,k) = x^(3^k) / (1 + x^(3^k) + x^(2*3^k));
 gturnS(x,k) = sum(j=0,k, gturnS_term(x,j));

gp_inline__location="../terdragon.tex:2682";
 gTurnRpredPart_term(x,k) = x^(3^k) / (1 + x^(3^k) + x^(2*3^k));
 gTurnRpredPart(x,k) = \
   1/2*x/(1-x) - 1/2*sum(j=0,k, gTurnRpredPart_term(x,j));

gp_inline__location="../terdragon.tex:2689";
 gA080846(x,k_limit) = sum(k=0,k_limit, x^(2*3^k) / (1 - x^(3^(k+1))));

gp_inline__location="../terdragon.tex:2742";
 gturn_by_expand(x,k) = gturn_to_k(x^3,k) + x/(1-x^3) - x^2/(1-x^3);
 gturn_by_expand2(x,k) = gturn_to_k(x^3,k) + x/(1+x+x^2);

gp_inline__location="../terdragon.tex:2751";
 turnlimit(k,x) = {
   if(k==0,return(0));
   turnlimit(k-1,x^3) + x/(1+x+x^2);
 }

gp_inline__location="../terdragon.tex:2758";
 turnlimit_term(k,x) = x=x^(3^k); x/(1+x+x^2);

gp_inline__location="../terdragon.tex:2761";
 turnlimit_term_recip(k,x) = x=x^(3^k); (x^2-x)/(x^3-1);

gp_inline__location="../terdragon.tex:2773";
 A189673(n) = {
   n>=1 || error("A189673() is for n>=1");
   TurnLpred(n-1);
 }

gp_inline__location="../terdragon.tex:2780";
 A189673_compact(n) = {
   \\ n--; while(n && n%3==0, n/=3); (n%3)==1;
   n--; (n/3^if(n,valuation(n,3))) % 3 == 1;
 }

gp_inline__location="../terdragon.tex:2828";
 function_run_lengths(f,n) = {
   my(previous=f(1), run=1, v=vector(n), pos=1, i=2);
   while(pos<=#v,
         my(value=f(i));
         if(value==previous,
            run++,
            v[pos]=run; pos++; run=1);
         previous=value; i++);
   v;
 }

gp_inline__location="../terdragon.tex:2839";
 TurnRun_vector(k) = {
   if(k==0,return([]));
   my(prev=turn(1), len=1, l=List([]));
   for(n=2,3^k-1,
       my(t = turn(n));
       if(t==prev, len++,          \\ continue run
          listput(l,len); len=1);  \\ new run
       prev=t);
   listput(l,len);
   Vec(l);
 }
 TurnRun_vector_by_middle(k) = {
   if(k==0,return([]));
   my(v=vector(2*3^(k-1),n, 1));
   forstep(i=2,#v-2,2,
     if(turn(i/2)==1, v[i+1]++,  \\ left, inc prev
                      v[i]++));  \\ right, inc next
   v;
 }

gp_inline__location="../terdragon.tex:2864";
 TurnRun_by_pairs(j) = {
   if(j==0, return(1));
   j++;  \\ to pairs 1,2 etc around turn of prev level
   1 + ((turn(j\2)==1) == (j%2));
 }

gp_inline__location="../terdragon.tex:2890";
 TurnRun(m) = {
   if(m==0,   1,
      m%2==0, 3/2 + 1/2* turn(m/2),
              3/2 - 1/2* turn((m+1)/2));
 }

gp_inline__location="../terdragon.tex:2908";
 TurnRun_by_ceil(m) = \
   if(m==0, 1,  3/2 + 1/2 * (-1)^m * turn(ceil(m/2)));

gp_inline__location="../terdragon.tex:2913";
 TurnRun_samples = {[1,1,2,2,1,1,2,1,2,2,1,2,1,1,2]};

gp_inline__location="../terdragon.tex:2935";
 turn_samples_2 = {[+1,-1,+1,+1,-1,-1,+1]};

gp_inline__location="../terdragon.tex:2955";
 gTurnRun_by_gturn(x) = \
   -1/2 + 3/2/(1-x) + 1/2*(1-1/x)*gturn(x^2);

gp_inline__location="../terdragon.tex:2964";
 TurnRun_by_Lpred(m) = {
   if(m==0,   1,
      m%2==0, 1 + TurnLpred(m/2),
              2 - TurnLpred((m+1)/2));
 }

gp_inline__location="../terdragon.tex:2972";
 TurnRun_by_Rpred(m) = {
   if(m==0,   1,
      m%2==0, 2 - TurnRpred(m/2),
              1 + TurnRpred((m+1)/2));
 }

gp_inline__location="../terdragon.tex:2996";
 TurnRunStart_by_sum(m) = 1 + sum(i=0,m-1, TurnRun(i));

gp_inline__location="../terdragon.tex:3009";
 TurnRunStart(m) = \
   3*m/2 + if(m%2==0,1-TurnLpred(3*m/2),1/2);

gp_inline__location="../terdragon.tex:3012";
 TurnRunSpred(n) = if(n==1 || turn(n)!=turn(n-1), 1, 0);
 TurnRunStart_by_pred(m) = \
   my(n=0); while(m>=0, n++; if(TurnRunSpred(n),m--)); n;

gp_inline__location="../terdragon.tex:3034";
 TurnRunStart_samples = {[1,2,3,5,7,8,9,11,12,14,16,17,19]};

gp_inline__location="../terdragon.tex:3109";
 dNextL_state_table = {[1,2,1; 1,3,2; 1,3,2]};
 dNextR_state_table = {[2,1,1; 2,1,3; 2,1,3]};
 dNextLsub1_d1 = 1;
 dNextLsub1_d1b = 2;
 dNextLsub1_d2 = 3;
 dNextLsub1_d2b = 4;
 dNextLsub1_d3 = 5;
 dNextLsub1_start_state = 3;
 dNextLsub1_state_table = {[3,2,1; 5,4,2; 3,2,1; 5,4,2; 3,2,1]};
 dNextLsub1_state_to_d = {[1,1,2,2,3]};

gp_inline__location="../terdragon.tex:3151";
 dNextL(n) = {
   n>=0 || error("dNextL() is for n>=0");
   if(n%3==0, 1,
      n%3==1, if(LowestNonTwo(n\3)==0, 2, 3),
      n%3==2, if(LowestNonTwo(n\3)==0, 1, 2),
      error());
 }
 dNextL_by_search(n) = {
   for(d=1,3, if(TurnLpred(n+d),return(d)));
   error();
 }

gp_inline__location="../terdragon.tex:3206";
 dNextR(n) = {
   n>=0 || error("dNextR() is for n>=0");
   if(n%3==0, 2,
      if(LowestNonTwo(n)==0, 3, 1));
 }
 dNextR_by_search(n) = {
   for(d=1,3, if(TurnRpred(n+d),return(d)));
   error();
 }

gp_inline__location="../terdragon.tex:3243";
 dNextL_samples = {[1,2,1,1,3,2,1,2,1,1,2,1,1,3,2,1]};

gp_inline__location="../terdragon.tex:3256";
 dNextR_samples = {[2,1,3,2,1,1,2,1,3,2,1,3,2,1,1,2]};

gp_inline__location="../terdragon.tex:3380";
 dNextL_transition(state,digit) = \
   dNextL_state_table[state,digit+1];
 dNextL_transitions(state,v) = \
   for(i=1,#v, state=dNextL_transition(state,v[i])); state;
 dNextL_by_high_to_low(n) = \
   dNextL_transitions(1,digits(n,3));

gp_inline__location="../terdragon.tex:3426";
 dNextL_LtoH_state_table = {[ 4,3,2;     \\ 1 = start
                              4,5,2;     \\ 2 = +1
                              5,6,3;     \\ 3 = +2
                              4,4,4;     \\ 4 = end 1
                              5,5,5;     \\ 5 = end 2
                              6,6,6 ]};  \\ 6 = end 3
 dNextL_LtoH_transition(state,digit) = \
   dNextL_LtoH_state_table[state,digit+1];
 dNextL_LtoH_transitions(state,v) = \
   for(i=1,#v, state=dNextL_LtoH_transition(state,v[i])); state;
 dNextL_LtoH_state_to_d = [1,1,2, 1,2,3];
 dNextL_LtoH_state(n) = \
   dNextL_LtoH_transitions(1, Vecrev(digits(n,3)));
 dNextL_by_LtoH(n) = \
   dNextL_LtoH_state_to_d[dNextL_LtoH_state(n)];

gp_inline__location="../terdragon.tex:3590";
 dNextR_transition(state,digit) = \
   dNextR_state_table[state,digit+1];
 dNextR_transitions(state,v) = \
   for(i=1,#v, state=dNextR_transition(state,v[i])); state;
 dNextR_by_high_to_low(n) = \
   dNextR_transitions(2, digits(n,3));

gp_inline__location="../terdragon.tex:3636";
 dNextR_LtoH_state_table = {[ 4,3,2;     \\ 1 = +2
                              5,3,2;     \\ 2 = +3
                              3,3,3;     \\ 3 = end 1
                              4,4,4;     \\ 4 = end 2
                              5,5,5 ]};  \\ 5 = end 3
 dNextR_LtoH_transition(state,digit) = \
   dNextR_LtoH_state_table[state,digit+1];
 dNextR_LtoH_transitions(state,v) = \
   for(i=1,#v, state=dNextR_LtoH_transition(state,v[i])); state;
 dNextR_LtoH_state_to_d = [2,3, 1,2,3];
 dNextR_LtoH_state(n) = \
   dNextR_LtoH_transitions(1, Vecrev(digits(n,3)));
 dNextR_by_LtoH(n) = \
   dNextR_LtoH_state_to_d[dNextR_LtoH_state(n)];

gp_inline__location="../terdragon.tex:3875";
 gdNextL_by_TurnRpred(x,limit) = {
   (1 + 2*x + x^2)/(1 - x^3)
   + (1/x + 1/x^2)*gTurnRpred(x^3,limit-1);
 }

gp_inline__location="../terdragon.tex:3897";
 gdNextL_by_sum(x,limit) = {
   (1+x)
   *( (1+x)/(1-x^3)
      + 1/x^2 * sum(k=1,limit, x^(2*3^k) / (1 - x^(3^(k+1)))) );
 }

gp_inline__location="../terdragon.tex:3913";
 gdNextR_by_turn(x,k) = \
   (2 + x + 2*x^2)/(1 - x^3) + 1/x * gturn_to_k(x^3,k);

gp_inline__location="../terdragon.tex:3926";
 gdNextR_by_sum(x,limit) = {
   (2 + x + 2*x^2)/(1 - x^3)
   + sum(k=1,limit, x^(3^k-1) / (1 + x^(3^k) + x^(2*3^k)));
 }

gp_inline__location="../terdragon.tex:3954";
 slnz(n) = {
   if(n%3==0, 1,
      n%3==1, LowestNonZero(n+2),
      n%3==2, 0,
      error());
 }

gp_inline__location="../terdragon.tex:3964";
 slnz_samples = {[1,1,0,1,2,0,1,1,0,1,1,0,1,2,0,1,2,0]};

gp_inline__location="../terdragon.tex:3988";
 gslnz(x,len) = sum(n=0,len-1, slnz(n) * x^n);

gp_inline__location="../terdragon.tex:4091";
 TurnLeft_by_pred(m) = {
   m>=0 || error("TurnLeft_by_pred() is for m>=0, got m=",m);
   my(n=0); while(m>=0, n++;m-=TurnLpred(n)); n;
 }
 TurnRight_by_pred(m) = {
   m>=0 || error("TurnRight_by_pred() is for m>=0, got m=",m);
   my(n=0); while(m>=0, n++;m-=TurnRpred(n)); n;
 }

gp_inline__location="../terdragon.tex:4129";
 TurnLeft_k(m) = {
   m>=1 || error("TurnLeft_k() is for m>=1");
   my(ret='oops);
   for(k=0,m, if(1/2*(3^k+1)<=m,
     ret=k,   \\ still below
     break)); \\ not below, stop
   ret;
 }
 TurnLeft(m) = {
   my(debug=0);
   m>=0 || error("TurnLeft() is for m>=0, got m=",m);
   if(m==0,return(1));
   my(k=TurnLeft_k(m));
   if(m<3^k,
        if(debug,print("k="k" above ",(3^k+1)/2,
                       " first half rem ",(m - 1/2*(3^k+1))));
        3^k   + TurnLeft(m - 1/2*(3^k + 1)),
      m>=3^k,
        if(debug,print("k="k" above ",(3^k - 1)/2,
                       " second half rem ",(m - 3^k)));
        2*3^k + TurnLeft(m - 3^k),
      error("oops"));
 }

gp_inline__location="../terdragon.tex:4165";
 TurnLeft_samples = {[1,3,4,7,9,10,12,13,16,19,21,22]};

gp_inline__location="../terdragon.tex:4177";
A026225(n) = {
  n>=1 || error("A026225() is for n>=1");
  TurnLeft(n-1);
}

gp_inline__location="../terdragon.tex:4214";
 TurnRight(m) = {
   my(debug=0);
   m>=0 || error("TurnRight() is for m>=0, got m=",m);
   my(k=0,t=0);
   while(1,if(1/2*(3^t-1)<=m, k=t;t++, break()));
   if(m<3^k-1,
        if(debug,print("k="k" above ",(3^k-1)/2,
                         " first half rem ",(m - 1/2*(3^k-1))));
        3^k   + TurnRight(m - 1/2*(3^k-1)),
      m==3^k-1,
        2*3^k,
      m>=3^k,
        if(debug,print("k="k" above ",(3^k-1)/2,
                         " second half rem ",(m - 3^k)));
        2*3^k + TurnRight(m - 3^k),
      error("oops"));
 }

gp_inline__location="../terdragon.tex:4239";
 TurnRight_samples = {[2,5,6,8,11,14,15,17,18,20,23,24]};

gp_inline__location="../terdragon.tex:4252";
 A026179(n) = {
   n>=1 || error("A026179() is for n>=1, got n=",n);
   if(n==1,1, TurnRight(n-2));
 }

gp_inline__location="../terdragon.tex:4388";
 TurnLeft_min_m_of_k(k) = {
   k>=0 || error();
   1/2*(3^k + 1);
 }

gp_inline__location="../terdragon.tex:4396";
 TurnLeft_max_m_of_k(k) = {
   k>=0 || error("TurnLeft_max_m_of_k() is for k>=0");
   1/2*(3^(k+1) - 1);
 }

gp_inline__location="../terdragon.tex:4403";
 TurnLeft_max_m_of_k_part1(k) = 3^k - 1;

gp_inline__location="../terdragon.tex:4543";
 \\ Return ternary digit at pos in integer n.
 \\ pos=0 is the least significant digit.
 ternary_digit(n,pos) = (n\3^pos) % 3;

gp_inline__location="../terdragon.tex:4576";
 TurnLeft_by_digits(m) = {
   my(n=2*m);     \\ or 2*m+1 same
   forstep(pos=if(n,logint(n,3)),0,-1,   \\ high to low
     if(ternary_digit(n,pos)==1, n--));
   n+1;
 }

gp_inline__location="../terdragon.tex:4614";
 TurnRight_by_digits(m) = {
   my(n=2*m+2);     \\ or 2*m+1 same
   forstep(pos=if(n,logint(n,3)),0,-1,   \\ high to low
     if(ternary_digit(n,pos)==1, n++));
   n;
 }

gp_inline__location="../terdragon.tex:4661";
 TurnLeft2(p) = {
   p>=0 || error("TurnLeft2() is for p>=0, got p=",p);
   p%2==0 || error("TurnLeft2() is for p even p=",p);
   if(p==0,return(1));
   my(k,t=0);  \\ k biggest satisfying
   while(1,if(3^t+1<=p, k=t;t++, break()));
      3^k+1 <= p || error();
   !( 3^(k+1)+1 <= p ) || error();
      3^k <= p || error();
   !( 3^(k+1) <= p ) || error();
   if(p<2*3^k,
        3^k   + TurnLeft2(p - 3^k - 1),
      p>=3^k,
        2*3^k + TurnLeft2(p - 2*3^k),
      error("oops"));
 }

gp_inline__location="../terdragon.tex:4768";
 TurnRight2(p) = {
   p>=2 || error("TurnRight2() is for p>=2, got p=",p);
   p%2==0 || error("TurnRight2() is for p even p=",p);
   my(k,t=0);  \\ k biggest satisfying
   while(1,if(3^t+1<=p, k=t;t++, break()));
      3^k+1 <= p || error();
   !( 3^(k+1)+1 <= p ) || error();
   if(p <  2*3^k,  3^k   + TurnRight2(p - 3^k + 1),
      p == 2*3^k,  2*3^k,
      p >  2*3^k,  2*3^k + TurnRight2(p - 2*3^k),
      error("oops, no case for p=",p));
 }

gp_inline__location="../terdragon.tex:4821";
 nbits_to_n_table = [0,1,'oops,2];
 nbits_to_n(n) = {
   fromdigits(apply(d->nbits_to_n_table[d+1], digits(n,4)),
              3);
 }

gp_inline__location="../terdragon.tex:4829";
 TurnRight_by_nbits(m) = {
   my(nbits=n_to_nbits(2*m+2));
   forstep(i=if(nbits,logint(nbits,4)),0,-1,
     if(bittest(nbits,2*i+1)==0 && bittest(nbits,2*i)==1,
       nbits=nbits_increment(nbits)));
   nbits_to_n(nbits);
 }

gp_inline__location="../terdragon.tex:4840";
 nbits_PostDecFix_mask = /* limited to 16 bits */  \
   fromdigits([0,1,0,1, 0,1,0,1, 0,1,0,1, 0,1,0,1],2);
 nbits_PostDecFix(n) = {
   n < 2^16 || error("nbits_PostDecFix() too big");
   n - bitand(bitand(n\2,bitneg(n)), nbits_PostDecFix_mask);
 }

gp_inline__location="../terdragon.tex:4854";
 nbits_decrement(nbits) = nbits_PostDecFix(nbits-1);

gp_inline__location="../terdragon.tex:4858";
 TurnLeft_by_nbits(m) = {
   my(nbits=n_to_nbits(2*m));
   forstep(i=if(nbits,logint(nbits,4)),0,-1,
     if(bittest(nbits,2*i+1)==0 && bittest(nbits,2*i)==1,
       nbits=nbits_decrement(nbits)));
   nbits_to_n(nbits) + 1;
 }

gp_inline__location="../terdragon.tex:4869";
 n_to_n2bits_table = [0,2,3];
 n_to_n2bits(n) = {
   fromdigits(apply(d->n_to_n2bits_table[d+1], digits(n,3)),
              4);
 }

gp_inline__location="../terdragon.tex:4877";
 n2bits_validate(n2bits) = {
   #select(d->d==1,digits(n2bits,4)) == 0
     || error("invalid n2bits = ",n2bits);
 }

gp_inline__location="../terdragon.tex:4883";
 n2bits_PostDecFix_mask = /* limited to 16 bits */  \
   fromdigits([0,1,0,1, 0,1,0,1, 0,1,0,1, 0,1,0,1],2);
 n2bits_PostDecFix(n) = {
   n < 2^16 || error("n2bits_PostDecFix() too big");
   bitand(n, bitneg(bitand(n2bits_PostDecFix_mask, bitneg(n\2))));
 }

gp_inline__location="../terdragon.tex:4904";
 n2bits_decrement(n2bits) = n2bits_PostDecFix(n2bits-1);

gp_inline__location="../terdragon.tex:4908";
 n2bits_to_n_table = [0,'oops,1,2];
 n2bits_to_n(n) = {
   fromdigits(apply(d->n2bits_to_n_table[d+1], digits(n,4)),
              3);
 }

gp_inline__location="../terdragon.tex:4916";
 TurnLeft_by_n2bits(m) = {
   my(n2bits=n_to_n2bits(2*m));
   forstep(i=if(n2bits,logint(n2bits,4)),0,-1,
     if(bittest(n2bits,2*i+1)==1 && bittest(n2bits,2*i)==0,
       n2bits=n2bits_decrement(n2bits)));
   n2bits_to_n(n2bits) + 1;
 }

gp_inline__location="../terdragon.tex:4937";
 unones(m,incr,low=0) = {
   forstep(pos=if(m,logint(m,3)),low,-1, \\ high to low
     if(ternary_digit(m,pos)==1, m+=incr));
   m;
 }

gp_inline__location="../terdragon.tex:4975";
 \\ explicit loop to propagate borrow in ternary digits
 TurnLeft_by_vec(m) = {
   my(v=digits(2*m,3));
   for(i=1,#v,
     if(v[i]==1,
       forstep(j=#v,i+1,-1, if(v[j]-->=0,break); v[j]=2)));
   fromdigits(v,3) + 1;
 }

gp_inline__location="../terdragon.tex:4987";
 \\ explicit loop to propagate carry in ternary digits
 TurnRight_by_vec(m) = {
   my(v=digits(2*m+2,3));
   for(i=1,#v, if(v[i]==1,
     forstep(j=#v,i+1,-1, if(v[j]++<3,break,v[j]=0))));
   fromdigits(v,3);
 }

gp_inline__location="../terdragon.tex:4998";
 \\ A026225 TurnLeft lowest non-0 is 1
 { A026225_compact(n) = n=2*n-2; my(v=digits(n,3));
   for(i=1,#v, if(v[i]==1,
     n--; forstep(j=#v,i+1,-1, if(v[j]--<0,v[j]=2,break))));
   n+1; }

gp_inline__location="../terdragon.tex:5006";
       \\ print("i="i" "v[i]"  "v);
 A026179_compact(n) = {
   if(n>1, n=2*n-2; my(v=digits(n,3));
     for(i=1,#v, if(v[i]==1,
       n++; forstep(j=#v,i,-1, if(v[j]++>2,v[j]=0,break)))));
   n; }
 { my(one=Mod(1,3)); A026179_compactM(n) =
   if(n>1, n=2*n-2; my(v=digits(n,3));
     for(i=1,#v, if(v[i]==1,
       n++; forstep(j=#v,i,-1, if(v[j]+=one,break)))));
   n; }

gp_inline__location="../terdragon.tex:5023";
     \\ print(to_binary(n)" "to_binary(b)" mask "to_binary(m));
       \\ print("  k="k"  "bittest(b,k+1),bittest(b,k)"  n="n);
 A026179_by_nbits(n) = {
   if(n==1,1, n=2*n-2;
     my(v=digits(n,3), b=fromdigits(v,4), k=2*#v, m=1<<k\3);
     while((k-=2)>=0, b=bitor(b,bitand(b>>1,m));
       if(bittest(b,k+1)!=bittest(b,k), n++;b++));
     n);
 }

gp_inline__location="../terdragon.tex:5042";
 A026179_k(n) = {
   n>=2 || error();
   my(k='undef, t=0);
   while((3^t-1)/2 <= n-2, k=t; t++);
   k;
 }

gp_inline__location="../terdragon.tex:5058";
 A189641(n) = {   \\ TurnsR(n-1)
   n>=1 || error("A189641() is for n>=1, got n=",n);
   n--; (n-vecsum(digits(n,3)%2))/2;
 }

gp_inline__location="../terdragon.tex:5065";
 A189672(n) = {   \\ TurnsR(n)
   n>=1 || error("A189672() is for n>=1, got n=",n);
   (n-vecsum(digits(n,3)%2))/2;
 }

gp_inline__location="../terdragon.tex:5089";
 ternary_insert_above_0s(n,d) = {
   my(k=if(n,valuation(n,3)));
   3*n + d*3^k;
 }

gp_inline__location="../terdragon.tex:5120";
 TurnLeftOff(m) = 2*m - TurnLeft(m);

gp_inline__location="../terdragon.tex:5122";
 TurnLeftOff_samples = {[-1,-1,0,-1,-1,0,0,1,0,-1,-1,0,-1,-1]};

gp_inline__location="../terdragon.tex:5139";
 TurnRightOff(m) = TurnRight(m) - 2*m;

gp_inline__location="../terdragon.tex:5141";
 TurnRightOff_samples = {[2,3,2,2,3,4,3,3,2,2,3,2,2,3]};

gp_inline__location="../terdragon.tex:5158";
 TurnRightOff_by_digits(m) = {
   m>=0 || error("TurnRightOff_by_digits() is for m>=0");
   my(k=#digits(m,3));
   if(m==3^k-1,
      2,
      m>=(3^k-1)/2,
      TurnRightOff(m-(3^k-1)/2) + 1
      ,
      TurnRightOff(m-3^(k-1)) + 0
      );
 }

gp_inline__location="../terdragon.tex:5196";
 TurnLeftOff_by_recurrence(m) = {
   if(m==0,return(-1));
   my(k,t=0);
   while(1,if(m>=1/2*(3^t+1), k=t;t++, break()));
   if(m<3^k,  TurnLeftOff(m - 1/2*(3^k+1)) + 1,
      m>=3^k, TurnLeftOff(m - 3^k),
      error("oops"));
 }

gp_inline__location="../terdragon.tex:5224";
 TurnRightOff_by_recurrence(m) = {
   m>=0 || error("TurnRightOff_by_recurrence() is for m>=0");
   my(k=0,t=0);
   while(1,if(m>=1/2*(3^t-1), k=t;t++, break()));
   if(m <  3^k-1,  TurnRightOff(m - 1/2*(3^k-1)) + 1,
      m == 3^k-1,  2,
      m >  3^k-1,  TurnRightOff(m - 3^k),
      error("oops"));
 }

gp_inline__location="../terdragon.tex:5267";
 LR_filling(len,func) = {
   my(v=vector(len));
   v[1]=1;
   for(n=2,2*len,
       my(h=func(n), L=n-h, R=n+h);
       if(L<=#v&&v[L]==0,v[L]=n,
          R<=#v,         v[R]=n));
   v;
 }

gp_inline__location="../terdragon.tex:5277";
 vector_new_highs(v) = {
   my(m=v[1]-1,l=List());
   for(i=1,#v, if(v[i]>m, listput(l,v[i]); m=v[i]));
   Vec(l);
 }
 vector_new_highindexes(v) = {
   my(m=v[1]-1,l=List());
   for(i=1,#v, if(v[i]>m, listput(l,i); m=v[i]));
   Vec(l);
 }
 vector_new_highs_from_func(len,func) = {
   for(l=1,99999,
       my(v=vector_new_highs(func(2^l)));
       if(#v>=len, return(v[1..len])));
 }
 vector_new_highindexes_from_func(len,func) = {
   for(l=1,99999,
       my(v=vector_new_highindexes(func(2^l)));
       if(#v>=len, return(v[1..len])));
 }

gp_inline__location="../terdragon.tex:5298";
 \\ per Neil Sloane's recursion in A131989
 A131989(n) = {
   my(t=0,p);
   if(n<1,error("A131989() is for n>=1, got ",n));
   if(n==1,return(2));
   while(1,p=(3^(t-1)-1)/2; if(p<n && n<=(3^t-1)/2, break(), t++));
   \\ print(t" "p);
   if(n==(3^(t-1)+1)/2,3,
      n==3^(t-1),1,
      A131989(if(n<3^(t-1),n-p,n-3^(t-1))));
 }

gp_inline__location="../terdragon.tex:5315";
 dTurnLeft(m) = TurnLeft(m+1) - TurnLeft(m);

gp_inline__location="../terdragon.tex:5322";
 dTurnLeft_samples = {[2,1,3,2,1,2,1,3,3,2,1,3,2,1,2,1,3]};

gp_inline__location="../terdragon.tex:5345";
 A026166_vec(len) = LR_filling(len,n->floor((n-1)/2));

gp_inline__location="../terdragon.tex:5351";
 A026169_vec(len) = vector_new_highs_from_func(len,A026166_vec);

gp_inline__location="../terdragon.tex:5357";
 A026171_vec(len) = vector_differences(A026169_vec(len+2)[^1])/2;

gp_inline__location="../terdragon.tex:5366";
 A026136_vec(len) = LR_filling(len,n->ceil((n-1)/2));

gp_inline__location="../terdragon.tex:5373";
 A026139_vec(len) = vector_new_highs_from_func(len,A026136_vec);

gp_inline__location="../terdragon.tex:5379";
 A026141_vec(len) =  vector_differences(A026139_vec(len+1))/2;

gp_inline__location="../terdragon.tex:5386";
 A026138_vec(len)=vector_new_highindexes_from_func(len,A026136_vec);

gp_inline__location="../terdragon.tex:5395";
 A026172_vec(len) = LR_filling(len,n->floor(n/2));

gp_inline__location="../terdragon.tex:5401";
 A026175_vec(len) = vector_new_highs_from_func(len,A026172_vec);

gp_inline__location="../terdragon.tex:5407";
 A026176_vec(len) =  vector_differences(A026175_vec(len+1))/2;

gp_inline__location="../terdragon.tex:5420";
 dTurnRight(m) = TurnRight(m+1) - TurnRight(m);

gp_inline__location="../terdragon.tex:5427";
 dTurnRight_samples = {[3,1,2,3,3,1,2,1,2,3,1,2,3,3,1,2,3]};

gp_inline__location="../terdragon.tex:5482";
 dTurnLeft_by_recurrence(m) = {
   m>=0 || error("dTurnLeft_by_recurrence() is for m>=0");
   if(m==0,return(2));
   if(m==1,return(1));
   my(k,t=0);
   while(1,if(m>=1/2*(3^t+1), k=t;t++, break()));
   if(!(k>=1),error("oops"));
   if(m<3^k-1,  dTurnLeft(m - 1/2*(3^k+1)),
      m==3^k-1, 3,
      m>=3^k,   dTurnLeft(m - 3^k),
      error("oops"));
 }

gp_inline__location="../terdragon.tex:5516";
 dTurnRight_by_recurrence(m) = {
   m>=0 || error("dTurnRight_by_recurrence() is for m>=0");
   if(m==0,return(3));
   my(k=0,t=0);
   while(1,if(m>=1/2*(3^t-1), k=t;t++, break()));
   if(!(k>=1),error("oops"));
   if(m<3^k-2,  dTurnRight(m - 1/2*(3^k-1)),
      m==3^k-2, 1,
      m==3^k-1, 2,
      m>=3^k,   dTurnRight(m - 3^k),
      error("oops"));
 }

gp_inline__location="../terdragon.tex:5559";
 \\ Return a vector of the first n many terms of A133162.
 \\ Calculation is by its defining symbol substitution
 \\ (done enough times to get n terms).
 A133162_vector(len) = {
   my(v=[1]);
   while(#v<len,
         v=concat(apply(e->if(e==1,[1,1,2,1],
                              e==2,[2],
                              error("oops")),v)));
   v[1..len];
 }

gp_inline__location="../terdragon.tex:5587";
 A131989_displayed_samples = {[2,3,1,2,3,3,1,2,1,2]};

gp_inline__location="../terdragon.tex:5665";
 \\ Recurrence calculation per Sloane in A133162, starting at n=1
 \\ per the offset in that sequence.
 A133162(n) = {
   my(t=0,p);
   if(n<1,error("A133162() is for n>=1, got ",n));
   if(n==1,return(1));
   while(1,p=(3^t-1)/2; if(p<n && n<=(3^(t+1)-1)/2, break(), t++));
   \\ print(t" "p);
   if(n==3^t,2, A133162(if(n<3^t, n-p, n-2*p-1)));
 }

gp_inline__location="../terdragon.tex:5678";
 \\ v is a vector.
 \\ Return a vector of the run lengths of 1s in v.
 run_lengths_of_1s(v) = {
   my(l=List(),len=0);
   for(i=1,#v,
       if(v[i]==1, len++, listput(l,len);len=0));
   if(len,listput(l,len));
   Vec(l);
 }

gp_inline__location="../terdragon.tex:5694";
 dTurnRight_by_loop(m) = {
   m>=0 || error();
   my(T=3^if(m,1+logint(m,3)));
   while(m>=2,
     T>=3 || error("T too small");
     m > 0 || error("negative ",m);
     (3*T-1)/2 > m || error("m too big ",m);
     if(m<(T-1)/2, ,
        m<T-2,  m-=(T-1)/2,
        m==T-2, return(1),
        m==T-1, return(2),
        m>=T,   m-=T);
     T/=3);
   if(m==0,3,1);
 }

gp_inline__location="../terdragon.tex:5712";
 A131989_by_loop(n) = {
   n>=1 || error();
   my(T=3^(1+logint(n,3)));
   while(n>=4,
     T>=3 || error("T too small");
     (3*T-1)/2 > n-2 || error("n too big ",n);
     if(n>=(T+3)/2,
        if(n<T, n-=(T-1)/2,
                n-=T; if(n<=1,return(n+1))));
     T/=3);
   [2,3,1][n];
 }

gp_inline__location="../terdragon.tex:5727";
 dTurnRight2(p) = {
   p>=2 || error("dTurnRight2() is for p>=2, got p=",p);
   p%2==0 || error("dTurnRight2() is for p even p=",p);
   if(p==2,return(3));
   my(k,t=0);  \\ k biggest satisfying
   while(1,if(3^t<=p, k=t;t++, break()));
      3^k+1 <= p || error();
   !( 3^(k+1)+1 <= p ) || error();
   if(p<2*3^k-2,   dTurnRight2(p - 3^k + 1), \\ 1.. not 2221
      p==2*3^k-2,  1,      \\ 122221
      p==2*3^k,    2,      \\ 200000
      p>2*3^k,     dTurnRight2(p - 2*3^k),
      error("oops, no case for p=",p));
 }

gp_inline__location="../terdragon.tex:5744";
 \\ explicit loop to propagate carry in ternary digits
 dTurnRight_by_vec(m) = {
   my(debug=0);
   my(v=digits(2*m+2,3), zeros=0, twos=0, i=1);
   while(i<#v,
     if(debug, print("i="i"  "v" twos="twos" zeros="zeros));
     if(v[i]==1,
       if(debug, print("  increment"));
       forstep(j=#v,i+1,-1, if(v[j]++<3,break,v[j]=0));
       twos=1;      \\ 12222 after increment
       ,
       v[i]==2,
       zeros=1;     \\ 20000 after increment
       );
     i++;
     if(v[i]!=0&&zeros&&debug, print("not zero"));
     if(v[i]!=2&&twos&&debug, print("not two"));
     if(v[i]!=0, zeros=0);
     if(v[i]!=2, twos=0);
   );
   if(debug, print("final "v" twos="twos" zeros="zeros));
   if(twos,1, zeros,2, 3);
 }

gp_inline__location="../terdragon.tex:5774";
 A131989_xy(n) = {
   if(n==1,return(2));
   my(v=digits(2*n-2,3), y=0, x=0, i=1);
   while(i<#v,
     if(v[i]==1, x=1; forstep(j=#v,i,-1, if(v[j]++<3,break,v[j]=0)),
        v[i]==2, y=1);
     i++; if(v[i]!=2,x=0); if(v[i]!=0,y=0));
   if(x,1, y,2, 3);
 }

gp_inline__location="../terdragon.tex:5822";
 A131989_expand = {[ [2,1],
                     [2,3,1],
                     [2,3,3,1] ]};
 A131989_vec_by_morphism(len) = {
   my(v=[2]);
   while(#v<len, v=concat(apply(d->A131989_expand[d],v)));
   v[1..len];
 }

gp_inline__location="../terdragon.tex:6037";
 dTurnLeft_expand_21 = {[2,1,3,2,1]};

gp_inline__location="../terdragon.tex:6043";
 dTurnLeft_expand_3 = {[2,1,3,3]};

gp_inline__location="../terdragon.tex:6049";
 dTurnLeft_expand_table = {[ [],
                             dTurnLeft_expand_21,
                             dTurnLeft_expand_3 ]};
 dTurnLeft_vec(len) = {
   my(v=[3]);
   while(#v<len, v=concat(apply(d->dTurnLeft_expand_table[d],v)));
   v[1..len];
 }

gp_inline__location="../terdragon.tex:6063";
 dTurnRight_expand_3 = {[3,1,2,3]};

gp_inline__location="../terdragon.tex:6069";
 dTurnRight_expand_12 = {[3,1,2,1,2]};

gp_inline__location="../terdragon.tex:6075";
 dTurnRight_expand_table = {[dTurnRight_expand_12,
                             [],
                             dTurnRight_expand_3 ]};
 dTurnRight_vec(len) = {
   my(v=[3]);
   while(#v<len, v=concat(apply(d->dTurnRight_expand_table[d],v)));
   v[1..len];
 }

gp_inline__location="../terdragon.tex:6093";
 dTurnLeft_expand_split_1 = {[1]};

gp_inline__location="../terdragon.tex:6099";
 dTurnLeft_expand_split_2 = {[2,1,3,2]};

gp_inline__location="../terdragon.tex:6105";
 dTurnLeft_expand_split_3 = {[2,1,3,3]};

gp_inline__location="../terdragon.tex:6111";
 dTurnLeft_expand_split_table = {[ dTurnLeft_expand_split_1,
                                   dTurnLeft_expand_split_2,
                                   dTurnLeft_expand_split_3 ]};
 dTurnLeft_vec_by_split(len) = {
   my(v=[2]);
   while(#v<len,
     v=concat(apply(d->dTurnLeft_expand_split_table[d],v)));
   v[1..len];
 }

gp_inline__location="../terdragon.tex:6126";
 dTurnRight_expand_split_1 = {[3,1,2,1]};

gp_inline__location="../terdragon.tex:6132";
 dTurnRight_expand_split_2 = {[2]};

gp_inline__location="../terdragon.tex:6138";
 dTurnRight_expand_split_3 = {[3,1,2,3]};

gp_inline__location="../terdragon.tex:6144";
 dTurnRight_expand_split_table = {[ dTurnRight_expand_split_1,
                                    dTurnRight_expand_split_2,
                                    dTurnRight_expand_split_3 ]};
 dTurnRight_vec_by_split(len) = {
   my(v=[3]);
   while(#v<len,
     v=concat(apply(d->dTurnRight_expand_split_table[d],v)));
   v[1..len];
 }

gp_inline__location="../terdragon.tex:6232";
 dTurnLeft_by_procedure(m) = {
   m>=0 || error("dTurnLeft_by_procedure() is for m>=0, got m=",m);
   my(n=2*m, d=2);
   forstep(pos=if(n,logint(n,3),-1),0,-1,   \\ high to low
     my(digit=ternary_digit(n,pos));
     \\ print("at d="d" digit "digit);
     if(digit==0,         if(d==0,d=3,d=2),
        digit==1,         d=0; n--,
        digit==2 && d!=0, d=1));
   d;
 }

gp_inline__location="../terdragon.tex:6278";
 dNextLsub1_transition(state,digit) = \
   dNextLsub1_state_table[state,digit+1];
 dNextLsub1_transitions(state,v) = \
   for(i=1,#v, state=dNextLsub1_transition(state,v[i])); state;
 dNextLsub1_high_to_low_state(n) = \
   dNextLsub1_transitions(dNextLsub1_start_state, digits(n,3));
 dNextLsub1_by_high_to_low(n) = \
   dNextLsub1_state_to_d[dNextLsub1_high_to_low_state(n)];

gp_inline__location="../terdragon.tex:6514";
 dTurnRight_by_procedure(m) = {
   m>=0 || error("dTurnRight_by_procedure() is for m>=0, got m=",m);
   my(n=2*m+2, d=2);
   forstep(pos=logint(n,3),0,-1,   \\ high to low
     my(digit=ternary_digit(n,pos));
     if(digit==0,         d=2,
        digit==1,         d=1; n++,
        digit==2 && d==2, d=3));
   d;
 }

gp_inline__location="../terdragon.tex:6583";
 { my(table=[2,4,1; 2,4,1; 2,4,1; 3,4,4]);
   dTurnLeft_compact(m) = my(v=Mod(digits(2*m,3),3), ret=2);
     for(i=1,#v, ret=table[ret,lift(v[i])+1];
                 if(v[i]==1, forstep(j=#v,i,-1,if(v[j]--!=2,break))));
     ret;
 }

gp_inline__location="../terdragon.tex:6592";
 dTurnRight_compact(m) = {
  my(v=digits(2*m+2,3), ret=2);
  for(i=1,#v,
   if(v[i]==0, ret=2,
      v[i]==1, ret=1; forstep(j=#v,i,-1,if(v[j]++<3,break,v[j]=0)),
      v[i]==2 && ret==2, ret=3));
  ret;
 }

gp_inline__location="../terdragon.tex:6603";
 { my(table=[2,1,1; 2,1,3; 2,1,3]);      \\ dTurnRight
   A131989_compact(n) = my(v=Mod(digits(2*n-2,3),3), ret=2);
     n>=1 || error();
     for(i=1,#v, ret=table[ret,lift(v[i])+1];
                 if(v[i]==1, forstep(j=#v,i,-1,if(v[j]++,break))));
     ret; }

gp_inline__location="../terdragon.tex:6621";
 A049321_table = [ [0,0,1,2], [1,2], [0,1,2] ];
 A049321_vector(len) = {
   my(v=[0]);
   while(#v<len, v=concat(apply(d->A049321_table[d+1],v)));
   v[1..len];
 }

gp_inline__location="../terdragon.tex:6642";
 { my(table=[2,1,0; 2,1,1; 2,1,0]);
   A049321_compact(n) = my(v=Mod(digits(2*n,3),3), ret=0);
     n>=0 || error();
     for(i=1,#v, ret=table[ret+1,lift(v[i])+1];
                 if(v[i]==1, forstep(j=#v,i,-1,if(v[j]++,break))));
     ret; }

gp_inline__location="../terdragon.tex:6673";
 dir(n) = count_1_digits(n);
 count_1_digits(n) = vecsum(apply((a)->(a==1), digits(n,3)));

gp_inline__location="../terdragon.tex:6681";
 dir_samples = {[0,1,0,1,2,1,0,1,0,1,2,1,2,3,2,1,2,1]};

gp_inline__location="../terdragon.tex:6702";
 gdir_term(x,k) = (x^(3^k) - x^(2*3^k)) / (1-x) / (1 - x^(3^(k+1)));

gp_inline__location="../terdragon.tex:6710";
 gdir_to_k(x,k) = sum(j=0,k, gdir_term(x,j));

gp_inline__location="../terdragon.tex:6889";
 AllOnes(k) = 1/2 * (3^k - 1);

gp_inline__location="../terdragon.tex:6899";
 AllOnes_samples = {[0,1,4,13,40,121,364,1093]};

gp_inline__location="../terdragon.tex:6926";
 A023692_pred(n) = count_1_digits(n)==1;

gp_inline__location="../terdragon.tex:6929";
 A023692_next_value(n) = {
   n + if(LowestNonTwo(n)==1, 2, 3^CountLowTwos(n) + 1);
   \\ my(p=CountLowTwos(n));
   \\ n + if(ternary_digit(n,p)==1,2, 3^p+1);
 }

gp_inline__location="../terdragon.tex:6937";
 A023692_next_by_search(n) = until(A023692_pred(n),n++); n;

gp_inline__location="../terdragon.tex:6954";
 LowestOnePos(n) = \
   my(ret=0); while(n, if(n%3==1,return(ret)); n\=3;ret++); -1;

gp_inline__location="../terdragon.tex:6961";
 LowestOneBit(n) = 1<<valuation(n,2);

gp_inline__location="../terdragon.tex:6970";
 vector_delete_consecutive_duplicates(v) = {
   my(l=List([v[1]]));
   for(i=2,#v, if(v[i]!=l[#l], listput(l,v[i])));
   Vec(l);
 }

gp_inline__location="../terdragon.tex:6984";
 A023692_count(k) = k*2^(k-1);

gp_inline__location="../terdragon.tex:6997";
 A023692_k(n) = {
   n>=1 || error();
   for(k=0,n+10,
     if(A023692_count(k)<n && n<=A023692_count(k+1),
        return(k)));
 }
 A023692(n) = {
   \\ print("A023692 n="n);
   my(len=2*logint(n,2)+1,
      v=vector(len));
   n--;
   forstep(k=len-1,0,-1,
     my(i=len-k);
     n>=0 || error();
     my(\\ k=A023692_k(n),
        a=A023692, c=A023692_count);
     c(k)<=n || next;
     \\ print("  at n="n" k="k" c="c(k)" part "n <= c(k)+2^(k-1));
     \\(c(k)<=n && n < c(k+1)) || error();
     c(k)+2^k+c(k)==c(k+1) || error();
     n-=k*2^(k-1);  \\ n-=c(k);
     \\ (n < 2^k) == (bittest(n,k)==0) || error();
     if(n < 2^k, v[i]=1; break,
                 v[i]=2; n-=2^k));
   \\ print("  final n="n" v="v);
   my(b=binary(n));
   v=concat(v[1..len-#b], 2*b);
   fromdigits(v,3);
 }

gp_inline__location="../terdragon.tex:7060";
 \\ one ternary 1 digit
 A023692_compact(n) = {
   my(v=vector(logint(n,2)+1)); n--;
   forstep(k=#v-1,0,-1,
     my(c=k*2^(k-1)); if(n>=c, if((n-=c)<2^k, v[#v-k]=1; break,
                                              v[#v-k]=2; n-=2^k)));
   my(b=binary(n)); fromdigits(concat(v[1..#v-#b], 2*b), 3);
 }

gp_inline__location="../terdragon.tex:7071";
 A023692_by_offset(n) = {
   my(debug=0);
   if(debug,print("A023692 n="n));
   my(c=A023692_count, a=A023692,
      len=2*logint(n,2)+1,
      v=vector(len));
   n--;
   n-=c(len);
   forstep(k=len-1,0,-1,
     my(i=len-k);
     n += c(k+1) - c(k);
     if(debug,print("  at k="k" n="n" c="c(k)" part "n <= c(k)+2^(k-1)));
     if(n>=0,
        \\ n-c(k) < c(k+1) || error();
        if(n < 2^k, v[i]=1; break,
                    v[i]=2; n-=2^k+c(k))));
   if(debug,print("  final n="n" v="v));
   my(b=binary(n));
   v=concat(v[1..len-#b], 2*b);
   if(debug,print("  v="v));
   fromdigits(v,3);
 }

gp_inline__location="../terdragon.tex:7107";
 TurnsL(n) = (n + dir(n))/2;
 TurnsR(n) = (n - dir(n))/2;

gp_inline__location="../terdragon.tex:7120";
 TurnsL_samples = {[0,1,1,2,3,3,3,4,4,5,6,6,7,8]};

gp_inline__location="../terdragon.tex:7131";
 A189674(n) = {
   n>=1 || error("A189674() is for n>=1");
   n--; (n + vecsum(digits(n,3)%2))/2;
 }

gp_inline__location="../terdragon.tex:7150";
 TurnsR_samples = {[0,0,1,1,1,2,3,3,4,4,4,5,5,5]};

gp_inline__location="../terdragon.tex:7175";
 gTurnsL_term(x,k) = x^(3^k) / (1-x) / (1 - x^(3^(k+1)));
 gTurnsL(x,k) = sum(j=0,k, gTurnsL_term(x,j));

gp_inline__location="../terdragon.tex:7184";
 gTurnsR_term(x,k) = x^(2*3^k) / (1-x) / (1 - x^(3^(k+1)));
 gTurnsR(x,k) = sum(j=0,k, gTurnsR_term(x,j));

gp_inline__location="../terdragon.tex:7282";
 TurnLeft_num_decrements(m) = {
   my(n=2*m,count=0);
   forstep(pos=if(n,logint(n,3)),0,-1,   \\ high to low
     if(ternary_digit(n,pos)==1, n--;count++));
   count;
 }

gp_inline__location="../terdragon.tex:7293";
 TurnRight_num_increments(m) = {
   my(n=2*m+2,count=0);
   forstep(pos=if(n,logint(n,3)),0,-1,   \\ high to low
     if(ternary_digit(n,pos)==1, n++;count++));
   count;
 }

gp_inline__location="../terdragon.tex:7396";
 TurnLeftOffH_formula(k) = 1/4 * (3^k + 2*k - 5);
 TurnLeftOffH(k) = {
   k>=1 || error("TurnLeftOffH() is for k>=1");
   TurnLeftOffH_formula(k);
 }

gp_inline__location="../terdragon.tex:7404";
 TurnLeftOffH_samples = {[0,2,7,21,62,184,549]};

gp_inline__location="../terdragon.tex:7413";
 A047926(n) = {
   n>=0 || error("A047926() is for n>=0");
   (3^(n+1) + 2*n + 1)/4;
 }

gp_inline__location="../terdragon.tex:7446";
 TurnRightOffH_formula(k) = 1/4 * (3^k - 2*k - 1);
 TurnRightOffH(k) = {
   k>=1 || error("TurnRightOffH() is for k>=1");
   TurnRightOffH_formula(k);
 }

gp_inline__location="../terdragon.tex:7453";
 TurnRightOffH_samples = {[0,1,5,18,58,179,543]};

gp_inline__location="../terdragon.tex:7463";
 A000340(n) = {
   n>=0 || error("A000340() is for n>=0");
   (3^(n+2) - 2*n - 5)/4;
 }

gp_inline__location="../terdragon.tex:7522";
 dir_mod3_samples = {[0,1,0,1,2,1,0,1,0,1,2,1,2,0,2,1]};

gp_inline__location="../terdragon.tex:7549";
 dir_mod3_0_at_n_samples = {[0,2,6,8,13,18,20,24,26]};

gp_inline__location="../terdragon.tex:7570";
 dir_mod3_1_at_n_samples = {[1,3,5,7,9,11,15,17,19]};

gp_inline__location="../terdragon.tex:7593";
 dir_mod3_2_at_n_samples = {[4,10,12,14,16,22,28,30,32]};

gp_inline__location="../terdragon.tex:7637";
 dir_mod3_expand = {[ [0,1,0],
                      [1,2,1],
                      [2,0,2] ]};
 dir_mod3_vec_by_morphism(len) = {
   my(v=[0]);
   while(#v<len, v=concat(apply(d->dir_mod3_expand[d+1],v)));
   v[1..len];
 }

gp_inline__location="../terdragon.tex:7682";
 \\ Weirdness ceil according as TurnLpred.
 A026177(n) = {
   n>=1 || error();
   if((n/3^valuation(n,3))%3==1, ceil(2*n/3), 2*n);
 }

gp_inline__location="../terdragon.tex:7690";
 \\ inverse of A026177
 A026178(n) = if(n%2 || (n/3^valuation(n,3))%3==2, floor(3*n/2), n/2);

gp_inline__location="../terdragon.tex:7708";
 \\ following the definition in A026177
 A026177_vector(len) = {
   my(v=vector(4*(len+1),i,'undef));
   v[1]=1;
   for(n=2,2*len,
       my(h=floor(n/2), L=n-h, R=n+h);
       if(R<=#v && (n%2!=0 || v[L]!='undef), v[R]=n,
          L<=#v,                             v[L]=n));
   v[1..len];
 }

gp_inline__location="../terdragon.tex:7933";
 \\ p index of plain
 \\ m index of multiple of k
 \\ A026177(m) is the multiple of k value
 \\ A026177(m)/k must be the plain A026177(p) value again
 A026177_multiples_disorder_pos(k) = {
   my(m=1);
   for(p=1,100,
     while(A026177(m)%k, m++);
     if(A026177(p) != A026177(m)/k, return(i));
     m++);
   'none;
 }

gp_inline__location="../terdragon.tex:7948";
 list_6j_by_3k(offset,limit) = {
   my(l=List([]));
   for(j=0,limit,
     my(s=6*j+offset); if(s>limit, break);
     for(k=0,limit,
       my(n=s*3^k); if(n>limit, break);
       listput(l,n)));
   vecsort(Vec(l),,8);
 }

gp_inline__location="../terdragon.tex:7997";
 A026177_pos_first_multiple_k(k) = \
   for(n=1,oo, if(A026177(n)%k==0, return(n)));

gp_inline__location="../terdragon.tex:8135";
 ceil_for_A026177(n) = ceil(3*n/2);
 floor_for_A026178(n) = floor(2*n/3);

gp_inline__location="../terdragon.tex:8199";
 period_of_func(n,func) = {
   my(m=Map(),prev);
   for(i=1,100000,
     if(mapisdefined(m,n,&prev), return(i-prev));
     mapput(m,n,i); n=func(n));
   'unknown;
 }

gp_inline__location="../terdragon.tex:8252";
 downwards_of_A026177(n) = \
   my(ret=0,t); while((t=A026177(n))<n, n=t;ret++); ret;

gp_inline__location="../terdragon.tex:8325";
 A026178_multiples_disorder_pos(k) = {
   my(m=1);
   for(p=1,100,
     while(A026178(m)%k, m++);
     if(A026178(p) != A026178(m)/k, return(i));
     m++);
   'none;
 }

gp_inline__location="../terdragon.tex:8358";
 \\ cf A026178 n%2==0 || LowestNonZero(n)==2, and then floor(3/2*n)
 \\
 \\ a(n) = n/2 if n even and A060236(n)=2,
 \\ otherwise a(n) = ceiling(3n/2),
 \\ where A060236(n) is the lowest non-0 ternary digit of n.
 A026214(n) = if(n%2==0 && A060236(n)==2, n/2, ceil(3/2*n));

gp_inline__location="../terdragon.tex:8441";
 \\ cf A026177 is LNZ=1 ceil(2*n/3) otherwise 2*n
 \\
 A026215(n) = if(LowestNonZero(n)==1, 2*n, floor(2/3*n));

gp_inline__location="../terdragon.tex:8490";
 \\ section 2.3 on Pi_odd
 \\ and in section 2.6, 2,4 are where even values of Pi_odd
 Dekking_sigmaodd(k) = {
   my(v=[2]);
   for(i=1,k,
       v=concat(apply(e->if(e==2, [3,2,2],
                            e==3, [3,2,4],
                            e==4, [3,2,4],
                            error()), v)));
   v;
 }

gp_inline__location="../terdragon.tex:8537";
 A026180_vec(len) = vector_new_highs_from_func(len,A026177_vector);

gp_inline__location="../terdragon.tex:8545";
 A026181_vec(len) =  vector_differences(A026180_vec(len+2)[^1])/2;

gp_inline__location="../terdragon.tex:8613";
 A026142_vector(len) = {
   my(v=vector(len));  \\ 0 when not yet set
   if(#v>=1,v[1]=1);
   for(n=2,oo,
     my(L=ceil(n/2), R=L);
     if(n-L>#v,break);
     if(n-L>=1 && v[n-L]==0, v[n-L]=n,
        n+R<=#v,             v[n+R]=n));
   v;
  }

gp_inline__location="../terdragon.tex:8625";
 A026142_morphism_table = {[ [0,0,0],
                             [2,3,2],
                             [2,3,4],
                             [2,3,4],
                             [5,2,4] ]};
 A026142_types_vector_by_morphism(len) = {
   my(v=[5]);
   while(#v<len,
     v=concat(apply(s->A026142_morphism_table[s], v)));
   v[1..len];
 }

gp_inline__location="../terdragon.tex:8637";
 A026142_samples_types = {
   vector(#A026142_samples,n,
     if(A026142_samples[n]%2==1 && A026142_samples[n]>n, 1,
        A026142_samples[n]%2==0 && A026142_samples[n]>n, 2,
        A026142_samples[n]%2==1 && A026142_samples[n]<n, 3,
        A026142_samples[n]%2==0 && A026142_samples[n]<n, 4,
        5));
 }

gp_inline__location="../terdragon.tex:8648";
 A026142_type(n) = {
   if(n==1, 5,
      n%3==1 || n==2, 2,
      n%3==2,         3,
      A026142_type(n/3)==2, 2, 4);
 }

gp_inline__location="../terdragon.tex:8687";
 A026142_by_type(n) = {
   if(n==1,return(1));
   my(t=A026142_type(n));
   if(t==2, 2*n,
      t==3, (2*n-1)/3,
      t==4, 2*n/3,
      error("oops, type %s",t));
 }

gp_inline__location="../terdragon.tex:8704";
 A026142(n) = {
   n>=1 || error("A026142() is for n>=1");
   if(n==1,1, my(q=n/3^valuation(n,3));
              if(q==2 || (q!=1 && q%3==1), 2*n, floor(2*n/3)));
 }

gp_inline__location="../terdragon.tex:8714";
 \\ A160384
 CountNonZeros(n) = my(v=digits(n,3)); sum(i=1,#v,v[i]!=0);

gp_inline__location="../terdragon.tex:8822";
 A026143(n) = {
   if(n%2==0,
      my(r=n/3^valuation(n,3));
      if(r==4 || (r!=2 && r%3==2), return(n/2)));
   if(n==1,1,ceil(3*n/2));
 }

gp_inline__location="../terdragon.tex:8921";
 terdragon_digit_vector = [0,1,w6];
 terdragon_digit(a) = terdragon_digit_vector[a+1];

gp_inline__location="../terdragon.tex:8956";
 terdragon_point(n) = {
   n>=0 || error("terdragon_point() is for n>=0");
   my(v=digits(n,3), d=0, ret=0);
   for(i=1,#v,  /* high to low */
       ret += b^(#v-i) * terdragon_digit(v[i]) * w3^d;
       d += (v[i]==1));
   ret;
 }

gp_inline__location="../terdragon.tex:8984";
 point_w6_samples = \
   [0, 1, w6, 1+w6, 2*w6, w6, -1+2*w6, 2*w6, -1+3*w6];

gp_inline__location="../terdragon.tex:9010";
 point_sqrt3i_samples = [0,1, 1/2+1/2*sqrt3i, 3/2+1/2*sqrt3i, \
   1+sqrt3i, 1/2+1/2*sqrt3i, sqrt3i, 1+sqrt3i,  1/2+3/2*sqrt3i ];

gp_inline__location="../terdragon.tex:9182";
 c45(x,y) = x*w6 + y*w3;

gp_inline__location="../terdragon.tex:9334";
 \\ return true if z is an Eisenstein integer
 z_is_integer(z) = is_integer(real(z)+imag(z)) \
                && is_integer(real(z)-imag(z));

gp_inline__location="../terdragon.tex:9351";
 z_mod_b(z) = {
   z -= b*imag(z)/imag(b);
   if(imag(z),error("z_mod_b() oops imag not zero"));
   z = real(z) % 3;
   if(z > 1, z += w3*b);
   z;
 }

gp_inline__location="../terdragon.tex:9366";
 \\ d=0,1,2.  Return vector [n, arm].
 terdragon_unpoint(z,d) = {
   my(debug=0);
   my(v=List([]), arm=0);
   while(1,
     if(z==0,                arm=2*d; break());
     if(z==w6       && d==2, arm=1;   break());
     if(z==-1       && d==0, arm=3;   break());
     if(z==conj(w6) && d==1, arm=5;   break());
     my(a = z_mod_b(z));    \\ low digit
     if(a == w6, a = 2);
     if(! (a==0||a==1||a==2), error("oops a=",a));
     d = (d - dir(a)) % 3;
     z = ( z - terdragon_digit(a) * w3^d )/b;
     \\ print("a=",a, "  z=",z, "  d=",d);
     if(! z_is_integer(z), error("oops, z=",z));
     listput(v,a);
     );
   v = Vec(v);
   if(debug,print("final v=",v," arm=",arm));
   my(n=digits_join_low_to_high(v,3));
   if(arm%2, [3^#v-n, arm],
             [ n,     arm]);
 }

gp_inline__location="../terdragon.tex:9416";
 z_count_visits(z) = \
   sum(d=0,2, terdragon_unpoint(z,d)[2]==0);
 z_to_n_on_arm(z,arm) = {
   for(d=0,2,
       my(v = terdragon_unpoint(z,d));
       if(v[2] == arm, return(v[1])));
 }

gp_inline__location="../terdragon.tex:9648";
 { my(sqrt3i=quadgen(-12), w6=1/2+1/2*sqrt3i, w3=w6-1, b=w6+1);
   A971003_X_compact(n) = my(v=digits(n,3), z=0, d=2);
     for(i=1,#v, z*=b; if(v[i]==1,z+=d;d*=w3, v[i]==2,z+=d*w6));
     real(z); }

gp_inline__location="../terdragon.tex:9655";
 { my(w6=quadgen(-3), w3=w6-1, b=w6+1);
   A971003_Y_compact(n) = my(v=digits(n,3), z=0, d=1);
     for(i=1,#v, z*=b; if(v[i]==1,z+=d;d*=w3, v[i]==2,z+=d*w6));
     imag(z); }

gp_inline__location="../terdragon.tex:9674";
 terdragon_other_n_and_arm(n,delta) = {
   if(n==0,return([0,0]));
   my(debug=0);
   my(v=digits(n,3),
      k=#v);
   v=concat(0,v);
   my(i=#v);
   while(v[i]==0, i--);
   my(ap=v[i]); i--;
   if(debug,print("ap=",ap));
   while(i>=1,
      my(a=v[i],
         c=(a - delta*ap)%3);
      delta = delta + dir(a) - dir(c);
      v[i]=c;
      i--);
   if(debug,print("final "v" delta="delta));
   my(ndelta=fromdigits(v,3));
   if(delta%3==0, [ndelta, 0],
      delta%3==1, [3^(k+1)-ndelta, -1],
                  [3^(k+1)-ndelta,  1]);
 }

gp_inline__location="../terdragon.tex:9697";
 \\ Return "nd" which is another n at the same location so
 \\ terdragon_point(n) == terdragon_point(nd).
 \\ delta can be 0,1,2.  When delta=0 n itself is returned.
 \\ delta=1,2 are the other visits to the location of n.
 \\ If there is no such other visit for the given delta
 \\ then return -1.
 terdragon_other_n(n,delta) = {
   my(n_and_arm=terdragon_other_n_and_arm(n,delta));
   if(n_and_arm[2]==0,n_and_arm[1],-1);
 }

gp_inline__location="../terdragon.tex:9779";
 ternary_delta(x,y) = {
   my(k=max(#digits(x,3),#digits(y,3)));
   fromdigits(apply(d->d%3,
                    ternary_padded(x,k) - ternary_padded(y,k)), 3);
 }

gp_inline__location="../terdragon.tex:9797";
 DeltaOnes_vector(v,d) = {
   my(s = vector_last_non_zero(v));    \\ low digit as +/-1
   forstep(i=#v-1,1, -1,  \\ low to high from second lowest
     my(new_digit = (v[i] + s*d) % 3);
     d -= (v[i] == 1);
     d += (new_digit == 1);
     v[i] = new_digit);
   if(d%3, -v, v);
 }
 DeltaOnes(n,k, d) = {
   fromdigits(DeltaOnes_vector(ternary_padded(n,k), d),
              3);
 }
 DeltaOnes_all(n,k) = vector(3,d,d--; DeltaOnes(n,k,d));

gp_inline__location="../terdragon.tex:9812";
 DeltaOnes_all_z(n,k) = \
   apply(terdragon_point, DeltaOnes_all(n,k));

gp_inline__location="../terdragon.tex:9822";
 vector_any_negative(v) = for(i=1,#v,if(v[i]<0,return(1)));0;
 other_n_by_DeltaOnes(n,d) = {
   my(v = concat([0,0], digits(n,3)));
   v = DeltaOnes_vector(v, d);
   if(vector_any_negative(v), -1,
      fromdigits(v,3));
 }

gp_inline__location="../terdragon.tex:9877";
 other_state_table = {[
   1,4,5;  \\ 1 = S1
   2,3,6;  \\ 2 = S2
   4,7,3;  \\ 3 = L1
   4,3,7;  \\ 4 = L2
   7,6,5;  \\ 5 = R1
   6,7,5;  \\ 6 = R2
   7,7,7   \\ 7 = unchanged
 ]};
 other_state_transition(state,a) = other_state_table[state,a+1];
 other_state_to_add = [0,0,  1,2,   1,2, 0];
 other_state_to_arm = [0,0, 99,-1, 99,1, 0];
 other_n_and_arm_by_states(n,delta) = {
   delta%=3;
   if(delta==0,return([n,0]));
   my(v=digits(n,3), state=delta);
   v=concat(0,v);
   forstep(i=#v,1,-1,
       my(a=v[i]);
       v[i] = (a + other_state_to_add[state]) % 3;
       state = other_state_transition(state,a));
   if(state==5, \\ R+1
       my(a=0);
       v = concat([(a + other_state_to_add[state]) % 3], v);
       state = other_state_transition(state,a));
   my(arm=other_state_to_arm[state],
      n=fromdigits(v,3));
   if(arm==99, error());
   if(arm, n=3^#v-n);
   [n,arm];
 }

gp_inline__location="../terdragon.tex:10086";
 other_n_delta1_samples = [0,2,5,6,17,1,15,4,11,18];

gp_inline__location="../terdragon.tex:10104";
 other_arm_delta1_samples = [0,-1,0,-1,-1,1,0,0,0,-1];

gp_inline__location="../terdragon.tex:10125";
 other_n_delta2_samples = [0,5,1,15,7,2,3,17,14,45];

gp_inline__location="../terdragon.tex:10144";
 other_arm_delta2_samples = [0,-1,1,-1,0,0,1,-1,0,-1];

gp_inline__location="../terdragon.tex:10227";
 other_delta_dz_to_c(delta_dz,a) = {
   my(delta=delta_dz[1],
      dz   =delta_dz[2],
      z_c=z_mod_b(terdragon_digit(a)+dz));
   if(z_c==0,0, z_c==1,1, z_c==w6,2, error());
 }

gp_inline__location="../terdragon.tex:10244";
 other_delta_dz_to_new_delta(delta_dz,a) = {
   my(delta=delta_dz[1],
      dz   =delta_dz[2],
      c        = other_delta_dz_to_c(delta_dz,a));
   (delta - dir(c) + dir(a)) % 3;
 }

gp_inline__location="../terdragon.tex:10339";
 other_delta_dz_transition(delta_dz,a) = {
   my(delta=delta_dz[1],
      dz   =delta_dz[2],
      c         = other_delta_dz_to_c(delta_dz,a),
      new_delta = other_delta_dz_to_new_delta(delta_dz,a),
      new_dz = ( dz*w3^dir(a)
                 - w3^new_delta*terdragon_digit(c)
                 + terdragon_digit(a)
               )/b);
   z_is_integer(new_dz) || error();
   [new_delta, new_dz];
 }

gp_inline__location="../terdragon.tex:10400";
 other_delta_dz_S1 = [1,                   0];

gp_inline__location="../terdragon.tex:10406";
 other_delta_dz_S2 = [2,                   0];

gp_inline__location="../terdragon.tex:10412";
 other_delta_dz_L1 = [  2,                   1];

gp_inline__location="../terdragon.tex:10420";
 other_delta_dz_L2 = [ 1,                        conj(w6)];

gp_inline__location="../terdragon.tex:10428";
 other_delta_dz_R1 = [1,                   1];

gp_inline__location="../terdragon.tex:10436";
 other_delta_dz_R2 = [ 2,                   w6];

gp_inline__location="../terdragon.tex:10536";
 other_n_and_arm_by_delta_dz(n,delta) = {
   my(debug=0);
   delta%=3;
   if(delta==0,return([n,0]));
   my(delta_dz=[delta, 0],
      l=List([]));
   while(n || ! (delta_dz == [0,0]
              || delta_dz == other_delta_dz_L2
              || delta_dz == other_delta_dz_R2 ),
     my(a=n%3);
     my(c = other_delta_dz_to_c(delta_dz,a));
     if(debug, print("at "delta_dz" n="n" a="n%3" is c="c));
     n\=3;
     listput(l,c);
     delta_dz=other_delta_dz_transition(delta_dz,a));
   if(debug, print("final "delta_dz));
   my(n=fromdigits(Vecrev(l),3),
      arm);
   if(delta_dz == [0,0],             arm=0,
      delta_dz == other_delta_dz_R2, arm=1,
      delta_dz == other_delta_dz_L2, arm=-1,
      error("oops"));
   if(debug,print("arm ",arm));
   if(arm, n=3^#l-n);
   [n,arm];
 }

gp_inline__location="../terdragon.tex:10933";
 otherright_matrix = [2,1; 0,2; 1,0];

gp_inline__location="../terdragon.tex:10942";
 otherright(n) = {
   my(nv=digits(n,3));
   nv=concat(0,nv);
   my(sv=vector(#nv), ev=sv);
   for(i=1,#nv,
       if(nv[i]==0, ev=sv;        sv[i]=2; ev[i]=1,
          nv[i]==1, sv=ev;ev=nv;  sv[i]=0; ev[i]=2,
                    sv=nv;        sv[i]=1; ev[i]=0));
   my(s=fromdigits(sv,3),e=fromdigits(ev,3),
      s_arm=if(sv[1],-1,0),
      e_arm=if(ev[1],-1,0));
   if(s_arm, s=3^#nv-1-s);
   if(e_arm, e=3^#nv-1-e);
   [s,s_arm, e,e_arm];
 }

gp_inline__location="../terdragon.tex:10970";
 otherright_by_unpoint(n) = {
   my(z=terdragon_point(n),
      d=dir(n),
      dz=w3^d);
   z += dz; dz /= w3; d--;
   my(na=terdragon_unpoint(z,d));
   my(e=na[1], e_arm=if(na[2],-1,0));
   if(e_arm,e--);
   z += dz; dz /= w3; d--;
   na=terdragon_unpoint(z,d);
   my(s=na[1], s_arm=if(na[2],-1,0));
   if(s_arm,s--);
   [s,s_arm, e,e_arm];
 }

gp_inline__location="../terdragon.tex:11093";
 otherleft(n) = {
   my(nv=digits(n,3));
   nv=concat(0,nv);
   my(sv=vector(#nv), ev=sv);
   for(i=1,#nv,
       if(nv[i]==0, ev=nv;        sv[i]=2; ev[i]=1,
          nv[i]==1, ev=sv;sv=nv;  sv[i]=0; ev[i]=2,
                    sv=ev;        sv[i]=1; ev[i]=0));
   my(s=fromdigits(sv,3),e=fromdigits(ev,3),
      s_arm=if(sv[1]==2,1,0),
      e_arm=if(ev[1]==2,1,0));
   if(s_arm, s=3^#nv-1-s);
   if(e_arm, e=3^#nv-1-e);
   [s,s_arm, e,e_arm];
 }

gp_inline__location="../terdragon.tex:11124";
 otherleft_by_unpoint(n) = {
   my(z=terdragon_point(n),
      d=dir(n),
      dz=w3^d);
   z += dz; dz *= w3; d=(d+1)%3;
   my(na=terdragon_unpoint(z,d));
   my(e=na[1], e_arm=na[2]);
   if(e_arm,e--);
   z += dz; dz *= w3; d=(d+1)%3;
   na=terdragon_unpoint(z,d);
   my(s=na[1], s_arm=na[2]);
   if(s_arm,s--);
   [s,s_arm, e,e_arm];
 }

gp_inline__location="../terdragon.tex:11160";
 other_stu_turn_L(v) = {
   my(s=List([0]),t=List([1]),u=List([2]));
   for(i=1,#v,
       my(new_s,new_t,new_u);
       if(v[i]==0,
          new_s=s; listput(new_s,0);
          new_t=u; listput(new_t,1);
          new_u=u; listput(new_u,2)
          ,
          v[i]==1,
          new_s=s; listput(new_s,1);
          new_t=s; listput(new_t,2);
          new_u=t; listput(new_u,0)
          ,
          new_s=s; listput(new_s,2);
          new_t=t; listput(new_t,0);
          new_u=s; listput(new_u,1));
       s=new_s; t=new_t; u=new_u);
   [Vec(s),Vec(t),Vec(u)];
 }
 stu_str_first = ["s","t","u"];
 stu_str_one(v) = \
   concat(stu_str_first[v[1]+1], concat(apply(d->Str(d),v[2..#v])));
 stu_str(stu) = {
   concat([stu_str_one(stu[1]),", ",
           stu_str_one(stu[2]),", ",
           stu_str_one(stu[3])]);
 }

gp_inline__location="../terdragon.tex:11193";
 other_n_and_arm_by_high_to_low_turn_L(n,delta) = {
   my(debug=0);
   my(v=digits(n,3), s=List([0]),t=List([1]),u=List([2]));
   my(lowpos=#v);
   forstep(i=#v,1,-1, if(v[i], lowpos=i;break()));
   if(debug,
      print("v digits ",v);
      print("lowpos ",lowpos));
   if(v[lowpos]!=1, error());
   for(i=1,lowpos-1,
       if(debug,
          print("at i="i);
          print("  s="Vec(s));
          print("  t="Vec(t));
          print("  u="Vec(u)));
       my(new_s,new_t,new_u);
       if(v[i]==0,
          new_s=s; listput(new_s,0);
          new_t=u; listput(new_t,1);
          new_u=u; listput(new_u,2)
          ,
          v[i]==1,
          new_s=s; listput(new_s,1);
          new_t=s; listput(new_t,2);
          new_u=t; listput(new_u,0)
          ,
          new_s=s; listput(new_s,2);
          new_t=t; listput(new_t,0);
          new_u=s; listput(new_u,1));
       s=new_s; t=new_t; u=new_u);
   if(debug,
      print("after sides");
      print("  s="Vec(s));
      print("  t="Vec(t));
      print("  u="Vec(u)));
   listput(s,1); listput(t,1); listput(u,1);
   for(i=lowpos+1,#v, listput(s,0); listput(t,0); listput(u,0));
   if(debug,
      print("final");
      print("s="Vec(s));
      print("t="Vec(t));
      print("u="Vec(u)));
   if(delta==1, s=u, delta==2, s=t);
   my(n=fromdigits(Vec(s),3),
      arm=if(s[1],-1,0));
   if(arm, n = 3^#s - n);
   [n,arm];
 }

gp_inline__location="../terdragon.tex:11248";
 other_n_and_arm_by_high_to_low_turn_R(n,delta) = {
   my(debug=0);
   my(v=digits(n,3), s=List([0]),t=List([1]),u=List([2]));
   my(lowpos=#v);
   forstep(i=#v,1,-1, if(v[i], lowpos=i;break()));
   if(debug,
      print("v digits ",v);
      print("lowpos ",lowpos));
   if(v[lowpos]!=2, error());
   for(i=1,lowpos-1,
       if(debug,
          print("at i="i);
          print("  s="Vec(s));
          print("  t="Vec(t));
          print("  u="Vec(u)));
       my(new_s,new_t,new_u);
       if(v[i]==0,
          new_s=s; listput(new_s,0);
          new_t=s; listput(new_t,1);
          new_u=u; listput(new_u,2)
          ,
          v[i]==1,
          new_s=s; listput(new_s,1);
          new_t=u; listput(new_t,2);
          new_u=s; listput(new_u,0)
          ,
          new_s=s; listput(new_s,2);
          new_t=t; listput(new_t,0);
          new_u=t; listput(new_u,1));
       s=new_s; t=new_t; u=new_u);
   if(debug,
      print("after sides");
      print("  s="Vec(s));
      print("  t="Vec(t));
      print("  u="Vec(u)));
   listput(s,2); listput(t,2); listput(u,2);
   for(i=lowpos+1,#v, listput(s,0); listput(t,0); listput(u,0));
   if(debug,
      print("final");
      print("s="Vec(s));
      print("t="Vec(t));
      print("u="Vec(u)));
   if(delta==1, s=t, delta==2, s=u);
   my(n=fromdigits(Vec(s),3),
      arm=if(s[1]==2,1,0));
   if(arm, n = 3^#s - n);
   [n,arm];
 }

gp_inline__location="../terdragon.tex:11303";
 other_n_and_arm_by_high_to_low(n,delta) = {
   if(turn(n)==1,
      other_n_and_arm_by_high_to_low_turn_L(n,delta),
      other_n_and_arm_by_high_to_low_turn_R(n,delta));
 }

gp_inline__location="../terdragon.tex:11334";
 Opred_at_n_samples = {[3,6,9,18,21,24,27,54,57]};

gp_inline__location="../terdragon.tex:11348";
 \\ Return 1 if the non-zero entries of v have alternating signs.
 vector_is_alternating_signs(v) = {
   v=select(n->n!=0,v);
   v=apply(sign,v);
   for(i=1,#v-1, if(v[i]==v[i+1],return(0)));
   1;
 }

gp_inline__location="../terdragon.tex:11368";
 A306556_vector(k) = {
   my(v=[0,1], p=1);
   for(i=1,k, v=concat(v,apply(n->n+2*p,v)); p*=3);
   v;
 }

gp_inline__location="../terdragon.tex:11380";
 \\ A306556 unreduced numerators of Cantor set
 \\ Recurrence per formula.
 A306556(n) = {
   if(n==1, return(0));
   if(n==2, return(1));
   my(p=logint(n,2),
      k = n - 2^p);
   n == 2^p+k || error();
   if(k==0, return(3^(p-1)));
   (1 <= k && k <= 2^p) || error();
   2*3^(p-1) + A306556(k);
 }

gp_inline__location="../terdragon.tex:11394";
 \\ GP code by Dan Dima in A306556.
 A306556_by_sm(n) = {
   my(sm=0);
   while(n>1,
     my(ex=floor(log(n)/log(2)));
     my(ex=logint(n,2));
     if(n-2^ex==0, sm=sm+3^(ex-1), sm=sm+2*3^(ex-1));
     n=n-2^ex);
   return(sm);
 }

gp_inline__location="../terdragon.tex:11406";
 A306556_compact(n) = n--; 2*fromdigits(binary(n>>1),3) + (n%2);

gp_inline__location="../terdragon.tex:11409";
 \\ A005823(n) having only digits 0,2 in ternary, OFFSET=1
 \\ This one-liner by Charles R Greathouse in A005823.
 A005823(n) = {
   n>=1 || error("A005823() is for n>=1");
   2*fromdigits(binary(n-1), 3);
 }

gp_inline__location="../terdragon.tex:11505";
 otherside_positive_samples = {[1,7,19,25,55,61,73,79]};

gp_inline__location="../terdragon.tex:11524";
 A055246_pred(n) = {
   n%3==1 || return(0);     \\ must lowest 1
   n\=3;
   while(n,
     if(n%3==1,return(0));  \\ then must not any 1, only 0,2
     n\=3);
   1;
 }

gp_inline__location="../terdragon.tex:11538";
 otherside_negative_samples = {[-2,-8,-20,-26,-56,-62,-74,-80]};

gp_inline__location="../terdragon.tex:11550";
 A190640_pred(n) = {
   n%3==2 || return(0);     \\ must lowest 2
   n\=3;
   while(n,
     if(n%3==1,return(0));  \\ then all else 0,2
     n\=3);
   1;
 }

gp_inline__location="../terdragon.tex:11569";
 otherside_differences_list(k) = {
   my(debug=0);
   if(k==0,return([]));
   Set(
   vector(2^(k-1),n,n--;
     my(v=binary_padded(n,k-1));
     if(debug,print("binary "v));
     my(s=-1);
     forstep(i=#v,1,-1, if(v[i], v[i]*=s; s=-s));
     if(debug,print("  signed "v));
     3*fromdigits(v,3)+1);
   );
 }

gp_inline__location="../terdragon.tex:11587";
 otherside_differences_list_by_unpoint(k) = {
   my(m=Map(), limit=3^k);
   for(n=0,limit-1,
     my(z=terdragon_point(n), d=dir(n), dz=w3^d);
     for(delta=1,2,  \\ left and right sides
       my(ma=terdragon_unpoint(z+dz,d+delta));
       if(ma[2]==0 && ma[1]<limit,
          mapput(m,ma[1]-n,1))));
   Set(Mat(m)[,1]);
 }

gp_inline__location="../terdragon.tex:11998";
 Opred_list_by_other_turn(k,delta,t) = {
   my(limit=3^k-1,m=Map());
   for(n=1,limit,
       if(turn(n)!=t,next());
       my(v=terdragon_other_n_and_arm(n,delta),
          on=v[1],arm=v[2]);
       if(arm==0 && on<=limit,
          mapput(m,abs(n-on),1)));
   m=Mat(m);
   if(matsize(m)[1], Set(m[,1]), []);
 }

gp_inline__location="../terdragon.tex:12018";
 n_flip_lowest_12(n) = {
   my(v=digits(n,3));
   forstep(i=#v,1,-1, if(v[i]==1,v[i]=2;break(),
                         v[i]==2,v[i]=1;break()));
   fromdigits(v,3);
 }

gp_inline__location="../terdragon.tex:12124";
 Opred_list_by_other(k,delta) = {
   my(limit=3^k-1,m=Map());
   for(n=1,limit,
       my(v=terdragon_other_n_and_arm(n,delta),
          on=v[1],arm=v[2]);
       if(arm==0 && on<=limit,
          mapput(m,abs(n-on),1)));
   m=Mat(m);
   if(matsize(m)[1], Set(m[,1]), []);
 }

gp_inline__location="../terdragon.tex:12141";
 Opred(d) = {
   if(d==0,return(0));
   if(d%3,return(0));
   while(d%3==0, d\=3);   \\ low 0s
   d\=3;                  \\ any above them
   while(d,
         if(d%3==1, return(0));  \\ disallow 1, only 0,2
         d\=3);
   1;
 }

gp_inline__location="../terdragon.tex:12156";
 Opred_at_n_ternary_samples = {[10,20,100,200,210,220,1000,2000,2010]};

gp_inline__location="../terdragon.tex:12237";
 Cpred(n) = {
   n>=0 || error("Cpred() is for n>=0");
   count_digits(n,3,1)==0;
 }

gp_inline__location="../terdragon.tex:12242";
 is_ternary_0s_and_2s(n) = {
   if(n<0,return(0));
   while(n, if(n%3==1,return(0)); n\=3); 1;
 }

gp_inline__location="../terdragon.tex:12254";
 Cpred_samples = {[1,0,1,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,1,0,1]};

gp_inline__location="../terdragon.tex:12266";
 Cpred_at_samples = {[0,2,6,8,18,20,24,26,54,56]};

gp_inline__location="../terdragon.tex:12281";
 NonCpred_at_samples = {[1,3,4,5,7,9,10,11,12,13]};

gp_inline__location="../terdragon.tex:12314";
 A055246_by_plusminus(n) = {
   n--;
   n = bitxor(n,n<<1);    \\ even 1s
   n = 2*n+1;             \\ odd 1s and low bit 1
   my(v=binary(n), s=1);
   forstep(i=#v,1,-1,     \\ alternating signs from low +1
     if(v[i],v[i]=s;s=-s));
   fromdigits(v,3);
 }

gp_inline__location="../terdragon.tex:12326";
 \\ like formula by Wolfdieter Lang (is it?) in A055246
 A055246_by_02(n) = 6*fromdigits(binary(n-1),3) + 1;

gp_inline__location="../terdragon.tex:12375";
 Skd(k,d) = 3^(k-1) + s(k-4*d)*3^floor((k-1)/2);

gp_inline__location="../terdragon.tex:12392";
 Skd_by_omega(k,d) = {
    1/3*( 3^k
        + conj(w3)^d * b^k
        +      w3^d  * conj(b)^k
    );
 }

gp_inline__location="../terdragon.tex:12405";
 Sk0_by_omega(k) = \
  1/3*( 3^k + (w12_times_sqrt3)^k + (conj(w12_times_sqrt3))^k );

gp_inline__location="../terdragon.tex:12410";
 Sk1_by_omega(k) = \
  1/3*( 3^k + w6^4*(w12_times_sqrt3)^k + conj(w6)^4*(conj(w12_times_sqrt3))^k );

gp_inline__location="../terdragon.tex:12415";
 Sk2_by_omega(k) = \
  1/3*( 3^k + w6^2*(w12_times_sqrt3)^k + conj(w6)^2*(conj(w12_times_sqrt3))^k );

gp_inline__location="../terdragon.tex:12429";
 Skd_by_norm(k,d) = 1/3*norm(b^k + w3^d) - 1/3;

gp_inline__location="../terdragon.tex:12433";
 Skd_by_abs(k,d) = \
   1/3*( geom_abs(b^k + w3^d)^2 - 1 );

gp_inline__location="../terdragon.tex:12440";
 s_vector = {[2,1,1,0,-1,-1,-2,-1,-1,0,1,1]};
 s(j) = vector_modulo(s_vector,j);

gp_inline__location="../terdragon.tex:12450";
 A214438(n) = vector_modulo(s_vector,n-1);

gp_inline__location="../terdragon.tex:12459";
 \\ generating function, per Maple code by R. J. Mathar in A214438,
 \\ first term n=-1 as x^0
 gA214438_fractions(x) = (1+x+2*x^2/3+x^3/3+x^4/9)/3 / (1 + x^6/27);

gp_inline__location="../terdragon.tex:12469";
 \\ per their Example 4, base b=3 page 645
 Borodin_Diaconis_Fulman_k(n) = {
   if(n < -1, return(0));
   if(n == -1, return(1/3));
   if(n%6==4, return(0));
   (-1)^floor((n+1)/6) * (1/3)^floor((n+3)/2) * 2^if(n%6==1,1,0);
 }
 Borodin_Diaconis_Fulman_samples = {[
    1/3,    1/3,    2/9,    1/9,    1/27,  0,
   -1/3^4, -1/3^4, -2/3^5, -1/3^5, -1/3^6, 0,
    1/3^7,  1/3^7,  2/3^8,  1/3^8,  1/3^9, 0
 ]};

gp_inline__location="../terdragon.tex:12489";
 S0_samples = {[1,2,4,9,24,72,225,702,2160,6561]};

gp_inline__location="../terdragon.tex:12500";
 S1_samples = {[0,1,4,12,33,90,252,729,2160,6480]};

gp_inline__location="../terdragon.tex:12511";
 S2_samples = {[0,0,1,6,24,81,252,756,2241,6642]};

gp_inline__location="../terdragon.tex:12521";
 A133474(n) = gf_term(x^3/((1-3*x)*(1-3*x+3*x^2)), n);

gp_inline__location="../terdragon.tex:12541";
 sd_vector = [ 2,3,1,0,-1,-3, -2,-3,-1,0,1,3 ];
 sd(j) = sd_vector[(j%12)+1];
 Skd_with_div(k,d) = (3^k + sd(k-4*d)*3^floor(k/2) )/3;

gp_inline__location="../terdragon.tex:12548";
 Skd_by_count(k,d) = sum(i=0,3^k-1, dir(i)%3==d);

gp_inline__location="../terdragon.tex:12553";
 gA092236(x) = ( - 4*x^2 + 4*x - 1) / ((3*x-1)*(3*x^2-3*x+1));
 gA135254(x) = x^2*(2*x-1) / ((3*x-1)*(3*x^2-3*x+1));
 gA133474(x) = -x^3 / ((3*x-1)*(3*x^2-3*x+1));
 gA135254_one_zero(x) = gA135254(x)/x;
 gA133474_two_zeros(x) = gA133474(x)/x;
 gAsum(x) = \
   gA092236(x) + gA135254_one_zero(x) + gA133474_two_zeros(x);

gp_inline__location="../terdragon.tex:12574";
 gS0(x) = ( 4*x^2 - 4*x + 1) / ((1-3*x)*(1-3*x+3*x^2));
 gS1(x) = (-2*x^2 +   x    ) / ((1-3*x)*(1-3*x+3*x^2));
 gS2(x) = (   x^2          ) / ((1-3*x)*(1-3*x+3*x^2));
 gSsum(x) = gS0(x) + gS1(x) + gS2(x);

gp_inline__location="../terdragon.tex:12676";
 poly(x) = x^3 - 6*x^2 + 12*x - 9;

gp_inline__location="../terdragon.tex:12709";
 Skd_by_recurrence(k,d) = \
   if(k<3,Skd(k,d), 6*Skd(k-1,d) - 12*Skd(k-2,d) + 9*Skd(k-3,d));

gp_inline__location="../terdragon.tex:12750";
 Skd_by_binomial(k,d) = sum(i=0,k, 2^(k-(3*i+d))*binomial(k,3*i+d));

gp_inline__location="../terdragon.tex:12791";
 SM(k,d) = 3^(k-1) + sm(k,d)*3^floor((k-1)/2);
 SM_from_Skd(k,d) = Skd(k,d+k);

gp_inline__location="../terdragon.tex:12801";
 SMkd_by_omega(k,d) =                \
    1/3*( 3^k                        \
        +      w3^d * sqrt3i^k  \
        + conj(w3^d * sqrt3i^k) \
    );

gp_inline__location="../terdragon.tex:12818";
 SM_by_norm(k,d) = 1/3*norm(sqrt3i^k + conj(w3)^d) - 1/3;

gp_inline__location="../terdragon.tex:12824";
 sm0_vector = {[2,0,-2,0]};

gp_inline__location="../terdragon.tex:12834";
 sm1_vector = {[-1,-1,1,1]};

gp_inline__location="../terdragon.tex:12844";
 sm2_vector = {[-1,1,1,-1]};

gp_inline__location="../terdragon.tex:12854";
 sm_vector_list = [sm0_vector, sm1_vector, sm2_vector];
 sm(k,d) = vector_modulo(vector_modulo(sm_vector_list,d),k);

gp_inline__location="../terdragon.tex:12865";
 SM0_samples = {[1,1,1,9,33,81,225,729,2241,6561]};

gp_inline__location="../terdragon.tex:12876";
 SM1_samples = {[0,0,4,12,24,72,252,756,2160,6480]};

gp_inline__location="../terdragon.tex:12887";
 SM2_samples = {[0,2,4,6,24,90,252,702,2160,6642]};

gp_inline__location="../terdragon.tex:12898";
 A101990_matrix = {[ 1, 0, 2;
                     2, 1, 0;
                     0, 2, 1 ]};
 SM_from_matrix(k,row) = (A101990_matrix^k * [1;0;0]) [row,1];

gp_inline__location="../terdragon.tex:12906";
 A101990_transposed = {[ 1, 2, 0;
                         0, 1, 2;
                         2, 0, 1 ]};
 M_swap23 = [1,0,0; 0,0,1; 0,1,0];
 SM_from_matrix23(k,row) = (A101990_transposed^k*[1;0;0])[row,1];

gp_inline__location="../terdragon.tex:12917";
 SM0_by_k2(k)= 1/3*(3^k + vector_modulo([2,0,-2,0],k)*3^floor(k/2));

gp_inline__location="../terdragon.tex:13006";
 SM2_by_floor(k) = \
   3^(k-1) - (-1)^ceil((k-1)/2) * (3)^floor((k-1)/2);

gp_inline__location="../terdragon.tex:13048";
 SN(n,d) = \
   1/3 * (n + 2*real(conj(w3)^d * terdragon_point(n)));
 SN_by_count(n,d) = d%=3; sum(j=0,n-1, dir(j)%3==d);

gp_inline__location="../terdragon.tex:13056";
 SN0_samples = {[0,1,1,2,2,2,2,3,3,4,4,4,4,4,5]};

gp_inline__location="../terdragon.tex:13063";
 SN1_samples = {[0,0,1,1,2,2,3,3,4,4,5,5,6,6,6]};

gp_inline__location="../terdragon.tex:13070";
 SN2_samples = {[0,0,0,0,0,1,1,1,1,1,1,2,2,3,3]};

gp_inline__location="../terdragon.tex:13176";
 gen_boundary_triangles_RT = 4;
 gen_boundary_triangles_LT = 4;
 gen_boundary_triangles_BT = 8;

gp_inline__location="../terdragon.tex:13210";
 BT(k) = 2^(k+1);

gp_inline__location="../terdragon.tex:13221";
 RT(k) = 2^k;
 LT(k) = RT(k);

gp_inline__location="../terdragon.tex:13232";
 VT(k) = RT(k);

gp_inline__location="../terdragon.tex:13334";
 BT1(k) = if(k==0, 2, 2^k);

gp_inline__location="../terdragon.tex:13336";
 BT1_samples = {[2,2,4,8,16]};

gp_inline__location="../terdragon.tex:13356";
 BT2(k) = if(k==0,0, 2^k);

gp_inline__location="../terdragon.tex:13360";
 BT2_samples = {[0,2,4,8,16,32]};

gp_inline__location="../terdragon.tex:13374";
 RT1(k) = BT1(k)/2;
 LT1(k) = RT1(k);
 RT1_samples = {[1,1,2,4,8,16]};

gp_inline__location="../terdragon.tex:13385";
 gA011782(x) = (1-x)/(1-2*x);

gp_inline__location="../terdragon.tex:13391";
 RT2(k) = BT2(k)/2;
 LT2(k) = RT2(k);
 RT2_samples = {[0,1,2,4,8,16]};

gp_inline__location="../terdragon.tex:13410";
 VT1(k) = RT2(k);
 VT2(k) = RT1(k);

gp_inline__location="../terdragon.tex:13477";
 B(k) = if(k==0, 2, 3*2^k);

gp_inline__location="../terdragon.tex:13479";
 B_samples = {[2,6,12,24,48,96]};

gp_inline__location="../terdragon.tex:13484";
 gB(x) = -1 + 3/(1-2*x);

gp_inline__location="../terdragon.tex:13498";
 R(k) = if(k==0, 1, 3*2^(k-1));

gp_inline__location="../terdragon.tex:13500";
 R_samples = {[1,3,6,12,24,48]};

gp_inline__location="../terdragon.tex:13508";
 gR(x) = -1/2 + (3/2)/(1-2*x);

gp_inline__location="../terdragon.tex:13527";
 V(k) = if(k==0, 2, 3*2^(k-1));

gp_inline__location="../terdragon.tex:13529";
 V_samples = {[2,3,6,12,24,48]};

gp_inline__location="../terdragon.tex:13538";
 gV(x) = 1/2 + (3/2)/(1-2*x);

gp_inline__location="../terdragon.tex:13687";
 Rpred_disallowed_pairs = Set([11, 12, 20]);

gp_inline__location="../terdragon.tex:13692";
 low_ternary_pair(n) = (n%3) + 10*((n\3)%3);
 Rpred_pair_is_disallowed(pair) = \
   setsearch(Rpred_disallowed_pairs,pair)!=0;
 Rpred_pair_is_allowed(pair) = ! Rpred_pair_is_disallowed(pair);
 Rpred(n) = {
   my(result=1);
   while(n,
     if(Rpred_pair_is_disallowed(low_ternary_pair(n)), return(0));
     n\=3);
   result;
 }

gp_inline__location="../terdragon.tex:13704";
Rpred_samples = {[1,1,1,1,0,0,0,1,1,1,1,1,0,0,0,0,0,0]};

gp_inline__location="../terdragon.tex:13818";
 Rpred_state_table = {[ 1,2,3;    \\ R=1
                        1,4,4;    \\ M=2
                        4,2,3;    \\ E=3
                        4,4,4 ]}; \\ non
 Rpred_R = 1;
 Rpred_M = 2;
 Rpred_E = 3;
 Rpred_non = 4;
 Rpred_transition(state,digit) = Rpred_state_table[state,digit+1];
 Rpred_transitions(state,v) = \
   for(i=1,#v, state=Rpred_transition(state,v[i])); state;
 Rpred_state_by_high_to_low(n) = \
   Rpred_transitions(Rpred_R,digits(n,3));
 Rpred_by_high_to_low(n) = Rpred_state_by_high_to_low(n)!=Rpred_non;

gp_inline__location="../terdragon.tex:13897";
 M(k) = if(k<=1,1, 3*2^(k-2));

gp_inline__location="../terdragon.tex:13899";
 M_samples = {[1,1,3,6,12,24,48,96]};

gp_inline__location="../terdragon.tex:13917";
 E(k) = if(k==0,1, k==1,2, 3*2^(k-2));

gp_inline__location="../terdragon.tex:13922";
 E_samples = {[1,2,3,6,12,24,48,96]};

gp_inline__location="../terdragon.tex:13958";
 E_from_sum(k) = E(0) + sum(i=0,k-1, M(i));
 E_from_sum2(k) = E(0) + M(0) + sum(i=0,k-2, R(i));
 E_from_sum3(k) = 1+1+1+ sum(i=1,k-2, 3*2^(i-1));

gp_inline__location="../terdragon.tex:13984";
 Rsides_v(v) = {
   my(state=Rpred_transitions(Rpred_R,v));
   if(state==Rpred_R,   1,
      state==Rpred_M,   2,
      state==Rpred_E,   2,
      state==Rpred_non, 3,
      error("oops, unknown Rpred state"));
 }
 Rsides(n) = Rsides_v(digits(n,3));

gp_inline__location="../terdragon.tex:13999";
 Rsides_by_Rpred_arithmetically(n) = \
   3 - Rpred(n)*vector_modulo([2,1,1],n);

gp_inline__location="../terdragon.tex:14004";
 Rsides_by_Rpred_and_low(n) = if(Rpred(n), if(n%3==0,1,2), 3);

gp_inline__location="../terdragon.tex:14008";
 Rsides_samples = {[1,2,2,1,3,3,3,2,2,1,2,2,3,3,3,3,3,3,3,3,3,1]};

gp_inline__location="../terdragon.tex:14041";
 Rsides_vector_by_morphism(k) = {
   my(v=[1]);
   for(i=1,k,
     my(l=List([]));
     for(j=1,#v,
       if(v[j]==1, listput(l,[1,2,2]),
          v[j]==2, v[j+1]==2||error(); j++;
                   listput(l,[1,3,3, 3,2,2]),
          v[j]==3, listput(l,[3,3,3]),
          error()));
     v=concat(Vec(l)));
   v;
 }

gp_inline__location="../terdragon.tex:14099";
 Rpred_LtoH_state_table = {[2,3,3;    \\ 1 = start
                            2,3,4;    \\ 2 = s0
                            2,4,3;    \\ 3 = s12
                            4,4,4 ]}; \\ 4 = non
 Rpred_LtoH_transition(state,digit) = \
   Rpred_LtoH_state_table[state,digit+1];
 Rpred_LtoH_transitions(state,v) = \
   for(i=1,#v, state=Rpred_LtoH_transition(state,v[i])); state;
 Rpred_LtoH_state(n,k) = \
   Rpred_LtoH_transitions(1, Vecrev(digits(n,3)));
 Rpred_by_LtoH(n,k) = Rpred_LtoH_state(n,k) != 4;

gp_inline__location="../terdragon.tex:14178";
 Rn_samples = {[0,1,2,3,7,8,9,10,11,21,25,26,27,28]};

gp_inline__location="../terdragon.tex:14195";
 Rn_samples_ternary = {[0,1,2,10,21,22,100,101,102,210,221,222,1000,1001]};

gp_inline__location="../terdragon.tex:14266";
 \\ Return a vector of digits of n written in
 \\ mixed radix low ternary then binary above.
 digits_mixed23(n) = concat(binary(n\3), [n%3]);

gp_inline__location="../terdragon.tex:14270";
 \\ Return an integer whose decimal digits are n written in
 \\ mixed radix low ternary then binary above.
 to_mixed23(n) = fromdigits(digits_mixed23(n));

gp_inline__location="../terdragon.tex:14276";
 \\ v is a vector of ternary digits.
 \\ Change each pair 1,NZ to 2,NZ where NZ is a non-zero digit.
 ternary_change12nz_vector(v) = \
   for(i=1,#v-1, if(v[i]==1 && v[i+1]!=0, v[i]=2)); v;
 ternary_change12nz(n) = \
   fromdigits(ternary_change12nz_vector(digits(n,3)),3);

gp_inline__location="../terdragon.tex:14287";
 Rn(m) =fromdigits(ternary_change12nz_vector(digits_mixed23(m)),3);

gp_inline__location="../terdragon.tex:14292";
 \\ v is a vector of ternary digits.
 \\ Flip each pair 1<->2 at each place 1,NZ or 2,NZ.
 ternary_flip12nz_vector(v) = \
   for(i=1,#v-1, if(v[i]&&v[i+1],v[i]=3-v[i])); v;
 ternary_flip12nz(n) = \
   fromdigits(ternary_flip12nz_vector(digits(n,3)),3);

gp_inline__location="../terdragon.tex:14337";
 Rn_pairs_allowed = [10, 0, 21, 1, 22, 2];
 all_pairs = [0,1,2, 10,11,12, 20,21,22];

gp_inline__location="../terdragon.tex:14364";
 g012(x) = (0+x+2*x^2)/(1-x^3);

gp_inline__location="../terdragon.tex:14382";
 \\ gf 1 where n has bit(k) = 1
 gBitK(x,k) = (x^(2^k) - x^(2*2^k)) / (1-x) / (1 - x^(2*2^k));

gp_inline__location="../terdragon.tex:14405";
 \\ where n has bit(k) = 1 and bit(k+1) = 1
 gBit11K(x,k) = {
   k>=1 || error("gBit11K() is for k>=1");
   (x^(3/2*2^k) - x^(2*2^k)) / (1-x) / (1 - x^(2*2^k));
 }

gp_inline__location="../terdragon.tex:14447";
 \\ "limit" is biggest k in the sum, limit>=0.
 \\ This gives limit+2 many ternary digits in the coeffs.
 gRn(x,limit) = {
   limit>=0 || error();
   g012(x)
   + 3*(1+x+x^2)*gBitK(x^3,0)
   + 3*(x^4+x^5)/(1-x^6)
   + 3*(1+x+x^2)
     * sum(k=1,limit, 3^k*( gBitK(x^3,k) + gBit11K(x^3,k) ));
 }

gp_inline__location="../terdragon.tex:14480";
 \\ Term giving ternary digit position k in each coeff.
 \\ Digit position 0 least significant.
 gRn_term(x,k) = {
   k>=0 || error();
   if(k==0, return( (x + 2*x^2) / (1-x^3) ));
   if(k==1, return( 3 * (x^3 + 2*x^4 + 2*x^5) / (1-x^6) ));
   k-=2;
   9 *   3^k*( x^(6*2^k) + x^(9*2^k)  - 2*x^(12*2^k)
             ) / (1-x) / (1 - x^(12*2^k));
 }

gp_inline__location="../terdragon.tex:14520";
 A300067(n) = vector_modulo([0,0,0,1,2,2],n); \\ OFFSET=0

gp_inline__location="../terdragon.tex:14696";
 Lpred_v(v) = {
   for(i=1,#v-1, if((v[i]==0 && v[i+1]==2)
                 || (v[i]==1 && v[i+1]==0)
                 || (v[i]==1 && v[i+1]==1), return(0)));
   1;
 }
 Lpred_is_pair_disallowed(pair) = pair==2 || pair==10 || pair==11;
 Lpred_is_pair_allowed(pair) = ! Lpred_is_pair_disallowed(pair);

gp_inline__location="../terdragon.tex:14707";
 Lpred_state_table = {[ 3,2,1;    \\ L=1
                        4,4,1;    \\ M=2
                        3,2,4;    \\ E=3
                        4,4,4 ]}; \\ non
 Lpred_L = 1;
 Lpred_M = 2;
 Lpred_E = 3;
 Lpred_non = 4;
 Lpred_transition(state,digit) = Lpred_state_table[state,digit+1];
 Lpred_transitions(state,v) = {
   for(i=1,#v, state=Lpred_transition(state,v[i]));
   state;
 }
 Lpred_k_by_states(k,n) = \
   Lpred_transitions(Lpred_L, ternary_padded(n,k)) != Lpred_non;
 LpredInf_by_states(n) = \
   Lpred_transitions(Lpred_E, digits(n,3)) ! =Lpred_non;

gp_inline__location="../terdragon.tex:14737";
 Lpred_disallowed_pairs = Set([02, 10, 11]);

gp_inline__location="../terdragon.tex:14739";
 Lpred_k(k,n) = Lpred_v(ternary_padded(n,k));

gp_inline__location="../terdragon.tex:14748";
 Lpred_0_samples = {[1]};

gp_inline__location="../terdragon.tex:14756";
 Lpred_1_samples = {[1,1,1]};

gp_inline__location="../terdragon.tex:14764";
 Lpred_2_samples = {[1,1,0,0,0,1,1,1,1]};

gp_inline__location="../terdragon.tex:14778";
 LpredInf(n) = Lpred_v(concat(0,digits(n,3)));

gp_inline__location="../terdragon.tex:14785";
 LpredInf_n_to_k(n) = if(n==0,0,length(digits(n,3))+1);
 LpredInf_n_to_k_by_search(n) = \
   for(k=0,n+1, if(3^k-1>=3*n, return(k))); error();

gp_inline__location="../terdragon.tex:14793";
 LpredInf_samples = {[1,1,0,0,0,1,0,0,0,0]};

gp_inline__location="../terdragon.tex:14808";
 LpredInf_n_samples = {[0,1,5,15,16,17,45,46,50,51,52,53]};

gp_inline__location="../terdragon.tex:14817";
 LpredInf_n_samples_ternary = {[0,1,12,120,121,122,1200,1201,1212,1220,1221,1222]};

gp_inline__location="../terdragon.tex:14831";
 LpredAll(n) = Lpred_v(digits(n,3));

gp_inline__location="../terdragon.tex:14833";
 LpredAll_samples = {[1,1,1,0,0,1,1,1,1,0]};

gp_inline__location="../terdragon.tex:14846";
 LpredAll_n_samples = {[0,1,2,5,6,7,8,15,16,17,18,19,23,24,25,26]};

gp_inline__location="../terdragon.tex:14855";
 LpredAll_n_samples_ternary = {[0,1,2,12,20,21,22,120,121,122,200,201,212,220,221,222]};

gp_inline__location="../terdragon.tex:14891";
 Lsides_v(v) = Rsides_v(apply(n->2-n,v));
 Lsides_k(k,n) = Lsides_v(ternary_padded(n,k));

gp_inline__location="../terdragon.tex:14904";
 Lsides_k_by_states(k,n) = {
   my(state=Lpred_transitions(Lpred_L,ternary_padded(n,k)));
   if(state==Lpred_L,   1,
      state==Lpred_M,   2,
      state==Lpred_E,   2,
      state==Lpred_non, 3,
      error("oops, unknown state"));
 }

gp_inline__location="../terdragon.tex:14917";
 Lsides_0_samples = {[1]};

gp_inline__location="../terdragon.tex:14925";
 Lsides_1_samples = {[2,2,1]};

gp_inline__location="../terdragon.tex:14933";
 Lsides_2_samples = {[2,2,3,3,3,1,2,2,1]};

gp_inline__location="../terdragon.tex:14944";
 LsidesInf(n) = Lsides_k(length(digits(n,3))+1, n);

gp_inline__location="../terdragon.tex:14948";
 LsidesInf_by_states(n) = {
   my(state=Lpred_transitions(Lpred_E,digits(n,3)));
   if(state==Lpred_L,1,
      state==Lpred_M,2,
      state==Lpred_E,2,
      state==Lpred_non,3,
      error("oops, unknown state"));
 }

gp_inline__location="../terdragon.tex:14960";
 LsidesInf_samples = {[2,2,3,3,3,1,3,3,3,3,3,3,3,3,3,2,2,1,3,3,3,3]};

gp_inline__location="../terdragon.tex:15146";
 Ln_table = {[0,0,0;0,1,0;0,2,1;1,0,2;1,1,2;1,2,2]};

gp_inline__location="../terdragon.tex:15158";
 \\ Ln_matrix[digit,digit_below] = new_digit
 Ln_matrix = matrix(2,3,i,j, 'none);
 for(i=1,matsize(Ln_table)[1], \
   Ln_matrix[Ln_table[i,1]+1, Ln_table[i,2]+1] = Ln_table[i,3]);
 Ln_transform_vector(v) = {
   forstep(i=#v-1,1,-1,
     v[i] = Ln_matrix[v[i]+1, v[i+1]+1]);
   v;
 }
 Ln_transform(v) = fromdigits(Ln_transform_vector(v),3);

gp_inline__location="../terdragon.tex:15171";
 Ln_k(k,m) = {
   m>=0 || error("Ln_k() is for m>=0");
   if(k==0,
      m==0 || error("Ln_k() is m>=0");
      return(0));
   Ln_transform(concat(binary_padded(m\3,k-1), m%3));
 }
 Ln_inf(m) = {
   m>=0 || error("Ln_inf() is for m>=0");
   Ln_transform(concat([0, binary(m\3), m%3]));
 }

gp_inline__location="../terdragon.tex:15185";
 Ln_all(m) = {
   m>=0 || error("Ln_all() is for m>=0");
   if(m<=2,return(m));
   if(m==3,return(5));
   m+=2;
   my(v=concat(binary(m\3), m%3));
   if(v[1]==1&&v[2]==0, v=v[2..#v];v[1]=1,
      v[1]==1&&v[2]==1,            v[1]=0);
   Ln_transform(v);
 }

gp_inline__location="../terdragon.tex:15221";
 Ln_pairs_allowed = [20, 0, 21, 1, 22, 12];

gp_inline__location="../terdragon.tex:15299";
 is_pow3(n) = n >= 1 && (n == 3^valuation(n,3));

gp_inline__location="../terdragon.tex:15302";
 is_both_boundaries(k,n) = {
   if(k==0, n==0,
      k==1, n>=0&&n<=2,
      n==0||n==1||is_pow3(n+1)||is_pow3(n+2));
 }
 is_both_boundaries_any_k(n) = n<=2 || is_pow3(n+1) || is_pow3(n+2);

gp_inline__location="../terdragon.tex:15394";
 Rturn(m) = {
   if(m%3==2, return(-1));
   my(h=m-floor(m/3));
   if(BitAboveLowestOne(h)==0, 1, 0);
 }

gp_inline__location="../terdragon.tex:15408";
 Rturn_samples = {[+1,-1,+1,0,-1,+1,+1,-1,0,0,-1,+1,+1,-1]};

gp_inline__location="../terdragon.tex:15773";
 A(k) = if(k==0,0, 2*( 3^(k-1)-2^(k-1) ));

gp_inline__location="../terdragon.tex:15775";
 A_samples = {[0,0,2,10,38,130,422,1330,4118]};

gp_inline__location="../terdragon.tex:15782";
 A056182(n) = {
   n>=0 || error();
   2*(3^n-2^n);
 }

gp_inline__location="../terdragon.tex:15806";
 AR(k) = if(k==0,0, 3^(k-1)-2^(k-1));
 AL(k) = AR(k);

gp_inline__location="../terdragon.tex:15810";
 AR_samples = {[0,0,1,5,19,65,211,665,2059]};

gp_inline__location="../terdragon.tex:16017";
 TurnRuns2_formula(k) = 3^(k-1) - 1;
 TurnRuns2(k) = {
   k>=0 || error("A is for k>=0");
   if(k==0,0, TurnRuns2_formula(k));
 }

gp_inline__location="../terdragon.tex:16023";
 TurnRuns2_by_count(k) = {
   my(v=TurnRun_vector(k));
   sum(i=1,#v,v[i]==2);
 }

gp_inline__location="../terdragon.tex:16029";
 TurnRuns2_samples = {[0,0,2,8,26,80,242]};

gp_inline__location="../terdragon.tex:16049";
 Turn2_formula(k) = 3^(k-1) + 1;
 Turn2(k) = if(k==0,0, Turn2_formula(k));

gp_inline__location="../terdragon.tex:16053";
 \\ Look for runs of "value" within the turn() sequence.
 \\ Return vector [c1,c2,c3] counts of how many runs of length
 \\ 1,2,3 occur between n=1 to n=3^k-1 inclusive.
 turn_count_runs(k,value) = {
   my(prev=0, len=0, runs=[0,0,0]);
   for(n=1,3^k-1,
       my(t = turn(n));
       if(prev==value && t==value, len++,        \\ continue run
          prev==value && t!=value, runs[len]++,  \\ end run
          prev!=value && t==value, len=1);       \\ start run
       prev=t);
   if(prev==value, runs[len]++);
   runs;
 }

gp_inline__location="../terdragon.tex:16148";
 TurnRuns2_over_A_limit = {1/2};

gp_inline__location="../terdragon.tex:16189";
 TurnRuns2pairs(k) = if(k<=1,0, 3^(k-2));

gp_inline__location="../terdragon.tex:16197";
 TurnRuns2pairs_LLRR(k) = {
   my(v=vector(3^k-1,n, turn(n)));
   sum(i=1,#v-3,
       v[i]  ==1  && v[i+1]==1 &&
       v[i+2]==-1 && v[i+3]==-1);
 }

gp_inline__location="../terdragon.tex:16206";
 TurnRuns2pairs_RRLL(k) = {
   my(v=vector(3^k-1,n, turn(n)));
   sum(i=1,#v-3,
       v[i]  ==-1 && v[i+1]==-1 &&
       v[i+2]==1  && v[i+3]==1);
 }

gp_inline__location="../terdragon.tex:16367";
 J(k) = {
   k>=0 || error("J(k) no k<0");
   if(k==0,0, 2^(k-1));
 }

gp_inline__location="../terdragon.tex:16373";
 J_samples = {[0,1,2,4,8,16,32,64]};

gp_inline__location="../terdragon.tex:16449";
 J_from_A(k) = (A(k+1)-3*A(k))/2;

gp_inline__location="../terdragon.tex:16520";
 H(k) = if(k<=2,0, 2^(k-2));

gp_inline__location="../terdragon.tex:16522";
 H_samples = {[0,0,0,2,4,8,16,32]};

gp_inline__location="../terdragon.tex:16541";
 HR(k) = if(k<=2,0, 2^(k-3));

gp_inline__location="../terdragon.tex:16544";
 HR_samples = {[0,0,0,1,2,4,8,16]};

gp_inline__location="../terdragon.tex:16637";
 HR_by_sum(k) = if(k<=2,0, 1+sum(i=0,k-4, 2^i));

gp_inline__location="../terdragon.tex:16748";
 Tperm(n) = {
   my(pow=1);
   while(pow<n,
     my(pair=(n\pow)%9);
     if(pair==3,n+=3*pow, pair==6,n-=3*pow);
     pow*=3);
    n;
 }

gp_inline__location="../terdragon.tex:16757";
 Tperm_digits(v) = {
   for(i=1,#v-1, if(v[i]!=0 && v[i+1]==0, v[i]=3-v[i]));
   v;
 }
 Tperm_by_digits(n) = fromdigits(Tperm_digits(digits(n,3)),3);

gp_inline__location="../terdragon.tex:16769";
 Tperm_samples = {[0,1,2,6,4,5,3,7,8,18,19,20,15,13,14,12,16]};

gp_inline__location="../terdragon.tex:16778";
 Tperm_samples_ternary = {[0,1,2,20,11,12,10,21,22,200,201,202,120,111]};

gp_inline__location="../terdragon.tex:16846";
 vertex_mod3(x,y) = (x + y) % 3;

gp_inline__location="../terdragon.tex:17075";
 S(k) = if(k==0,2, 2^k+2);

gp_inline__location="../terdragon.tex:17078";
 S_samples = {[2,4,6,10,18,34,66,130,258]};

gp_inline__location="../terdragon.tex:17099";
 D(k) = if(k==0,0, 2^k-2);

gp_inline__location="../terdragon.tex:17102";
 D_samples = {[0,0,2,6,14,30,62,126,254]};

gp_inline__location="../terdragon.tex:17122";
 T_formula(k) = 3^(k-1) - 2*2^(k-1) + 1;
 T(k) = if(k==0,0, T_formula(k));

gp_inline__location="../terdragon.tex:17130";
 T_samples = {[0,0,0,2,12,50,180,602,1932]};

gp_inline__location="../terdragon.tex:17139";
 A028243(n) = {
   n >= 1 || error();
   3^(n-1) - 2*2^(n-1) + 1;
 }

gp_inline__location="../terdragon.tex:17238";
 S_by_sum(k) = 2 + sum(j=0,k-1,BT1(j));

gp_inline__location="../terdragon.tex:17243";
 D_by_sum(k) = sum(j=0,k-1,BT2(j));

gp_inline__location="../terdragon.tex:17417";
 S_by_join(k) = if(k==0,2, k==1,4, \
                3*S(k-1) + 2*( -(J(k-1)-1) - 3));

gp_inline__location="../terdragon.tex:17424";
 D_by_join(k) = if(k<2,0, \
                3*D(k-1) + 2*( -(J(k-1)-1) + 1));

gp_inline__location="../terdragon.tex:17434";
 T_by_join(k) = if(k<2,0, \
                3*T(k-1) + 2*(  J(k-1)-1 ));

gp_inline__location="../terdragon.tex:17577";
 TB_formula(k) = 3*2^(k-2) - 4;
 TB(k) = if(k<=2,0, TB_formula(k));

gp_inline__location="../terdragon.tex:17583";
 TB_samples = {[0,0,0,2,8,20,44,92,188]};

gp_inline__location="../terdragon.tex:17590";
 A131128(n) = if(n==0,1, 3*2^n - 4);

gp_inline__location="../terdragon.tex:17599";
 Bpred_k(k,n) = Rpred(n) || Lpred_k(k,n);

gp_inline__location="../terdragon.tex:17628";
 P_power_formula(k) = 3^(k-1) + 2^k + 1;
 P(k) = if(k==0,2, P_power_formula(k));

gp_inline__location="../terdragon.tex:17634";
 P_samples = {[2,4,8,18,44,114,308,858]};

gp_inline__location="../terdragon.tex:17682";
 Visits_k(k,n) = {
   n<=3^k || error("Visits_k() is for n <= 3^k");
   if(n==0, return(1));
   my(l=0);
   while(n%3==0, n/=3; l++);
   if(n%3==1,Rsides(n\3),Lsides_k(k-l-1,n\3));
 }

gp_inline__location="../terdragon.tex:17693";
 Visits_0_samples = {[1,1]};

gp_inline__location="../terdragon.tex:17701";
 Visits_1_samples = {[1,1,1,1]};

gp_inline__location="../terdragon.tex:17709";
 Visits_2_samples = {[1,1,2,1,2,2,1,2,1,1]};

gp_inline__location="../terdragon.tex:17726";
 VisitsInf(n) = Visits_k(#digits(n,3)+1,n);

gp_inline__location="../terdragon.tex:17729";
 VisitsInf_samples = {[1,1,2,1,2,2,2,2,3,1,1,3,2,3,3,2,3,1,2,3]};

gp_inline__location="../terdragon.tex:17738";
 VisitsInf_eq1_n_samples = {[0,1,3,9,10,17,27,28,30,51,53,64]};

gp_inline__location="../terdragon.tex:17752";
 VisitsInf_eq2_n_samples = {[2,4,5,6,7,12,15,18,21,22,25,31]};

gp_inline__location="../terdragon.tex:17767";
 VisitsInf_eq3_n_samples = {[8,11,13,14,16,19,20,23,24,26,29,32]};

gp_inline__location="../terdragon.tex:17788";
 Visits_k_by_other(k,n) = {
   if(n==0,return(1));
   my(n_hi=3^k);
   sum(delta=0,2, my(nd=terdragon_other_n(n,delta));
                  nd>=0 && nd<=n_hi);
 }

gp_inline__location="../terdragon.tex:17804";
 VisitsInf_by_other(n) = {
   if(n==0,return(1));
   sum(delta=0,2, terdragon_other_n(n,delta)>=0);
 }

gp_inline__location="../terdragon.tex:17827";
 sum_Visits_k(k) = 3*3^k - 4*2^k + 3;

gp_inline__location="../terdragon.tex:17829";
 sum_Visits_k_samples = {[2,4,14,52,182,604,1934]};

gp_inline__location="../terdragon.tex:17853";
 Lines_by_unpoint(k) = {
   my(debug=0);
   my(limit=3^k,counts=vector(3));
   for(n=0,limit-1,
     my(z=terdragon_point(n),
        d=dir(n)%3,
        na=terdragon_unpoint(z-w3^d,d));
     if(debug,print("n="n" at z="z" d="d
                    " preceding "na
                    " is ",(na[1]>limit || na[2]!=0)));
     counts[d+1] += (na[1]>limit || na[2]!=0));
   counts;
 }

gp_inline__location="../terdragon.tex:17960";
 Lines(k) = 2^(k+1) - 1;

gp_inline__location="../terdragon.tex:17962";
 Lines_samples = {[1,3,7,15,31,63,127,255]};

gp_inline__location="../terdragon.tex:18061";
 Lines_by_direction_0(k) = 1/3*(2^(k+1) + ld(k));

gp_inline__location="../terdragon.tex:18067";
 Lines_by_direction_1(k) = 1/3*(2^(k+1) - ld(k-1));

gp_inline__location="../terdragon.tex:18073";
 Lines_by_direction_2(k) = 1/3*(2^(k+1) - ld(k+1));
 Lines_by_direction_functions = \
   [Lines_by_direction_0,Lines_by_direction_1,Lines_by_direction_2];
 Lines_by_direction(k,d) = \
   vector_modulo(Lines_by_direction_functions,d)(k);

gp_inline__location="../terdragon.tex:18082";
 ld_vector = {[1,2,4,5,4,2]};

gp_inline__location="../terdragon.tex:18086";
 ld(m) = vector_modulo(ld_vector,m);

gp_inline__location="../terdragon.tex:18094";
 Lines_by_direction_0_samples = {[1,2,4,7,12,22,43,86,172,343,684]};

gp_inline__location="../terdragon.tex:18102";
 Lines_by_direction_1_samples = {[0,1,2,4,9,20,42,85,170,340,681]};

gp_inline__location="../terdragon.tex:18110";
 Lines_by_direction_2_samples = {[0,0,1,4,10,21,42,84,169,340,682]};

gp_inline__location="../terdragon.tex:18189";
 RTS_dir(n) = {
   my(s=Rsides(n));
   if(s==3, return(-1));
   my(d=dir(n)%3);
   if(s==1, return(d));
   my(next_z=terdragon_point(n+1));
   my(next_n_and_arm=terdragon_unpoint(next_z,d-1));
   if(next_n_and_arm[2]!=0,return(-1)); \\ second side of 2-side
   (d+1)%3;
 }
 RTS_by_count(k,d) = sum(n=0,3^k-1, RTS_dir(n)==d);

gp_inline__location="../terdragon.tex:18227";
 RTS_vector = {[2,1,-1,-2,-1,1]};

gp_inline__location="../terdragon.tex:18234";
 RTS(k,d) = 1/3*(2^k + vector_modulo(RTS_vector,k+2*d));

gp_inline__location="../terdragon.tex:18243";
 A057079(n) = vector_modulo(RTS_vector,n+5);

gp_inline__location="../terdragon.tex:18249";
 RTS_0_samples = {[1,1,1,2,5,11,22,43,85,170,341]};

gp_inline__location="../terdragon.tex:18260";
 A024493(n) = RTS(n,0);

gp_inline__location="../terdragon.tex:18270";
 RTS_1_samples = {[0,0,1,3,6,11,21,42,85,171,342]};

gp_inline__location="../terdragon.tex:18282";
 A024495(n) = RTS(n,1);

gp_inline__location="../terdragon.tex:18296";
 RTS_2_samples = {[0,1,2,3,5,10,21,43,86,171,341]};

gp_inline__location="../terdragon.tex:18307";
 A131708(n) = RTS(n,2);

gp_inline__location="../terdragon.tex:18359";
 n_to_n_list(n) = {
   my(l=List([]));
   for(delta=0,2,
       my(nd=terdragon_other_n(n,delta));
       if(nd>=0, listput(l,nd)));
   Vec(l);
 }
 SD_dir(k,n) = {
   my(v=n_to_n_list(n));
   v=select(n->n<3^k,v);
   if(#v==3,return(-1));
   if(#v==1,return((dir(n)+turn(n)) % 3));
   v=vecsort(v);
   \\ print("n list "v);
   if(v[1]!=n,return(-1));  \\ second visit
   v=apply(n->(dir(n)+turn(n))%3, v);
   \\ print("singles d "v);
   my(seen=vector(3));
   for(i=1,#v,seen[v[i]+1]=1);
   vecsum(seen)==2 || error(seen);
   for(d=1,#seen, if(!seen[d],return(d-1)));
   error();
 }
 SD_by_count(k,d) = sum(n=1,3^k-1, SD_dir(k,n)==d);

gp_inline__location="../terdragon.tex:18403";
 SD(k,d) = 2*sum(j=0,k-1,RTS(j,d+1));

gp_inline__location="../terdragon.tex:18415";
 SD_0_samples = {[0,0,0,2,8,20,42,84,168,338]};

gp_inline__location="../terdragon.tex:18438";
 A111927(n) = SD(n,0) / 2;

gp_inline__location="../terdragon.tex:18444";
 SD_1_samples = {[0,0,2,6,12,22,42,84,170,342]};

gp_inline__location="../terdragon.tex:18465";
 SD_2_samples = {[0,2,4,6,10,20,42,86,172,342]};

gp_inline__location="../terdragon.tex:18531";
 Lines_by_SD(k,d) = 1/2*(SD(k,d+1) + SD(k,d+2) + if(d%3==0,2));

gp_inline__location="../terdragon.tex:18548";
 Cournot_p3_y0(n) = A111927(n);

gp_inline__location="../terdragon.tex:18571";
 Cournot_p3_y1(n) = A131708(n);

gp_inline__location="../terdragon.tex:18581";
 Cournot_p3_y2(n) = A024495(n);

gp_inline__location="../terdragon.tex:18600";
 Cournot_p2_y0(n) = 1/2*2^n - 1;
 Cournot_p2_y1(n) = 1/2*2^n;

gp_inline__location="../terdragon.tex:18608";
 Cournot_p4_y0(n) = 1/4*2^n + 1/2*sqrt(2)^n*cos(1/4*Pi*n) - 1;
 Cournot_p4_y1(n) = 1/4*2^n + 1/2*sqrt(2)^n*sin(1/4*Pi*n);
 Cournot_p4_y2(n) = 1/4*2^n - 1/2*sqrt(2)^n*cos(1/4*Pi*n);
 Cournot_p4_y3(n) = 1/4*2^n - 1/2*sqrt(2)^n*sin(1/4*Pi*n);

gp_inline__location="../terdragon.tex:18665";
 RTS_by_binomial(k,d) = d=(-d)%3; sum(j=0,k, binomial(k,d+3*j));

gp_inline__location="../terdragon.tex:18730";
 SD_by_binomial(k,d) = \
   d+=1; d=-d; d%=3; 2*sum(i=0,k-1, sum(j=0,i, binomial(i,d+3*j)));

gp_inline__location="../terdragon.tex:18735";
 SD_0_by_binomial(k) = \
   2 * sum(i=0,k-1, sum(j=0,i, binomial(i,2+3*j)));

gp_inline__location="../terdragon.tex:18810";
 Lines_0_by_binomial(k) = \
  1 + sum(i=0,k-1, sum(j=0,i, binomial(i,0+3*j)+binomial(i,1+3*j)));

gp_inline__location="../terdragon.tex:18816";
 Lines_1_by_binomial(k) = \
   sum(i=0,k-1, sum(j=0,i, binomial(i,0+3*j)+binomial(i,2+3*j)));

gp_inline__location="../terdragon.tex:18822";
 Lines_2_by_binomial(k) = \
   sum(i=0,k-1, sum(j=0,i, binomial(i,1+3*j)+binomial(i,2+3*j)));

gp_inline__location="../terdragon.tex:18838";
 RT_1_d0_samples = [1,1,1,1,1,1,2,8,29,85,211,463,926];
 RT_1_d1_samples = [0,0,1,3,6,10,15,21,29,45,90,220,561];
 RT_1_d2_samples = [0,0,0,0,1,5,15,35,70,126,211,341,561];
 RT_2_d0_samples = [0,0,0,1,4,10,20,35,56,85,130,220,440];
 RT_2_d1_samples = [0,0,0,0,0,1,6,21,56,126,252,463,804];
 RT_2_d2_samples = [0,1,2,3,4,5,6,8,16,45,130,341,804];

gp_inline__location="../terdragon.tex:18845";
 RT_1_d0(k) = sum(i=0,k,binomial(k,6*i));

gp_inline__location="../terdragon.tex:18848";
 RT_2_d2(k) = sum(i=0,k,binomial(k,6*i+1));

gp_inline__location="../terdragon.tex:18853";
 RT_1_d1(k) = sum(i=0,k,binomial(k,6*i+2));

gp_inline__location="../terdragon.tex:18857";
 RT_2_d0(k) = sum(i=0,k,binomial(k,6*i+3));

gp_inline__location="../terdragon.tex:18860";
 RT_1_d2(k) = sum(i=0,k,binomial(k,6*i+4));

gp_inline__location="../terdragon.tex:18863";
 RT_2_d1(k) = sum(i=0,k,binomial(k,6*i+5));
 gRT_2_d1(x) = 1/((1-x)^6-x^6);
 gRT_2_d1_partial_fractions(x) = \
     16/3/(1 - 2*x) \
   + (1/12 - 1/12*sqrt3i)/(1 - conj(w6)*x)  \
   + (1/12 + 1/12*sqrt3i)/(1 -      w6 *x)  \
   + (-9/4 + 3/4*sqrt3i) /(1 - conj(w12_times_sqrt3)*x) \
   + (-9/4 - 3/4*sqrt3i) /(1 -      w12_times_sqrt3 *x);

gp_inline__location="../terdragon.tex:18877";
 RTS_d0_by_1_2(k) = RT_1_d0(k) + RT_2_d0(k);

gp_inline__location="../terdragon.tex:18880";
 RTS_d1_by_1_2(k) = RT_1_d1(k) + RT_2_d1(k);

gp_inline__location="../terdragon.tex:18883";
 RTS_d2_by_1_2(k) = RT_1_d2(k) + RT_2_d2(k);

gp_inline__location="../terdragon.tex:19000";
 RsideNum_state_table = {[ 1,1,2;    \\ 1
                           3,1,2;    \\ 2
                           3,2,3 ]}; \\ 3
 RsideNum_transition(state,digit) = \
   RsideNum_state_table[state,digit+1];
 RsideNum_transitions(state,v) = \
   for(i=1,#v, state=RsideNum_transition(state,v[i])); state;

gp_inline__location="../terdragon.tex:19054";
 RsideNum(n) = RsideNum_transitions(1,digits(n,3));

gp_inline__location="../terdragon.tex:19056";
 RsideNum_samples = {[1,1,2,1,1,2,3,1,2,1,1,2,1,1,2,3,1,2]};

gp_inline__location="../terdragon.tex:19065";
 RsideNum1_at_samples = {[0,1,3,4,7,9,10,12,13,16]};

gp_inline__location="../terdragon.tex:19078";
 RsideNum2_at_samples = {[2,5,8,11,14,17,19,23,26,29]};

gp_inline__location="../terdragon.tex:19090";
 RsideNum3_at_samples = {[6,15,18,20,24,33,42,45,47,51]};

gp_inline__location="../terdragon.tex:19199";
 LsideNum_state_table = {[ 1,2,1;    \\ 1
                           2,3,1;    \\ 2
                           2,3,3 ]}; \\ 3
 LsideNum_transition(state,digit) = \
   LsideNum_state_table[state,digit+1];
 LsideNum_transitions(state,v) = \
   for(i=1,#v, state=LsideNum_transition(state,v[i])); state;

gp_inline__location="../terdragon.tex:19252";
 LsideNum(n) = LsideNum_transitions(1,digits(n,3));

gp_inline__location="../terdragon.tex:19254";
 LsideNum_samples = {[1,2,1,2,3,1,1,2,1,2,3,1,2,3,3,1,2,1]};

gp_inline__location="../terdragon.tex:19263";
 LsideNum1_at_samples = {[0,2,5,6,8,11,15,17,18,20]};

gp_inline__location="../terdragon.tex:19273";
 LsideNum2_at_samples = {[1,3,7,9,12,16,19,21,25,27]};

gp_inline__location="../terdragon.tex:19283";
 LsideNum3_at_samples = {[4,10,13,14,22,28,31,32,37,40]};

gp_inline__location="../terdragon.tex:19639";
 EpredR(n) = (RsideNum(n) == 3);

gp_inline__location="../terdragon.tex:19647";
 EpredR_by_20(n) = {
   my(v=digits(n,3),ones_ok=1);
   forstep(i=#v,1,-1, \\ low to high
     if(i<#v && v[i]==2 && v[i+1]==0, return(ones_ok));
     if(v[i]==1 && ! (i<#v && v[i+1]==0), ones_ok=0));
   0;
 }

gp_inline__location="../terdragon.tex:19663";
 EpredR_by_mod(n) = {
   if(n%3==1, return(0));
   my(v = digits(n,3));
   forstep(i=#v-1,1,-1, \\ low to high
     if(v[i]==2 && v[i+1]==0, return(1));
     if(v[i]==1 && v[i+1]==1, return(0));
     if(v[i]==1 && v[i+1]==2, return(0)));
   0;
 }

gp_inline__location="../terdragon.tex:19675";
 EpredR_samples = {[0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0]};

gp_inline__location="../terdragon.tex:19692";
 EpredL(n) = (LsideNum(n) == 3);

gp_inline__location="../terdragon.tex:19700";
 vector_collapse_0s(v) = {
   my(l=List());
   for(i=1,#v,
       if(v[i]==0 && i<#v && v[i+1]==0, , \\ skip
          listput(l,v[i])));
   Vec(l);
 }
 EpredL_by_11(n) = {    \\ WRONG
   my(v=digits(n,3), zeros_ok=1);
   v=vector_collapse_0s(v);
   forstep(i=#v,1,-1, \\ low to high
     if(i<#v && v[i]==1 && v[i+1]==1, return(zeros_ok));
     if(v[i]==0 && ! (i<#v && v[i+1]==1), zeros_ok=0));
   0;
 }

gp_inline__location="../terdragon.tex:19724";
 EpredL_by_mod(n) = {
   if(n%3==0, return(0));
   my(v = digits(n,3));
   forstep(i=#v-1,1,-1,  \\ low to high
     if(v[i]==1 && v[i+1]==0, return(1));
     if(v[i]==1 && v[i+1]==1, return(1));
     if(v[i]==0 && v[i+1]==2, return(0)));
   0;
 }

gp_inline__location="../terdragon.tex:19736";
 EpredL_samples = {[0,0,0,0,1,0,0,0,0,0,1,0,0,1,1,0,0,0]};

gp_inline__location="../terdragon.tex:19763";
 \\                     digit 0 1 2
 EpredR_LtoH_state_table = {[ 1,3,0;     \\ 0 = rm0
                              1,0,2;     \\ 1 = rm1
                              2,2,2;     \\ 2 = right enc
                              3,3,3 ]};  \\ 3 = not
 EpredR_LtoH_transition(state,digit) = \
   EpredR_LtoH_state_table[state+1,digit+1];
 EpredR_LtoH_transitions(state,v) = \
   for(i=1,#v, state=EpredR_LtoH_transition(state,v[i])); state;

gp_inline__location="../terdragon.tex:19773";
 EpredR_by_LtoH(n) = \
   EpredR_LtoH_transitions(0,Vecrev(digits(n,3)))==2;

gp_inline__location="../terdragon.tex:19807";
 \\                     digit 0 1 2
 EpredL_LtoH_state_table = {[ 3,1,0;     \\ 0 = lm0
                              1,2,0;     \\ 1 = lm1
                              2,2,2;     \\ 2 = left enc
                              3,3,3 ]};  \\ 3 = not
 EpredL_LtoH_transition(state,digit) = \
   EpredL_LtoH_state_table[state+1,digit+1];
 EpredL_LtoH_transitions(state,v) = \
   for(i=1,#v, state=EpredL_LtoH_transition(state,v[i])); state;

gp_inline__location="../terdragon.tex:19817";
 EpredL_by_LtoH(n) = \
   EpredL_LtoH_transitions(0,Vecrev(digits(n,3)))==2;

gp_inline__location="../terdragon.tex:19923";
 EpredRpair(n) = EpredR(n) && EpredR(n+1);
 EpredLpair(n) = EpredL(n) && EpredL(n+1);

gp_inline__location="../terdragon.tex:20037";
 EncRpairs_formula(k) = 1/2*(3^(k-2) + 1) - 2^(k-2);
 EncRpairs(k) = if(k<=1,0, 1/2*T(k-1));

gp_inline__location="../terdragon.tex:20062";
 EncRpairs_samples = {[0,0,0,0,1,6,25,90,301,966]};

gp_inline__location="../terdragon.tex:20144";
 Epred(n) = EpredL(n) + EpredR(n);

gp_inline__location="../terdragon.tex:20348";
 EpredTwelve(n) = {
   my(v=digits(n,3));
   my(i=#v);
   if(i<1 || v[i]!=1, return(0)); i--;
   if(i<1 || v[i]!=1, return(0)); i--;
   if(i<1 || v[i]!=2, return(0)); i--;
   while(i>=1 && v[i]==2, i--);
   if(i<1 || v[i]!=1, return(0)); i--;
   EpredL(fromdigits(v[1..i],3));
 }
 EpredTwelve_by_each(n) = \
   for(i=0,11, if(!Epred(n+i), return(0))); 1;

gp_inline__location="../terdragon.tex:20453";
 VisitNum(n) = {
   if(n==0,return(1));
   while(n%3==0,n/=3);
   if(n%3==1,RsideNum(n\3),LsideNum(n\3));
 }

gp_inline__location="../terdragon.tex:20461";
 VisitNum_samples = {[1,1,1,1,1,2,1,2,1,1,1,2,1,1,3,2,2,1,1,3]};

gp_inline__location="../terdragon.tex:20532";
 VisitNum_by_other(n) = {
   if(n==0,return(1));
   1 + sum(delta=1,2,
           my(n_other=terdragon_other_n(n,delta));
           0<=n_other && n_other<n);
 }

gp_inline__location="../terdragon.tex:20541";
 VisitNum_by_other_pos(n) = vecsearch(vecsort(n_to_n_list(n)),n);

gp_inline__location="../terdragon.tex:20553";
 VisitNum_by_other3(n) = {
   if(n==0,return(1));
   sum(delta=0,2,
       my(n_other=terdragon_other_n(n,delta));
       0<=n_other && n_other<=n);
 }

gp_inline__location="../terdragon.tex:20577";
 sum_VisitNum(k) = 2*3^k - 2*2^k + 2;

gp_inline__location="../terdragon.tex:20580";
 sum_VisitNum_samples = {[2,4,12,40,132,424,1332]};

gp_inline__location="../terdragon.tex:20598";
 \\ how many visits yet to come
 VisitsInfAfter(n) = VisitsInf(n) - VisitNum(n);

gp_inline__location="../terdragon.tex:20630";
 Ba2(k) = if(k==0, 4, 9*2^(k-1));

gp_inline__location="../terdragon.tex:20637";
 Aa2(k) = if(k==0, 0, 4*3^(k-1) - 3*2^(k-1) );

gp_inline__location="../terdragon.tex:20641";
 Na2(k) = 2*3^k;

gp_inline__location="../terdragon.tex:20664";
 Na3(k) = 3*3^k;
 Ba3(k) = 6*2^k;
 Aa3(k) = 6*3^(k-1) - 4*2^(k-1);

gp_inline__location="../terdragon.tex:20693";
 Ba4(k) = if(k==0, 8, 15*2^(k-1));

gp_inline__location="../terdragon.tex:20700";
 Aa4(k) = if(k==0, 0, 8*3^(k-1) - 5*2^(k-1));

gp_inline__location="../terdragon.tex:20702";
 Na4(k) = 4*3^k;

gp_inline__location="../terdragon.tex:20726";
 Ba5(k) = if(k==0, 10, 18*2^(k-1));

gp_inline__location="../terdragon.tex:20734";
 Aa5(k) = if(k==0, 0, 10*3^(k-1) - 6*2^(k-1));

gp_inline__location="../terdragon.tex:20736";
 Na5(k) = 5*3^k;

gp_inline__location="../terdragon.tex:20761";
 Ba6(k) = if(k==0, 12, 18*2^(k-1));

gp_inline__location="../terdragon.tex:20767";
 Aa6(k) = if(k==0, 0, 12*3^(k-1) - 6*2^(k-1));

gp_inline__location="../terdragon.tex:20769";
 Na6(k) = 6*3^k;

gp_inline__location="../terdragon.tex:20861";
 BSH(k) = 2*2^k;

gp_inline__location="../terdragon.tex:20867";
 RSH(k) = 2^k;

gp_inline__location="../terdragon.tex:20877";
 ASH(k) = if(k==0,0, 2*3^(k-1));

gp_inline__location="../terdragon.tex:20885";
 ASH_from_A_BT2(k) = A(k) + BT2(k);

gp_inline__location="../terdragon.tex:20892";
 ASH_from_cases(k) = if(k==0, 0+0, 2*(3^(k-1) - 2^(k-1)) + 2^k);

gp_inline__location="../terdragon.tex:20896";
 ASH_from_A_B(k) = if(k==0,A(k), A(k)+1/3*B(k));

gp_inline__location="../terdragon.tex:20904";
 BSH_from_B_BT2(k) = B(k) - BT2(k);

gp_inline__location="../terdragon.tex:20911";
 BSH_from_cases(k) = if(k==0, 2+0, 3*2^k - 2^k);

gp_inline__location="../terdragon.tex:20918";
 BSH_from_B(k) = if(k==0,B(k), 2/3*B(k));

gp_inline__location="../terdragon.tex:20962";
 A_area_limit = 1/(2*sqrt3);
 A_area_limit_sample = {(0288675/1000000)};

gp_inline__location="../terdragon.tex:21106";
 JBSH(k) = if(k==0,error("JBSH for k>=1 only"), 2^(k-1));

gp_inline__location="../terdragon.tex:21142";
 GV_generated_samples = {[
   1/4/2*(4 + (-2)*sqrt3i),
   1/4/3*(9 + (-1)*sqrt3i),
   1/4/6*(27 + (11)*sqrt3i),
   1/4/12*(42 + (64)*sqrt3i),
   1/4/24*(-81 + (233)*sqrt3i),
   1/4/48*(-969 + (607)*sqrt3i),
   1/4/96*(-4758 + (824)*sqrt3i),
   1/4/192*(-16749 + (-2339)*sqrt3i),
   1/4/384*(-43149 + (-23845)*sqrt3i),
   1/4/768*(-57666 + (-114764)*sqrt3i),
   1/4/1536*(171783 + (-401959)*sqrt3i),
   1/4/3072*(1721955 + (-1033853)*sqrt3i),
   1/4/6144*(8268150 + (-1378876)*sqrt3i)
 ]};
 GR_generated_samples = {[
   1/4/1*(2 + (0)*sqrt3i),
   1/4/3*(9 + (3)*sqrt3i),
   1/4/6*(21 + (17)*sqrt3i),
   1/4/12*(24 + (70)*sqrt3i),
   1/4/24*(-117 + (233)*sqrt3i),
   1/4/48*(-1023 + (589)*sqrt3i),
   1/4/96*(-4812 + (770)*sqrt3i),
   1/4/192*(-16749 + (-2447)*sqrt3i),
   1/4/384*(-42987 + (-24007)*sqrt3i),
   1/4/768*(-57180 + (-114926)*sqrt3i),
   1/4/1536*(172755 + (-401959)*sqrt3i),
   1/4/3072*(1723413 + (-1033367)*sqrt3i),
   1/4/6144*(8269608 + (-1377418)*sqrt3i)
 ]};
 GRT_generated_samples = {[
   1/6/1*(3 + (-1)*sqrt3i),
   1/6/2*(9 + (1)*sqrt3i),
   1/6/4*(24 + (14)*sqrt3i),
   1/6/8*(33 + (67)*sqrt3i),
   1/6/16*(-99 + (233)*sqrt3i),
   1/6/32*(-996 + (598)*sqrt3i),
   1/6/64*(-4785 + (797)*sqrt3i),
   1/6/128*(-16749 + (-2393)*sqrt3i),
   1/6/256*(-43068 + (-23926)*sqrt3i),
   1/6/512*(-57423 + (-114845)*sqrt3i),
   1/6/1024*(172269 + (-401959)*sqrt3i),
   1/6/2048*(1722684 + (-1033610)*sqrt3i),
   1/6/4096*(8268879 + (-1378147)*sqrt3i)
 ]};
 GRSH_generated_samples = {[
   1/4/1*(2 + (0)*sqrt3i),
   1/4/2*(7 + (1)*sqrt3i),
   1/4/4*(17 + (9)*sqrt3i),
   1/4/8*(22 + (44)*sqrt3i),
   1/4/16*(-67 + (155)*sqrt3i),
   1/4/32*(-665 + (399)*sqrt3i),
   1/4/64*(-3190 + (532)*sqrt3i),
   1/4/128*(-11165 + (-1595)*sqrt3i),
   1/4/256*(-28711 + (-15951)*sqrt3i),
   1/4/512*(-38282 + (-76564)*sqrt3i),
   1/4/1024*(114845 + (-267973)*sqrt3i),
   1/4/2048*(1148455 + (-689073)*sqrt3i),
   1/4/4096*(5512586 + (-918764)*sqrt3i)
 ]};

gp_inline__location="../terdragon.tex:21217";
 GRT(k) = 1/13*(7 - 2*w6) * b^k  + 1/39*(5 - 7*w6) * (conj(w6)/2)^k;

gp_inline__location="../terdragon.tex:21220";
 GRT0 = (0 + 1 + conj(w6))/3;
 GRT1 = 1/2*( GRT0 + 1 + w6^2*GRT0 );
 GRT2 = 1/2*( GRT1 + b^2 + w6^4*GRT1 );

gp_inline__location="../terdragon.tex:21353";
 GRT_recurrence(k) = 1/2*( GRT(k-1) + b^k + w6^4*GRT(k-1) );

gp_inline__location="../terdragon.tex:21365";
 GRT_recurrence2(k) = 1/2*conj(w6)*GRT(k-1) + 1/2*b^k;

gp_inline__location="../terdragon.tex:21379";
 GRT_sum(k) = {
   (conj(w6)/2)^k*GRT0
   + 1/2*b* sum(j=0,k-1, (conj(w6)/2)^j * b^(k-1-j));
 }

gp_inline__location="../terdragon.tex:21437";
 GRSH(k) = \
   1/13*(7 - 2*w6) * b^k  + 1/26*(-1 + 4*w6) * (conj(w6)/2)^k;
 GRSH0 = 1/2;
 GRSH1 = 1/2 * (1/2 + 1+1/2*w6);

gp_inline__location="../terdragon.tex:21482";
 GR_powers(k) = GRT(k) + w6/3 * (b/2)^k;
 GR(k) = if(k==0,return(1/2)); GR_powers(k);

gp_inline__location="../terdragon.tex:21532";
 GV_powers(k) = GRT(k) - w6/3 * (b/2)^k;
 GV(k) = if(k==0,return(1/2 - 1/4*sqrt3i)); GV_powers(k);

gp_inline__location="../terdragon.tex:21663";
 GR0 = 1/2;
 GR1 = b/2;
 GV0 = 1/2*(w6^5/2 + 1+w6^4/2);
 GV1 = 1/3*(w6^5/2 + 1+w6^4/2 + 1+w6/2);
 GR_by_mutual(k) = {
   if(k==0, return(GR0));
   if(k==1, return(GR1));
   if(R(k-1)!=V(k-1),error("oops"));
   1/2*GR(k-1)
   + 1/2*(b^k + w6^4*GV_by_mutual(k-1));
 }
 GV_by_mutual(k) = {
   if(k==0, return(GV0));
   if(k==1, return(GV1));
   if(R(k-1)!=V(k-1),error("oops"));
   1/2*GV_by_mutual(k-1)
   + 1/2*(b^k + w6^4*GR(k-1));
 }

gp_inline__location="../terdragon.tex:21697";
 GV2 = 1/6*(w6^5/2      \
            + 1 + w6^4/2  \
            + 1 + w6/2    \
            + 2+2*sqrt3i/2 + w6^4/2 \
            + 2+2*sqrt3i/2 + w6^3/2 \
            + 1+2*sqrt3i/2 + w6/2   \
           );

gp_inline__location="../terdragon.tex:21937";
 GRf = (7 - 2*w6)/13;

gp_inline__location="../terdragon.tex:21947";
 GRf_real_sample = {(0461538/1000000)};

gp_inline__location="../terdragon.tex:21951";
 GRf_imag_sample = {-(0133234/1000000)};

gp_inline__location="../terdragon.tex:22057";
 GLf = 1 - GRf;

gp_inline__location="../terdragon.tex:22111";
 GJ2_P1 = ( 1  + (3{+}1/3)*sqrt3i/2);

gp_inline__location="../terdragon.tex:22116";
 GJ2_P2 = (1/2 + (2{+}1/3)*sqrt3i/2);

gp_inline__location="../terdragon.tex:22123";
 GJ2 = 1/2*( GJ2_P1 + GJ2_P2 );

gp_inline__location="../terdragon.tex:22138";
 GJ1 = conj(b)/2 + w6;

gp_inline__location="../terdragon.tex:22151";
 GJ(k) = b^(k+1) - 2*w6*GRT(k);

gp_inline__location="../terdragon.tex:22164";
 GJ_expanded(k) = (9 + 3*w6)/13 * b^k \
         + (-14 + 4*w6)/39 * (conj(w6)/2)^k;

gp_inline__location="../terdragon.tex:22176";
 GJ_samples = [ 1 + 2/3*sqrt3i, 3/4 + 17/12*sqrt3i, -1 + 29/12*sqrt3i, -83/16 + 149/48*sqrt3i, -399/32 + 199/96*sqrt3i, -349/16 - 299/96*sqrt3i, -3589/128 - 5981/384*sqrt3i, -4785/256 - 28711/768*sqrt3i ];

gp_inline__location="../terdragon.tex:22286";
 GJf = (9 + 3*w6)/13;

gp_inline__location="../terdragon.tex:22294";
 GJf_sample = (807692 + 199852*I)/10^6;

gp_inline__location="../terdragon.tex:22421";
 GARN_samples_by_path = { 1/6 * [
    (3) + (5)*sqrt3i,   /* k=2 */
    (-12) + (46)*sqrt3i,   /* k=3 */
    (-306) + (248)*sqrt3i,   /* k=4 */
    (-2769) + (799)*sqrt3i,   /* k=5 */
    (-17277) + (-385)*sqrt3i,   /* k=6 */
    (-80199) + (-28301)*sqrt3i,   /* k=7 */
    (-244227) + (-253717)*sqrt3i,   /* k=8 */
    (28590) + (-1536860)*sqrt3i,   /* k=9 */
    (7088076) + (-6973474)*sqrt3i   /* k=10 */
 ]};

gp_inline__location="../terdragon.tex:22435";
 GAR_2 = 1/3*(w6 + 2*w6 + 2*w6-1);

gp_inline__location="../terdragon.tex:22440";
 GAR_3 = 1/5 * ( \
           1  + 2*sqrt3i/2 - b/3 \
       +        4*sqrt3i/2 - b/3 \
       +  1/2 + 3*sqrt3i/2 - b/3 \
       + -1/2 + 3*sqrt3i/2 - b/3 \
       + -1/2 + 5*sqrt3i/2 - b/3);

gp_inline__location="../terdragon.tex:22470";
 GAR(k) = 1/2*b^k + GAR_extra(k);
 GAR_extra(k) = {
   1/(3^(k-1) - 2^(k-1))
   * (+ 1/52*(-1 + 4*w6) * 2^k * b^k
      - 1/6 *w6  * b^k
      + 1/78*(- 5 + 7*w6) * conj(w6)^k
     );
 }

gp_inline__location="../terdragon.tex:22512";
 GAR_by_GR(k) = 1/(3*AR(k)) * (3^k*1/2*b^k - R(k)*GR(k));

gp_inline__location="../terdragon.tex:22548";
 GAR_by_join(k) = {
   1/AR(k) * (
       AR(k-1) *                              GAR(k-1)
     + AR(k-1) * (         b^(k-1) + w3*GAR(k-1))
     + AR(k-1) * (w6*b^(k-1) +          GAR(k-1))
     +  J(k-1) * (b^k - GJ(k-1))
   );
 }

gp_inline__location="../terdragon.tex:22564";
 GARf(k) = GAR(k)/b^k;

gp_inline__location="../terdragon.tex:22615";
 gen_convex_hull_samples = {[
   /* 0 */ [ 0,1 ],
   /* 1 */ [ 0,1,2+1*w3,1+1*w3 ],
   /* 2 */ [ 0,1,2+1*w3,3+3*w3,2+3*w3,1+2*w3 ],
   /* 3 */ [ 0,1,2+1*w3,3+3*w3,3+6*w3,2+6*w3,1+5*w3,3*w3 ],
   /* 4 */ [ 0,1,2+1*w3,3+3*w3,3+7*w3,9*w3,-1+9*w3,-2+8*w3,-3+6*w3,-3+2*w3 ],
   /* 5 */ [ 1,2+1*w3,3+3*w3,3+7*w3,10*w3,-1+10*w3,-10+9*w3,-11+8*w3,-12+6*w3,-12+2*w3,-9-1*w3,-8-1*w3 ],
   /* 6 */ [ 1,2+1*w3,3+3*w3,3+7*w3,10*w3,-10+10*w3,-12+9*w3,-28,-29-1*w3,-30-3*w3,-30-7*w3,-27-10*w3,-17-10*w3,-15-9*w3 ],
   /* 7 */ [ 2+1*w3,3+3*w3,3+7*w3,10*w3,-10+10*w3,-30,-34-4*w3,-56-28*w3,-57-30*w3,-57-34*w3,-54-37*w3,-44-37*w3,-24-27*w3,-20-23*w3 ],
   /* 8 */ [ 3+3*w3,3+7*w3,10*w3,-10+10*w3,-30,-61-31*w3,-64-37*w3,-84-84*w3,-84-88*w3,-81-91*w3,-71-91*w3,-51-81*w3,-20-50*w3,-17-44*w3 ],
   /* 9 */ [ 3+7*w3,10*w3,-10+10*w3,-30,-61-31*w3,-91-91*w3,-91-101*w3,-84-169*w3,-81-172*w3,-71-172*w3,-51-162*w3,-20-131*w3,10-71*w3,10-61*w3 ],
   /* 10 */ [ 10*w3,-10+10*w3,-30,-61-31*w3,-91-91*w3,-91-182*w3,-81-192*w3,-253*w3,10-253*w3,30-243*w3,61-212*w3,91-152*w3,91-61*w3,81-51*w3 ],
   /* 11 */ [ -10+10*w3,-30,-61-31*w3,-91-91*w3,-91-182*w3,-273*w3,31-273*w3,253-253*w3,273-243*w3,304-212*w3,334-152*w3,334-61*w3,243+30*w3,212+30*w3 ],
   /* 12 */ [ -30,-61-31*w3,-91-91*w3,-91-182*w3,-273*w3,274-273*w3,334-243*w3,759,790+31*w3,820+91*w3,820+182*w3,729+273*w3,455+273*w3,395+243*w3 ],
   /* 13 */ [ -61-31*w3,-91-91*w3,-91-182*w3,-273*w3,274-273*w3,820,911+91*w3,1519+760*w3,1549+820*w3,1549+911*w3,1458+1002*w3,1184+1002*w3,638+729*w3,547+638*w3 ],
   /* 14 */ [ -91-91*w3,-91-182*w3,-273*w3,274-273*w3,820,1640+820*w3,1731+1002*w3,2278+2278*w3,2278+2369*w3,2187+2460*w3,1913+2460*w3,1367+2187*w3,547+1367*w3,456+1185*w3 ],
   /* 15 */ [ -91-182*w3,-273*w3,274-273*w3,820,1640+820*w3,2460+2460*w3,2460+2734*w3,2278+4556*w3,2187+4647*w3,1913+4647*w3,1367+4374*w3,547+3554*w3,-273+1914*w3,-273+1640*w3 ],
   /* 16 */ [ -273*w3,274-273*w3,820,1640+820*w3,2460+2460*w3,2460+4921*w3,2187+5194*w3,6834*w3,-274+6834*w3,-820+6561*w3,-1640+5741*w3,-2460+4101*w3,-2460+1640*w3,-2187+1367*w3 ],
   /* 17 */ [ 274-273*w3,820,1640+820*w3,2460+2460*w3,2460+4921*w3,7381*w3,-820+7381*w3,-6835+6834*w3,-7381+6561*w3,-8201+5741*w3,-9021+4101*w3,-9021+1640*w3,-6561-820*w3,-5741-820*w3 ],
   /* 18 */ [ 820,1640+820*w3,2460+2460*w3,2460+4921*w3,7381*w3,-7381+7381*w3,-9021+6561*w3,-20503,-21323-820*w3,-22143-2460*w3,-22143-4921*w3,-19683-7381*w3,-12302-7381*w3,-10662-6561*w3 ],
   /* 19 */ [ 1640+820*w3,2460+2460*w3,2460+4921*w3,7381*w3,-7381+7381*w3,-22143,-24604-2461*w3,-41006-20503*w3,-41826-22143*w3,-41826-24604*w3,-39366-27064*w3,-31985-27064*w3,-17223-19683*w3,-14762-17222*w3 ],
   /* 20 */ [ 2460+2460*w3,2460+4921*w3,7381*w3,-7381+7381*w3,-22143,-44287-22144*w3,-46747-27064*w3,-61509-61509*w3,-61509-63970*w3,-59049-66430*w3,-51668-66430*w3,-36906-59049*w3,-14762-36905*w3,-12302-31985*w3 ]
 ]};

gp_inline__location="../terdragon.tex:22640";
 \\ for k>=6
 P1_samples = vector(#gen_convex_hull_samples-6,i, \
                      gen_convex_hull_samples[i+6][1]);
 P2_samples = vector(#gen_convex_hull_samples-6,i, \
                      gen_convex_hull_samples[i+6][2]);
 P3_samples = vector(#gen_convex_hull_samples-6,i, \
                      gen_convex_hull_samples[i+6][3]);
 P4_samples = vector(#gen_convex_hull_samples-6,i, \
                      gen_convex_hull_samples[i+6][4]);
 P5_samples = vector(#gen_convex_hull_samples-6,i, \
                      gen_convex_hull_samples[i+6][5]);
 P6_samples = vector(#gen_convex_hull_samples-6,i, \
                      gen_convex_hull_samples[i+6][6]);
 P7_samples = vector(#gen_convex_hull_samples-6,i, \
                      gen_convex_hull_samples[i+6][7]);

gp_inline__location="../terdragon.tex:22815";
 P1(k) = if(k<0, error("P1 is for k>=0, got ",k)); \
         -1/24 * (b^k + p(k));

gp_inline__location="../terdragon.tex:22822";
 P2(k) = if(k<0, error("P2 is for k>=0, got ",k)); \
         -1/24 * (b^(k+1) + p(k+1));

gp_inline__location="../terdragon.tex:22828";
 P3(k) = if(k<0, error("P3 is for k>=0, got ",k)); \
         -1/24 * (b^(k+2) + p(k+2));

gp_inline__location="../terdragon.tex:22834";
 P4(k) = if(k<0, error("P4 is for k>=0, got ",k)); \
         -1/24 * (b^(k+3) + p(k+3));

gp_inline__location="../terdragon.tex:22840";
 P5(k) = if(k<0, error("P5 is for k>=0, got ",k)); \
         -1/24 * (b^(k+4) + p(k+4));

gp_inline__location="../terdragon.tex:22846";
 P6(k) = if(k<0, error("P6 is for k>=0, got ",k)); \
         -1/24 * b^(k+5) - 1/24*p(k+5);

gp_inline__location="../terdragon.tex:22857";
 P7(k) = if(k<0, error("P7 is for k>=0, got ",k)); \
         -1/24*( (1+1/9*w6)*b^(k+5) + p(k+6) );

gp_inline__location="../terdragon.tex:22879";
 P1dash(k) = b^k - P1(k);
 P2dash(k) = b^k - P2(k);
 P3dash(k) = b^k - P3(k);
 P4dash(k) = b^k - P4(k);
 P5dash(k) = b^k - P5(k);
 P6dash(k) = b^k - P6(k);
 P7dash(k) = b^k - P7(k);

gp_inline__location="../terdragon.tex:22927";
 p_vector = {[
   -9,        6+15*w3,        -3-3*w3,        -3-6*w3,
  (-9)*w3,   (6+15*w3)*w3,   (-3-3*w3)*w3,   (-3-6*w3)*w3,
  (-9)*w3^2, (6+15*w3)*w3^2, (-3-3*w3)*w3^2, (-3-6*w3)*w3^2
 ]};
 p(m) = vector_modulo(p_vector,m);

gp_inline__location="../terdragon.tex:22963";
 gP1_periodic(x) = {
     + (3/16 - 1/16*sqrt3i)/(1 + w3*x)
     + (-1/16 + 1/16*sqrt3i)/(1 - w3*x)
     + (1/4 + (1/8 - 1/8*sqrt3i)*x)/(1 - w6*x^2);
 }
 gP1(x) = -1/24 * 1/(1 - b*x) + gP1_periodic(x);

gp_inline__location="../terdragon.tex:22974";
 \\ Return a vector of complex vertices of the hull
 \\ going anti-clockwise around.
 hull_sample(k) = gen_convex_hull_samples[k+1];
 hull(k) = {
   if(k<6, return(hull_sample(k)));
   [ P1(k), P2(k), P3(k), P4(k), P5(k), P6(k), P7(k),
     b^k-P1(k), b^k-P2(k), b^k-P3(k), b^k-P4(k),
     b^k-P5(k), b^k-P6(k), b^k-P7(k) ];
 }

gp_inline__location="../terdragon.tex:23525";
 P2_sub_P3(k) = 1/72*b^(k+3) + 1/24*(p(k+2) - p(k+1));

gp_inline__location="../terdragon.tex:23531";
 P6_sub_P7(k) = 1/24*1/9*w6*b^(k+5) \
              + 1/24*(p(k+6) - p(k+5));

gp_inline__location="../terdragon.tex:23538";
 P6_sub_P7_simplified(k) = \
   w3*(1/72*b^(k+3) + 1/24*(p(k+2) - p(k+1)));

gp_inline__location="../terdragon.tex:23686";
 P6A(k) = P6(k-1);
 P3B(k) = b^(k-1) + w3*P3(k-1);

gp_inline__location="../terdragon.tex:23707";
 P2A(k) = P2(k-1);
 P4B_dash(k) = b^(k-1) + w3*(b^(k-1) - P4(k-1));

gp_inline__location="../terdragon.tex:23724";
 imag_P2A_sub_P4B_dash_over_b_k_plus_2(k) = \
   1/24*sqrt3*(1 - (-1/3)^ceil(k/2));

gp_inline__location="../terdragon.tex:23757";
 P1_by_mutual(k) = if(k<7, P1(k),         P2(k-1));
 P2_by_mutual(k) = if(k<7, P2(k),         P3(k-1));
 P3_by_mutual(k) = if(k<7, P3(k),         P4(k-1));
 P4_by_mutual(k) = if(k<7, P4(k),         P5(k-1));
 P5_by_mutual(k) = if(k<7, P5(k),         P6(k-1));
 P6_by_mutual(k) = if(k<7, P6(k), b^(k-1) + w3*P3(k-1));
 P7_by_mutual(k) = if(k<7, P7(k), b^(k-1) + w3*P4(k-1));

gp_inline__location="../terdragon.tex:23775";
 g_b_power_plus(x,n) = 1/(1-b*x)*b^n;
 g_b_power(x) = g_b_power_plus(x,0);

gp_inline__location="../terdragon.tex:23779";
 g_p_plus(x,n) = 1/(1-x^12) * Polrev(vector(12,k,k--; p(k+n)));

gp_inline__location="../terdragon.tex:23783";
 gP2(x) = -1/24*(g_b_power_plus(x,1) + g_p_plus(x,1));
 gP3(x) = -1/24*(g_b_power_plus(x,2) + g_p_plus(x,2));
 gP4(x) = -1/24*(g_b_power_plus(x,3) + g_p_plus(x,3));
 gP5(x) = -1/24*(g_b_power_plus(x,4) + g_p_plus(x,4));
 gP6(x) = -1/24*(g_b_power_plus(x,5) + g_p_plus(x,5));
 gP7(x) = -1/24*((1+1/9*w6)*g_b_power_plus(x,5) + g_p_plus(x,6));

gp_inline__location="../terdragon.tex:23798";
 gP_vector = [gP1(x), gP2(x), gP3(x), gP4(x), \
              gP5(x), gP6(x), gP7(x)];

gp_inline__location="../terdragon.tex:23810";
 gP_matrix = {
   [ 1,  -x,     0,     0,   0,   0,   0;  /* 1 */
     0,   1,    -x,     0,   0,   0,   0;  /* 2 */
     0,   0,     1,    -x,   0,   0,   0;  /* 3 */
     0,   0,     0,     1,  -x,   0,   0;  /* 4 */
     0,   0,     0,     0,   1,  -x,   0;  /* 5 */
     0,   0, -w3*x,     0,   0,   1,   0;  /* 6 */
     0,   0,     0, -w3*x,   0,   0,   1   /* 7 */
   ]; }
 gP_matrix_column = {
   [                  P1(0),  /*  1 */
                      P2(0),  /*  2 */
                      P3(0),  /*  3 */
                      P4(0),  /*  4 */
                      P5(0),  /*  5 */
     x*g_b_power(x) + P6(0),  /*  6 */
     x*g_b_power(x) + P7(0)   /*  7 */
   ]~; }

gp_inline__location="../terdragon.tex:23830";
 gP_vector_by_matsolve = \
   Vec(matsolve(gP_matrix, gP_matrix_column));

gp_inline__location="../terdragon.tex:23881";
 P3_from_sum(k) = {
   my(r=(k-6)%4); my(q=(k-6-r)/4);
   sum(j=0,q-1, b^(k-4-4*j)*w3^j)
   + w3^q * P3(6+r);
 }

gp_inline__location="../terdragon.tex:23916";
 P3_from_power(k) = {
   my(r=(k-6)%4); my(q=(k-6-r)/4);
   b^(r+6) * ((b^4)^q - w3^q) / (b^4 - w3)
   + w3^q * P3(6+r);
 }

gp_inline__location="../terdragon.tex:23930";
 P3_from_power24(k) = if(k<6,P3(k), \
   my(r=(k-6)%4); my(q=(k-6-r)/4);  \
   -1/24*( b^(k+2)                  \
           - b^(r+8) * w3^q         \
           - 24 * w3^q * P3(6+r)  ));

gp_inline__location="../terdragon.tex:23960";
 p_of_k_plus_2_from_P3_right(k) =  \
   my(r=(k-6)%4); my(q=(k-6-r)/4); \
   - b^(r+8) * w3^q              \
   - 24*w3^q * P3(r+6);

gp_inline__location="../terdragon.tex:23982";
 P6A_dash(k) = P6dash(k-1);

gp_inline__location="../terdragon.tex:23985";
 P6B_dash(k) = b^(k-1) + w3*P6dash(k-1);
 P5B_dash(k) = b^(k-1) + w3*P5dash(k-1);

gp_inline__location="../terdragon.tex:23991";
 P6A_P6B_real_diff(k) = \
   real(( P6A_dash(k) - P6B_dash(k) )/w12_times_sqrt3^k) * sqrt3^k;

gp_inline__location="../terdragon.tex:23999";
 P6A_P6B_real_diff_p(k) = \
   real(1/24*( p(k+4) - w3*p(k+4) )/w12_times_sqrt3^k)*sqrt3^k;

gp_inline__location="../terdragon.tex:24013";
 P6A_P6B_diff_real_cases(k) = if(k%4!=1,0, -1/2*sqrt3);

gp_inline__location="../terdragon.tex:24115";
 P1_limit = -1/24;
 P2_limit = -1/24 *b;
 P3_limit = -1/24 *b^2;
 P4_limit = -1/24 *b^3;
 P5_limit = -1/24 *b^4;
 P6_limit = -1/24 *b^5;
 P7_limit = -1/24 *b^5 * (1 + 1/9*w6);
 P1dash_limit = 1 - P1_limit;
 P2dash_limit = 1 - P2_limit;
 P3dash_limit = 1 - P3_limit;
 P4dash_limit = 1 - P4_limit;
 P5dash_limit = 1 - P5_limit;
 P6dash_limit = 1 - P6_limit;
 P7dash_limit = 1 - P7_limit;

gp_inline__location="../terdragon.tex:24144";
 hull_fractal = {[
   P1_limit, P2_limit, P3_limit, P4_limit,
   P5_limit, P6_limit, P7_limit,
   P1dash_limit, P2dash_limit, P3dash_limit, P4dash_limit,
   P5dash_limit, P6dash_limit, P7dash_limit
 ]};

gp_inline__location="../terdragon.tex:24241";
 hull_extent_width = 3/16*sqrt3;

gp_inline__location="../terdragon.tex:24249";
 hull_extent_width_sample = {(0324759/1000000)};

gp_inline__location="../terdragon.tex:24303";
 PN1_by_mutual(k) = if(k<7, PN1(k),         PN2(k-1));
 PN2_by_mutual(k) = if(k<7, PN2(k),         PN3(k-1));
 PN3_by_mutual(k) = if(k<7, PN3(k),         PN4(k-1));
 PN4_by_mutual(k) = if(k<7, PN4(k),         PN5(k-1));
 PN5_by_mutual(k) = if(k<7, PN5(k),         PN6(k-1));
 PN6_by_mutual(k) = if(k<7, PN6(k), 3^(k-1) + PN3(k-1));
 PN7_by_mutual(k) = if(k<7, PN7(k), 3^(k-1) + PN4(k-1));

gp_inline__location="../terdragon.tex:24328";
 PN1_limit = {(1)/(720)};

gp_inline__location="../terdragon.tex:24333";
 PN1_vector = {[-9,53,-1,-3]};
 PN1(k) = 1/720*3^k + 1/80*vector_modulo(PN1_vector,k);

gp_inline__location="../terdragon.tex:24356";
 PN1_digits(k) = {
   k>=6 || error();
   k -= 6;
   concat([ 1,  \\ high 1
            concat_repeat([0,0,0,1], k\4),
            vector_modulo([[],[0],[0,0],[0,0,1]], k)
          ]);
 }

gp_inline__location="../terdragon.tex:24367";
 PN1_samples = {[1,3,9,28,82,246,738,2215,6643]};

gp_inline__location="../terdragon.tex:24382";
 PN2(k) = PN1(k+1);
 PN3(k) = PN1(k+2);
 PN4(k) = PN1(k+3);
 PN5(k) = PN1(k+4);
 PN6(k) = PN1(k+5);

gp_inline__location="../terdragon.tex:24397";
 PN7_limit = {(83)/(240)};

gp_inline__location="../terdragon.tex:24402";
 PN7_vector = {[-1,-3,-9,53]};
 PN7(k) = 83/240*3^k + 1/80*vector_modulo(PN7_vector,k);

gp_inline__location="../terdragon.tex:24424";
 PN7_digits(k) = {
   k -= 4;
   concat([ [1,0,0,1],
            concat_repeat([0,0,0,1], k\4),
            vector_modulo([[],[0],[0,0],[0,0,1]], k) ]);
 }

gp_inline__location="../terdragon.tex:24433";
 PN7_samples = {[252,757,2269,6807,20421,61264]};

gp_inline__location="../terdragon.tex:24507";
 PN2_limit = 3*PN1_limit;
 PN3_limit = 3*PN2_limit;
 PN4_limit = 3*PN3_limit;
 PN5_limit = 3*PN4_limit;
 PN6_limit = 3*PN5_limit;
 PN1dash_limit = 1-PN1_limit;
 PN2dash_limit = 1-PN2_limit;
 PN3dash_limit = 1-PN3_limit;
 PN4dash_limit = 1-PN4_limit;
 PN5dash_limit = 1-PN5_limit;
 PN6dash_limit = 1-PN6_limit;
 PN7dash_limit = 1-PN7_limit;

gp_inline__location="../terdragon.tex:24552";
 HA_initial_vector = {[0,2]};

gp_inline__location="../terdragon.tex:24560";
 HA_half_vector = {[15,23,11,25]};

gp_inline__location="../terdragon.tex:24568";
 HA_constant_vector = {[5,3,1,3]};

gp_inline__location="../terdragon.tex:24576";
 HA_formula(k) = {
   29/24 * 3^k
   - 1/12 * vector_modulo(HA_half_vector,k) * 3^floor(k/2)
   - 1/8 * vector_modulo(HA_constant_vector,k);
 }
 HA(k) = {
   if(k<#HA_initial_vector, HA_initial_vector[k+1], HA_formula(k));
 }

gp_inline__location="../terdragon.tex:24597";
 HA_samples = {[0,2,8,26,86,276,856,2586]};

gp_inline__location="../terdragon.tex:24636";
 HAf_unit_triangles = 29/24;
 HAf_unit_triangles_sample = {(1208333/1000000)};

gp_inline__location="../terdragon.tex:24669";
 HAf = HAf_unit_triangles * unit_triangle_area;
 HAf_sample = {(0523223/1000000)};

gp_inline__location="../terdragon.tex:24683";
 gHA(x) = {
   2/3 + 2/3*x
   - 3/8 * 1/(1 - x)
   - 1/4 * 1/(1 + x^2)
   + (-13/12 - 2*x)/(1 - 3*x^2)
   + (-1/6 + 1/12*x)/(1 + 3*x^2)
   + 29/24 * 1/(1 - 3*x);
 }

gp_inline__location="../terdragon.tex:24732";
 \\ constants c=[15,9,3,9] can floor div by 24 since 0 <= c < 24
 my(h=[30,46,22,50]); \
 HA_compact(n) = if(n<2,2*n, (29*3^n - h[n%4+1]*3^(n\2))\24);

gp_inline__location="../terdragon.tex:24757";
 HAf_vector(len) = digits(sqrtint(2523*100^len)\96);

gp_inline__location="../terdragon.tex:24777";
 HB_initial = {[2,4]};

gp_inline__location="../terdragon.tex:24789";
 HB_part_7_half = {[-30,162,30,-162]};

gp_inline__location="../terdragon.tex:24794";
 HB_part_7_constant = {[9,63]};

gp_inline__location="../terdragon.tex:24807";
 HB_sans_7(k) = {
   (13/12 + 5/12*sqrt3) * sqrt3^k
   + vector_modulo([9/4 - 7/4*sqrt3,
                    3/4 - 7/4*sqrt3,
                    3/4 - 5/4*sqrt3,
                    9/4 - 5/4*sqrt3],k);
 }
 HB_part_7_squared(k) = {
   1/36 * (37 * 3^k
           + vector_modulo(HB_part_7_half,k) * 3^floor(k/2)
           + vector_modulo(HB_part_7_constant,k) );
 }
 HB_vector_formula(k) = \
   [ HB_sans_7(k), geom_sqrt_as_quad(HB_part_7_squared(k)) ];
 HB_vector(k) = {
   if(k==0, [HB_initial[1],0],
      k==1, [HB_initial[2],0],
      HB_vector_formula(k));
 }

gp_inline__location="../terdragon.tex:24829";
 HB_inexact(k) = {
   if(k<2, HB_initial[k+1]*1.0,
           HB_sans_7(k) + sqrt(HB_part_7_squared(k)));
 }

gp_inline__location="../terdragon.tex:24840";
 hull_sides_sans_7(k) = if(k<6,[], \
   geom_sides_of_polygon(hull(k)) [^14][^7] );
 HB_sans_7_from_sides(k) = \
   vecsum(apply(geom_abs,hull_sides_sans_7(k)));

gp_inline__location="../terdragon.tex:24848";
 hull_sides_7(k) = if(k<6,[], \
   vecextract(geom_sides_of_polygon(hull(k)), [7,14]));
 HB_part_7(k) = vecsum(apply(geom_abs,hull_sides_7(k)));

gp_inline__location="../terdragon.tex:24898";
 HBf_vector = [ 13/12, 5/12*sqrt3, 1/6*sqrt37 ];
 HBf_inexact = vecsum(HBf_vector*1.0);

gp_inline__location="../terdragon.tex:24903";
 HBf_sample = {(2818814/1000000)};

gp_inline__location="../terdragon.tex:24914";
 HBf_poly(x) = ((x-13/12)^2 - 223/144)^2 - 925/432;

gp_inline__location="../terdragon.tex:24993";
 HBf_poly_integers(x) = HBf_poly(x) * 2^8*3^4;

gp_inline__location="../terdragon.tex:25004";
 HBf_digits(len) = {
   my(s=10^(len-1), t=s^2);
   digits((sqrtint(sqrtint(111*t^2)*20 + 223*t) + 13*s) \ 12);
 }

gp_inline__location="../terdragon.tex:25065";
 HD_half_vector = {[3,9,9,15]};

gp_inline__location="../terdragon.tex:25070";
 HD_constant_vector = {[1,3,9,19]};

gp_inline__location="../terdragon.tex:25075";
 HD_squared(k) = {
   21/16 * 3^k
   - 1/8*vector_modulo(HD_half_vector,k) * 3^floor(k/2)
   + 1/16*vector_modulo(HD_constant_vector,k);
 }

gp_inline__location="../terdragon.tex:25083";
 HD_squared_samples = {[1,3,9,31,103,309,927,2821]};

gp_inline__location="../terdragon.tex:25099";
 \\ return the maximum norm(v[i]-v[j])
 vector_max_pair_norm(v) = {
   my(m=0);
   for(i=1,#v, for(j=i+1,#v, m = max(m, norm(v[i]-v[j]))));
   m;
 }
 HD_squared_by_terdragon_points(k) = \
   vector_max_pair_norm(terdragon_points(k));

gp_inline__location="../terdragon.tex:25131";
 pmax_norm = vecmax(vector(12,m, norm(1/24*p(m))));
 pmax_inexact = sqrt(pmax_norm);

gp_inline__location="../terdragon.tex:25156";
 P3_sub_P3dash_abs(k) = abs(b^k + 2*1/24*b^(k+2));

gp_inline__location="../terdragon.tex:25186";
 P2_sub_P2dash_abs(k) = abs(b^k + 2*1/24*b^(k+1));

gp_inline__location="../terdragon.tex:25239";
 HD_diff(k) = \
   P3_sub_P3dash_abs(k) - P2_sub_P2dash_abs(k) - 4*pmax_inexact;

gp_inline__location="../terdragon.tex:25284";
 HD_limit = sqrt21 / 4;
 HD_inexact(k) = sqrt(HD_squared(k));
 HD_limit_sample = {(1145643/1000000)};

gp_inline__location="../terdragon.tex:25314";
 \\ doesn't work for len=0, but that not very important
 sqrt21_over_4_digits(len) = \
   digits(sqrtint(21*100^(len-1))\4);

gp_inline__location="../terdragon.tex:25360";
 P1S_offset(k) = if(k%4==1,w6^((k+1)/2));
 P1S_formula(k) = P1(k) + P1S_offset(k);
 P1S(k) = if(k==0||k==1,0, P1S_formula(k));

gp_inline__location="../terdragon.tex:25372";
 P1Sdash(k) = b^k - P1S(k);

gp_inline__location="../terdragon.tex:25389";
 HSDf = {(13)/(12)};

gp_inline__location="../terdragon.tex:25399";
 HSD_formula(k) = \
   HSDf*sqrt3^k - vector_modulo([3/4, 3/4*sqrt3, 1/4, 1/4*sqrt3],k);
 HSD(k) = if(k==0,1, k==1,sqrt3, simplify(HSD_formula(k)));

gp_inline__location="../terdragon.tex:25416";
 HSD_samples = \
   [ 1,sqrt3, 3,3*sqrt3, 9,9*sqrt3, 29,29*sqrt3, 87,87*sqrt3 ];

gp_inline__location="../terdragon.tex:25446";
 HSD_digits(k) = {
   my(m=k\2);
   vector(m+1,i, if(i==1,1, i==2,0, i%2==1, 0, 2));
 }

gp_inline__location="../terdragon.tex:25639";
 HSD_by_search(k) = {
   my(m=Map(), end=b^k, rescale=sqrt3^k);
   for(n=0,3^k,
     my(z=terdragon_point(n)/end,
        x=geom_point_x(z)*rescale,
        y=geom_point_y(z),
        elem);
     if(mapisdefined(m,y,&elem),
        elem[1]=min(elem[1],x);
        elem[2]=max(elem[2],x),
        elem=[x,x]);
     mapput(m,y,elem));
   my(y_list=Mat(m)[,1], found=[-1], count=0);
   for(i=1,#y_list,
     my(y=y_list[i], elem=mapget(m,y), d=elem[2]-elem[1]);
     if(d>found[1],
        found=[d,y,elem[1],elem[2]]; count=1,
        d==found[1],
        count++));
   found;
 }

gp_inline__location="../terdragon.tex:25687";
 HSW_limit_sample = {(0625462/1000000)};

gp_inline__location="../terdragon.tex:25697";
 P1W_formula(k) = b^(k-1) + w3*P1S(k-1);
 P1W(k) = if(k==0,0, k==1,1, P1W_formula(k));
 P1Wdash(k) = if(k==0,0, b^k - P1W(k));
 HWD(k) = if(k==0,0, HSD(k-1));

gp_inline__location="../terdragon.tex:25707";
 HWD_by_search(k) = {
   my(debug=0);
   my(m=Map(), end=b^k, rescale=sqrt3^k);
   for(n=0,3^k,
     my(z=terdragon_point(n)/end,
        x=geom_point_x(z),
        y=geom_point_y(z)*rescale,
        elem);
     if(debug,print("z "z"  x="x" y="y));
     if(mapisdefined(m,x,&elem),
        elem[1]=min(elem[1],y);
        elem[2]=max(elem[2],y),
        elem=[y,y]);
     mapput(m,x,elem));
   my(x_list=Mat(m)[,1], found=[-1], count=0);
   for(i=1,#x_list,
     my(x=x_list[i], elem=mapget(m,x), d=elem[2]-elem[1]);
     if(d>found[1],
        found=[d,x,elem[1],elem[2]]; count=1,
        d==found[1],
        count++));
   found;
 }

gp_inline__location="../terdragon.tex:25801";
 gen_convex_hull_T_samples = {[
   /* 0 */ [ 0,-1*w3,1,1+1*w3 ],
   /* 1 */ [ 0,-1*w3,0,2+1*w3,2+1*w3,2+2*w3 ],
   /* 2 */ [ -1*w3,3+2*w3,3+4*w3,1*w3 ],
   /* 3 */ [ -1*w3,3+2*w3,4+4*w3,3+7*w3,4*w3,-1+2*w3 ],
   /* 4 */ [ -1*w3,3+2*w3,4+4*w3,4+7*w3,10*w3,-3+7*w3,-4+5*w3,-4+2*w3 ],
   /* 5 */ [ -1*w3,3+2*w3,4+4*w3,4+7*w3,1+10*w3,-9+10*w3,-12+7*w3,-13+5*w3,-13+2*w3,-10-1*w3 ],
   /* 6 */ [ -1*w3,3+2*w3,4+4*w3,4+7*w3,1+10*w3,-11+10*w3,-13+9*w3,-27+1*w3,-30-2*w3,-31-4*w3,-31-7*w3,-28-10*w3,-16-10*w3,-14-9*w3 ],
   /* 7 */ [ 3+2*w3,4+4*w3,4+7*w3,1+10*w3,-11+10*w3,-31,-34-3*w3,-57-29*w3,-58-31*w3,-58-34*w3,-55-37*w3,-43-37*w3,-23-27*w3,-20-24*w3 ],
   /* 8 */ [ 4+4*w3,4+7*w3,1+10*w3,-11+10*w3,-31,-61-30*w3,-64-36*w3,-85-85*w3,-85-88*w3,-82-91*w3,-70-91*w3,-50-81*w3,-20-51*w3,-17-45*w3 ],
   /* 9 */ [ 4+7*w3,1+10*w3,-11+10*w3,-31,-61-30*w3,-91-90*w3,-91-102*w3,-85-169*w3,-82-172*w3,-70-172*w3,-50-162*w3,-20-132*w3,10-72*w3,10-60*w3 ],
   /* 10 */ [ 1+10*w3,-11+10*w3,-31,-61-30*w3,-91-90*w3,-91-183*w3,-81-193*w3,-1-253*w3,11-253*w3,31-243*w3,61-213*w3,91-153*w3,91-60*w3,81-50*w3 ],
   /* 11 */ [ -11+10*w3,-31,-61-30*w3,-91-90*w3,-91-183*w3,-274*w3,30-274*w3,254-253*w3,274-243*w3,304-213*w3,334-153*w3,334-60*w3,243+31*w3,213+31*w3 ],
   /* 12 */ [ -31,-61-30*w3,-91-90*w3,-91-183*w3,-274*w3,273-274*w3,333-244*w3,760,790+30*w3,820+90*w3,820+183*w3,729+274*w3,456+274*w3,396+244*w3 ],
   /* 13 */ [ -61-30*w3,-91-90*w3,-91-183*w3,-274*w3,273-274*w3,819-1*w3,912+92*w3,1519+759*w3,1549+819*w3,1549+912*w3,1458+1003*w3,1185+1003*w3,639+730*w3,546+637*w3 ],
   /* 14 */ [ -91-90*w3,-91-183*w3,-274*w3,273-274*w3,819-1*w3,1641+821*w3,1732+1003*w3,2278+2277*w3,2278+2370*w3,2187+2461*w3,1914+2461*w3,1368+2188*w3,546+1366*w3,455+1184*w3 ],
   /* 15 */ [ -91-183*w3,-274*w3,273-274*w3,819-1*w3,1641+821*w3,2461+2461*w3,2461+2734*w3,2278+4557*w3,2187+4648*w3,1914+4648*w3,1368+4375*w3,546+3553*w3,-274+1913*w3,-274+1640*w3 ],
   /* 16 */ [ -274*w3,273-274*w3,819-1*w3,1641+821*w3,2461+2461*w3,2461+4921*w3,2188+5194*w3,6835*w3,-273+6835*w3,-819+6562*w3,-1641+5740*w3,-2461+4100*w3,-2461+1640*w3,-2188+1367*w3 ],
   /* 17 */ [ 273-274*w3,819-1*w3,1641+821*w3,2461+2461*w3,2461+4921*w3,1+7381*w3,-821+7381*w3,-6834+6835*w3,-7380+6562*w3,-8202+5740*w3,-9022+4100*w3,-9022+1640*w3,-6562-820*w3,-5740-820*w3 ],
   /* 18 */ [ 819-1*w3,1641+821*w3,2461+2461*w3,2461+4921*w3,1+7381*w3,-7382+7381*w3,-9022+6561*w3,-20502+1*w3,-21324-821*w3,-22144-2461*w3,-22144-4921*w3,-19684-7381*w3,-12301-7381*w3,-10661-6561*w3 ],
   /* 19 */ [ 1641+821*w3,2461+2461*w3,2461+4921*w3,1+7381*w3,-7382+7381*w3,-22144,-24604-2460*w3,-41007-20504*w3,-41827-22144*w3,-41827-24604*w3,-39367-27064*w3,-31984-27064*w3,-17222-19683*w3,-14762-17223*w3 ],
   /* 20 */ [ 2461+2461*w3,2461+4921*w3,1+7381*w3,-7382+7381*w3,-22144,-44287-22143*w3,-46747-27063*w3,-61510-61510*w3,-61510-63970*w3,-59050-66430*w3,-51667-66430*w3,-36905-59049*w3,-14762-36906*w3,-12302-31986*w3 ],
   /* 21 */ [ 2461+4921*w3,1+7381*w3,-7382+7381*w3,-22144,-44287-22143*w3,-66430-66429*w3,-66430-73812*w3,-61510-123019*w3,-59050-125479*w3,-51667-125479*w3,-36905-118098*w3,-14762-95955*w3,7381-51669*w3,7381-44286*w3 ],
   /* 22 */ [ 1+7381*w3,-7382+7381*w3,-22144,-44287-22143*w3,-66430-66429*w3,-66430-132861*w3,-59049-140242*w3,-1-184528*w3,7382-184528*w3,22144-177147*w3,44287-155004*w3,66430-110718*w3,66430-44286*w3,59049-36905*w3 ],
   /* 23 */ [ -7382+7381*w3,-22144,-44287-22143*w3,-66430-66429*w3,-66430-132861*w3,-199291*w3,22143-199291*w3,184529-184528*w3,199291-177147*w3,221434-155004*w3,243577-110718*w3,243577-44286*w3,177147+22144*w3,155004+22144*w3 ],
   /* 24 */ [ -22144,-44287-22143*w3,-66430-66429*w3,-66430-132861*w3,-199291*w3,199290-199291*w3,243576-177148*w3,553585,575728+22143*w3,597871+66429*w3,597871+132861*w3,531441+199291*w3,332151+199291*w3,287865+177148*w3 ],
   /* 25 */ [ -44287-22143*w3,-66430-66429*w3,-66430-132861*w3,-199291*w3,199290-199291*w3,597870-1*w3,664302+66431*w3,1107169+553584*w3,1129312+597870*w3,1129312+664302*w3,1062882+730732*w3,863592+730732*w3,465012+531442*w3,398580+465010*w3 ],
   /* 26 */ [ -66430-66429*w3,-66430-132861*w3,-199291*w3,199290-199291*w3,597870-1*w3,1195743+597872*w3,1262173+730732*w3,1660753+1660752*w3,1660753+1727184*w3,1594323+1793614*w3,1395033+1793614*w3,996453+1594324*w3,398580+996451*w3,332150+863591*w3 ],
   /* 27 */ [ -66430-132861*w3,-199291*w3,199290-199291*w3,597870-1*w3,1195743+597872*w3,1793614+1793614*w3,1793614+1992904*w3,1660753+3321507*w3,1594323+3387937*w3,1395033+3387937*w3,996453+3188647*w3,398580+2590774*w3,-199291+1395032*w3,-199291+1195742*w3 ],
   /* 28 */ [ -199291*w3,199290-199291*w3,597870-1*w3,1195743+597872*w3,1793614+1793614*w3,1793614+3587227*w3,1594324+3786517*w3,4982260*w3,-199290+4982260*w3,-597870+4782970*w3,-1195743+4185097*w3,-1793614+2989355*w3,-1793614+1195742*w3,-1594324+996452*w3 ],
   /* 29 */ [ 199290-199291*w3,597870-1*w3,1195743+597872*w3,1793614+1793614*w3,1793614+3587227*w3,1+5380840*w3,-597872+5380840*w3,-4982259+4982260*w3,-5380839+4782970*w3,-5978712+4185097*w3,-6576583+2989355*w3,-6576583+1195742*w3,-4782970-597871*w3,-4185097-597871*w3 ],
   /* 30 */ [ 597870-1*w3,1195743+597872*w3,1793614+1793614*w3,1793614+3587227*w3,1+5380840*w3,-5380841+5380840*w3,-6576583+4782969*w3,-14946777+1*w3,-15544650-597872*w3,-16142521-1793614*w3,-16142521-3587227*w3,-14348908-5380840*w3,-8968066-5380840*w3,-7772324-4782969*w3 ],
   /* 31 */ [ 1195743+597872*w3,1793614+1793614*w3,1793614+3587227*w3,1+5380840*w3,-5380841+5380840*w3,-16142521,-17936134-1793613*w3,-29893557-14946779*w3,-30491428-16142521*w3,-30491428-17936134*w3,-28697815-19729747*w3,-23316973-19729747*w3,-12555293-14348907*w3,-10761680-12555294*w3 ],
   /* 32 */ [ 1793614+1793614*w3,1793614+3587227*w3,1+5380840*w3,-5380841+5380840*w3,-16142521,-32285041-16142520*w3,-34078654-19729746*w3,-44840335-44840335*w3,-44840335-46633948*w3,-43046722-48427561*w3,-37665880-48427561*w3,-26904200-43046721*w3,-10761680-26904201*w3,-8968067-23316975*w3 ],
   /* 33 */ [ 1793614+3587227*w3,1+5380840*w3,-5380841+5380840*w3,-16142521,-32285041-16142520*w3,-48427561-48427560*w3,-48427561-53808402*w3,-44840335-89680669*w3,-43046722-91474282*w3,-37665880-91474282*w3,-26904200-86093442*w3,-10761680-69950922*w3,5380840-37665882*w3,5380840-32285040*w3 ],
   /* 34 */ [ 1+5380840*w3,-5380841+5380840*w3,-16142521,-32285041-16142520*w3,-48427561-48427560*w3,-48427561-96855123*w3,-43046721-102235963*w3,-1-134521003*w3,5380841-134521003*w3,16142521-129140163*w3,32285041-112997643*w3,48427561-80712603*w3,48427561-32285040*w3,43046721-26904200*w3 ],
   /* 35 */ [ -5380841+5380840*w3,-16142521,-32285041-16142520*w3,-48427561-48427560*w3,-48427561-96855123*w3,-145282684*w3,16142520-145282684*w3,134521004-134521003*w3,145282684-129140163*w3,161425204-112997643*w3,177567724-80712603*w3,177567724-32285040*w3,129140163+16142521*w3,112997643+16142521*w3 ],
   /* 36 */ [ -16142521,-32285041-16142520*w3,-48427561-48427560*w3,-48427561-96855123*w3,-145282684*w3,145282683-145282684*w3,177567723-129140164*w3,403563010,419705530+16142520*w3,435848050+48427560*w3,435848050+96855123*w3,387420489+145282684*w3,242137806+145282684*w3,209852766+129140164*w3 ],
   /* 37 */ [ -32285041-16142520*w3,-48427561-48427560*w3,-48427561-96855123*w3,-145282684*w3,145282683-145282684*w3,435848049-1*w3,484275612+48427562*w3,807126019+403563009*w3,823268539+435848049*w3,823268539+484275612*w3,774840978+532703173*w3,629558295+532703173*w3,338992929+387420490*w3,290565366+338992927*w3 ],
   /* 38 */ [ -48427561-48427560*w3,-48427561-96855123*w3,-145282684*w3,145282683-145282684*w3,435848049-1*w3,871696101+435848051*w3,920123662+532703173*w3,1210689028+1210689027*w3,1210689028+1259116590*w3,1162261467+1307544151*w3,1016978784+1307544151*w3,726413418+1162261468*w3,290565366+726413416*w3,242137805+629558294*w3 ],
   /* 39 */ [ -48427561-96855123*w3,-145282684*w3,145282683-145282684*w3,435848049-1*w3,871696101+435848051*w3,1307544151+1307544151*w3,1307544151+1452826834*w3,1210689028+2421378057*w3,1162261467+2469805618*w3,1016978784+2469805618*w3,726413418+2324522935*w3,290565366+1888674883*w3,-145282684+1016978783*w3,-145282684+871696100*w3 ],
   /* 40 */ [ -145282684*w3,145282683-145282684*w3,435848049-1*w3,871696101+435848051*w3,1307544151+1307544151*w3,1307544151+2615088301*w3,1162261468+2760370984*w3,3632067085*w3,-145282683+3632067085*w3,-435848049+3486784402*w3,-871696101+3050936350*w3,-1307544151+2179240250*w3,-1307544151+871696100*w3,-1162261468+726413417*w3 ],
   /* 41 */ [ 145282683-145282684*w3,435848049-1*w3,871696101+435848051*w3,1307544151+1307544151*w3,1307544151+2615088301*w3,1+3922632451*w3,-435848051+3922632451*w3,-3632067084+3632067085*w3,-3922632450+3486784402*w3,-4358480502+3050936350*w3,-4794328552+2179240250*w3,-4794328552+871696100*w3,-3486784402-435848050*w3,-3050936350-435848050*w3 ],
   /* 42 */ [ 435848049-1*w3,871696101+435848051*w3,1307544151+1307544151*w3,1307544151+2615088301*w3,1+3922632451*w3,-3922632452+3922632451*w3,-4794328552+3486784401*w3,-10896201252+1*w3,-11332049304-435848051*w3,-11767897354-1307544151*w3,-11767897354-2615088301*w3,-10460353204-3922632451*w3,-6537720751-3922632451*w3,-5666024651-3486784401*w3 ],
   /* 43 */ [ 871696101+435848051*w3,1307544151+1307544151*w3,1307544151+2615088301*w3,1+3922632451*w3,-3922632452+3922632451*w3,-11767897354,-13075441504-1307544150*w3,-21792402507-10896201254*w3,-22228250557-11767897354*w3,-22228250557-13075441504*w3,-20920706407-14382985654*w3,-16998073954-14382985654*w3,-9152809052-10460353203*w3,-7845264902-9152809053*w3 ],
   /* 44 */ [ 1307544151+1307544151*w3,1307544151+2615088301*w3,1+3922632451*w3,-3922632452+3922632451*w3,-11767897354,-23535794707-11767897353*w3,-24843338857-14382985653*w3,-32688603760-32688603760*w3,-32688603760-33996147910*w3,-31381059610-35303692060*w3,-27458427157-35303692060*w3,-19613162255-31381059609*w3,-7845264902-19613162256*w3,-6537720752-16998073956*w3 ],
   /* 45 */ [ 1307544151+2615088301*w3,1+3922632451*w3,-3922632452+3922632451*w3,-11767897354,-23535794707-11767897353*w3,-35303692060-35303692059*w3,-35303692060-39226324512*w3,-32688603760-65377207519*w3,-31381059610-66684751669*w3,-27458427157-66684751669*w3,-19613162255-62762119218*w3,-7845264902-50994221865*w3,3922632451-27458427159*w3,3922632451-23535794706*w3 ],
   /* 46 */ [ 1+3922632451*w3,-3922632452+3922632451*w3,-11767897354,-23535794707-11767897353*w3,-35303692060-35303692059*w3,-35303692060-70607384121*w3,-31381059609-74530016572*w3,-1-98065811278*w3,3922632452-98065811278*w3,11767897354-94143178827*w3,23535794707-82375281474*w3,35303692060-58839486768*w3,35303692060-23535794706*w3,31381059609-19613162255*w3 ],
   /* 47 */ [ -3922632452+3922632451*w3,-11767897354,-23535794707-11767897353*w3,-35303692060-35303692059*w3,-35303692060-70607384121*w3,-105911076181*w3,11767897353-105911076181*w3,98065811279-98065811278*w3,105911076181-94143178827*w3,117678973534-82375281474*w3,129446870887-58839486768*w3,129446870887-23535794706*w3,94143178827+11767897354*w3,82375281474+11767897354*w3 ],
   /* 48 */ [ -11767897354,-23535794707-11767897353*w3,-35303692060-35303692059*w3,-35303692060-70607384121*w3,-105911076181*w3,105911076180-105911076181*w3,129446870886-94143178828*w3,294197433835,305965331188+11767897353*w3,317733228541+35303692059*w3,317733228541+70607384121*w3,282429536481+105911076181*w3,176518460301+105911076181*w3,152982665595+94143178828*w3 ],
   /* 49 */ [ -23535794707-11767897353*w3,-35303692060-35303692059*w3,-35303692060-70607384121*w3,-105911076181*w3,105911076180-105911076181*w3,317733228540-1*w3,353036920602+35303692061*w3,588394867669+294197433834*w3,600162765022+317733228540*w3,600162765022+353036920602*w3,564859072962+388340612662*w3,458947996782+388340612662*w3,247125844422+282429536482*w3,211822152360+247125844420*w3 ],
   /* 50 */ [ -35303692060-35303692059*w3,-35303692060-70607384121*w3,-105911076181*w3,105911076180-105911076181*w3,317733228540-1*w3,635466457083+317733228542*w3,670770149143+388340612662*w3,882592301503+882592301502*w3,882592301503+917895993564*w3,847288609443+953199685624*w3,741377533263+953199685624*w3,529555380903+847288609444*w3,211822152360+529555380901*w3,176518460300+458947996781*w3 ]
 ]};

gp_inline__location="../terdragon.tex:25859";
 \\ for k>=6
 PT1_samples = vector(#gen_convex_hull_T_samples-6,i, gen_convex_hull_T_samples[i+6][1]);
 PT2_samples = vector(#gen_convex_hull_T_samples-6,i, gen_convex_hull_T_samples[i+6][2]);
 PT3_samples = vector(#gen_convex_hull_T_samples-6,i, gen_convex_hull_T_samples[i+6][3]);
 PT4_samples = vector(#gen_convex_hull_T_samples-6,i, gen_convex_hull_T_samples[i+6][4]);
 PT5_samples = vector(#gen_convex_hull_T_samples-6,i, gen_convex_hull_T_samples[i+6][5]);
 PT6_samples = vector(#gen_convex_hull_T_samples-6,i, gen_convex_hull_T_samples[i+6][6]);
 PT7_samples = vector(#gen_convex_hull_T_samples-6,i, gen_convex_hull_T_samples[i+6][7]);

gp_inline__location="../terdragon.tex:25868";
 near_list_by_points(k,pred) = {
   my(v=vector(3^k+1,n,n--; n));
   v=select(pred,v);
   v=apply(terdragon_point,v);  /* start each segment */

   \\ v=apply(n->my(z=terdragon_point(n),d=w3^dir(n));
   \\        vector(25,i,i--; z+d*i/24),
   \\        v);     /* fractions within segments */
   \\ v=concat(v);

   my(middle=1/2*b^k);
   my(dist=apply(z->geom_norm(middle-z),v));
   my(dist_minimum=vecmin(dist,&pos));
   my(l=List([]));
   for(i=1,#v,if(dist[i]==dist_minimum,listput(l,v[i])));
   vector_unique(Vec(l));
 }
 Rnear_list_by_points(k) = near_list_by_points(k,Rpred);
 Lnear_list_by_points(k) = {
   my(n_hi=3^k);
   near_list_by_points(k, n-> n==n_hi || Lpred_k(k,n));
 }

gp_inline__location="../terdragon.tex:25913";
 Lnear_list_1 = [ 1, 1/2 + 1/2*sqrt3i ];

gp_inline__location="../terdragon.tex:25921";
 Lnear_list_2 = [ 1/2 + 1/2*sqrt3i, 1 + sqrt3i ];

gp_inline__location="../terdragon.tex:25933";
 Lnearf = (19 + sqrt3i)/48;
 Lnear_formula(k) = Lnearf*b^k + 1/24*pt(k+1);

gp_inline__location="../terdragon.tex:25941";
 Lnear_list_5() = [Lnear_formula(5), -11/2 + 3/2*sqrt3i];

gp_inline__location="../terdragon.tex:25946";
 Lnear_list(k) = {
   if(k==0, [0, 1],
      k==1, Lnear_list_1,
      k==2, Lnear_list_2,
      k==5, Lnear_list_5(),
          [ Lnear_formula(k) ]);
 }

gp_inline__location="../terdragon.tex:25996";
 pt_vector = {[
   15,        6-9*w3,        -3-27*w3,        -3+18*w3,
  (15)*w3,   (6-9*w3)*w3,   (-3-27*w3)*w3,   (-3+18*w3)*w3,
  (15)*w3^2, (6-9*w3)*w3^2, (-3-27*w3)*w3^2, (-3+18*w3)*w3^2
 ]};
 pt(m) = vector_modulo(pt_vector,m);

gp_inline__location="../terdragon.tex:26013";
 Rnear_p_vector = {[
    -2+3*w3,        1+9*w3,        1-6*w3,        -5*w3,
   (-2+3*w3)*w3,   (1+9*w3)*w3,   (1-6*w3)*w3,   (-5*w3)*w3,
   (-2+3*w3)*w3^2, (1+9*w3)*w3^2, (1-6*w3)*w3^2, (-5*w3)*w3^2
 ]};
 Rnear_p(k) = vector_modulo(Rnear_p_vector,k);

gp_inline__location="../terdragon.tex:26022";
 Rnearf = (29 - sqrt3i)/48;
 Rnear_formula(k) = Rnearf*b^k + 1/8*Rnear_p(k);
 Rnear_list(k) = {
   if(k==0, [0, 1],
      k==1, Lnear_list_1,
      k==2, Lnear_list_2,
      k==5, [ -8+3*sqrt3i, Rnear_formula(k) ],
            [ Rnear_formula(k) ]);
 }

gp_inline__location="../terdragon.tex:26227";
 PT1(k) = if(k<0, error("PT1 is for k>=0, got ",k)); \
          -1/24 * (b^k + pt(k));
 PT2(k) = if(k<0, error("PT2 is for k>=0, got ",k)); \
          -1/24 * (b^(k+1) + pt(k+1));
 PT3(k) = if(k<0, error("PT3 is for k>=0, got ",k)); \
          -1/24 * (b^(k+2) + pt(k+2));
 PT4(k) = if(k<0, error("PT4 is for k>=0, got ",k)); \
          -1/24 * (b^(k+3) + pt(k+3));
 PT5(k) = if(k<0, error("PT5 is for k>=0, got ",k)); \
          -1/24 * (b^(k+4) + pt(k+4));
 PT6(k) = if(k<0, error("PT6 is for k>=0, got ",k)); \
          -1/24 * b^(k+5) - 1/24*pt(k+5);
 PT7(k) = if(k<0, error("PT7 is for k>=0, got ",k)); \
          -1/24*( (1+1/9*w6)*b^(k+5) + pt(k+6) );

gp_inline__location="../terdragon.tex:26250";
 PT1dash(k) = b^k - PT1(k);
 PT2dash(k) = b^k - PT2(k);
 PT3dash(k) = b^k - PT3(k);
 PT4dash(k) = b^k - PT4(k);
 PT5dash(k) = b^k - PT5(k);
 PT6dash(k) = b^k - PT6(k);
 PT7dash(k) = b^k - PT7(k);

gp_inline__location="../terdragon.tex:26258";
 PT_hull_formula(k) = {
   [ PT1(k),PT2(k),PT3(k),PT4(k),PT5(k),PT6(k),PT7(k),
     PT1dash(k),PT2dash(k),PT3dash(k),PT4dash(k),PT5dash(k),
     PT6dash(k),PT7dash(k) ];
 }
 PT_hull(k) = \
   if(k<=6, gen_convex_hull_T_samples[k+1], PT_hull_formula(k));

gp_inline__location="../terdragon.tex:26380";
 Lnear_by_PT4(k) = 1/3*b^k - PT4(k-2);

gp_inline__location="../terdragon.tex:26540";
 Lnearf_sample_real = {(03958333/10000000)};

gp_inline__location="../terdragon.tex:26545";
 Lnearf_sample_imag = {(0036084/1000000)};

gp_inline__location="../terdragon.tex:26567";
 Rnearf_sample_real = {(06041666/10000000)};

gp_inline__location="../terdragon.tex:26571";
 Rnearf_sample_imag = {-(0036084/1000000)};

gp_inline__location="../terdragon.tex:26599";
 Lnear_width_limit_sample = {(0220479/1000000)};

gp_inline__location="../terdragon.tex:26609";
 Lnearf_angle = arg(Rnearf-Lnearf);  \\ negative

gp_inline__location="../terdragon.tex:26614";
 Lnearf_angle_sample = {-(19106605/1000000)};

gp_inline__location="../terdragon.tex:26687";
 Lnear_formula_abs_squared(k) = {
   7/576 * 3^k
   + vector_modulo([-11/96, -3/32, -1/96, -5/32],k) * 3^floor(k/2)
   + vector_modulo([19/64, 73/64, 43/64, 25/64],k);
 }

gp_inline__location="../terdragon.tex:26713";
 LnearN_list(k) = {
   my(v=Lnear_list(k));
   v=apply(z->vector(3,d,terdragon_unpoint(z,d)), v);
   v=concat(v);
   v=select(elem->elem[2]==0, v);  \\ arm 0
   v=apply(elem->elem[1], v);
   v;
 }

gp_inline__location="../terdragon.tex:26738";
 Jnear_by_Ln_search(k) = {
   my(j=b^k,
      n_limit=2*3^k,
      min_norm=3^k, min_z_list=List([]),m=0);
   while(1,
     my(n=Ln_inf(m)); m++;
     if(n>n_limit,break());
     my(z=terdragon_point(n),
        nn=norm(z-j));
     if(nn<min_norm,
        min_z_list=List([z]); min_norm=nn,
        nn==min_norm,
        listput(min_z_list,z)));
   Set(min_z_list);
 }

gp_inline__location="../terdragon.tex:26755";
 Jnear_PT_hulls(k) = {
   my(v=PT_hull(k));
   concat([apply(z->z,             v),
           apply(z->z*w3 + b^k,    v),
           apply(z->z    + b^k*w3, v)]);
 }

gp_inline__location="../terdragon.tex:26765";
 Jnear_by_PT_search(k) = {
   if(k==0,return([1]));
   my(v=Set(w6*Jnear_PT_hulls(k-1)),
      j=b^k,
      nv=apply(z->norm(z-j),v),
      nmin=vecmin(nv));
   select(z->norm(z-j)==nmin, v);
 }

gp_inline__location="../terdragon.tex:26778";
 Jnear_extra(k) = {
   if(k==0,[1], k==1,[0], k==3,[w3+w6+w3], k==6,[0]);
 }

gp_inline__location="../terdragon.tex:26808";
 Jnear_list(k) = {
   if(k==0, [1],
      k==1, [1, w6],
      k==2, [sqrt3i],
      k==3, [JnearPT2(k), JnearPT2(k)+conj(b)],
      k==6, [JnearPT2(k), JnearPT2(k)-w6],
      [JnearPT2(k)]);
 }

gp_inline__location="../terdragon.tex:26845";
 Jnearf = 13/24 + 1/6*sqrt3i;
 JnearPT2(k) = Jnearf*b^k + 1/24*pt(k);

gp_inline__location="../terdragon.tex:26852";
 JnearPT1(k) = w6*(b^(k-1) + w3*PT1(k-1));
 JnearPT3(k) = w6*(b^(k-1) + w3*PT3(k-1));

gp_inline__location="../terdragon.tex:27063";
 Jnearf_sample_real = {(0541666/1000000)};

gp_inline__location="../terdragon.tex:27067";
 Jnearf_sample_imag = {+(0288675/1000000)};

gp_inline__location="../terdragon.tex:27265";
 Jnear_abs_limit_sample = {(0613788/1000000)};

gp_inline__location="../terdragon.tex:27292";
 Jnear_arg_limit_sample = {(28054880/1000000)};

gp_inline__location="../terdragon.tex:27311";
 Jnear_sub_1_arg_limit_sample = {(32204227/1000000)};

gp_inline__location="../terdragon.tex:27736";
 MR_initial_vector = {[0,3,9,33]};

gp_inline__location="../terdragon.tex:27746";
 MR_formula(k) = MrW(k)*MrH(k) / MrDen(k);
 MR(k) = \
   if(k<#MR_initial_vector, MR_initial_vector[k+1], MR_formula(k));

gp_inline__location="../terdragon.tex:27751";
 MR_samples = {[0,3,9,33,(2187)/(19),(25392)/(73),(205407)/(193)]};

gp_inline__location="../terdragon.tex:27765";
 MrW_factor = {(13)/(12)};

gp_inline__location="../terdragon.tex:27770";
 MrW_half = {[-9,18,-1,-30]};

gp_inline__location="../terdragon.tex:27777";
 MrW_constant = {[0,-3,-2,1]};
 MrW(k) = {
   MrW_factor * 3^k
   + 1/12 * vector_modulo(MrW_half,k) * 3^floor(k/2)
   + 1/4 * vector_modulo(MrW_constant,k);
 }

gp_inline__location="../terdragon.tex:27788";
 MrW_samples = {[81,276,787,2302,7047,21444]};

gp_inline__location="../terdragon.tex:27797";
 MrH_factor = {(13)/(36)};

gp_inline__location="../terdragon.tex:27802";
 MrH_half = {[-3,6,-1,-16]};

gp_inline__location="../terdragon.tex:27809";
 MrH_constant = {[0,-1,0,1]};
 MrH(k) = {
   MrH_factor * 3^k
   + 1/12 * vector_modulo(MrH_half,k) * 3^floor(k/2)
   + 1/4 * vector_modulo(MrH_constant,k);
 }

gp_inline__location="../terdragon.tex:27819";
 MrH_samples = {[27,92,261,754,2349,7148]};

gp_inline__location="../terdragon.tex:27830";
 MrDen(k) = norm(P7(k) - P1dash(k));

gp_inline__location="../terdragon.tex:27833";
 MrDen_factor = {(37)/(144)};

gp_inline__location="../terdragon.tex:27838";
 MrDen_half = {[-5,27,5,-27]};

gp_inline__location="../terdragon.tex:27845";
 MrDen_constant = {[1,7]};
 MrDen_by_powers(k) = {
   MrDen_factor * 3^k
   + 1/24 * vector_modulo(MrDen_half,k) * 3^floor(k/2)
   + 1/16 * vector_modulo(MrDen_constant,k);
 }

gp_inline__location="../terdragon.tex:27855";
 MrDen_samples = {[19,73,193,532,1669,5149]};

gp_inline__location="../terdragon.tex:28160";
 \\ area measured in unit triangles
 MR12_formula(k) = {
   3^(k+2)
   * real((P5dash(k) - P5(k))/b^(k+2))
   * geom_point_y((P2(k) - P2dash(k))/b^(k+2))
   / (sqrt3/4);
 }
 MR12(k) = if(k==0, 1, MR12_formula(k));

gp_inline__location="../terdragon.tex:28189";
 MR12_factor = {(91)/(48)};

gp_inline__location="../terdragon.tex:28194";
 MR12_half_vector = {[51,69,17,51]};

gp_inline__location="../terdragon.tex:28199";
 MR12_constant_vector = {[9,3,1,3]};

gp_inline__location="../terdragon.tex:28204";
 MR12_by_powers_formula(k) = {
   MR12_factor * 3^k
   - 1/24 * vector_modulo(MR12_half_vector,k) * 3^floor(k/2)
   + 1/16 * vector_modulo(MR12_constant_vector,k) ;
 }

gp_inline__location="../terdragon.tex:28214";
 MR12_samples = {[1,3,15,45,135,435]};

gp_inline__location="../terdragon.tex:28275";
 \\ measured in unit triangles
 MR23(k) = {
   3^k
   * real((P3(k) - P3dash(k))/b^k)
   * geom_point_y((P5(k) - P5dash(k))/b^k)
   / (sqrt3/4);
 }

gp_inline__location="../terdragon.tex:28290";
 MR23_factor = {(27)/(16)};

gp_inline__location="../terdragon.tex:28295";
 MR23_half_vector = {[15,9,9,27]};

gp_inline__location="../terdragon.tex:28301";
 MR23_constant_vector = {[3,1,3,9]};

gp_inline__location="../terdragon.tex:28312";
 MR23_samples = {[0,4,12,36,120,400]};

gp_inline__location="../terdragon.tex:28384";
 \\ measured in unit triangles
 MR34(k) = {
   3^(k+1)
   * real((P3(k) - P3dash(k))/b^(k+1))
   * geom_point_y((P6(k) - P6dash(k))/b^(k+1))
   / (sqrt3/4);
 }

gp_inline__location="../terdragon.tex:28401";
 MR34_factor = {(25)/(16)};

gp_inline__location="../terdragon.tex:28406";
 MR34_half_vector = {[5,15,15,25]};

gp_inline__location="../terdragon.tex:28412";
 MR34_constant_vector = {[1,3,9,3]};

gp_inline__location="../terdragon.tex:28423";
 MR34_samples = {[1,3,9,33,121,363]};

gp_inline__location="../terdragon.tex:28452";
 MR71(k) = {
   norm(P7(k) - P1dash(k))
   * real( (P4(k) - P4dash(k))
          / (P7(k) - P1dash(k)) )
   * geom_point_y( (P7(k) - P7dash(k))
                / (P7(k) - P1dash(k)) )
   / (sqrt3/4);
 }

gp_inline__location="../terdragon.tex:28478";
 MR71_real(k) = geom_point_x( (P4(k)-P4dash(k)) \
                               * conj(P7(k)-P1dash(k)) );
 MR71_imag(k) = geom_point_y( (P7(k)-P7dash(k)) \
                               * conj(P7(k)-P1dash(k)) );

gp_inline__location="../terdragon.tex:28517";
 MR71_factor = {(169)/(111)};

gp_inline__location="../terdragon.tex:28533";
 MR71_divided_fraction(k) = {
   (   MR71_B_factor(k) * 3^k
     + MR71_C_factor(k) * 3^floor(k/2)
     + MR71_D_factor(k)
   ) / MrDen(k);
 }
 MR71_divided(k) = {
   MR71_factor*3^k
   - MR71_A_factor(k) * 3^floor(k/2)
   + MR71_divided_fraction(k);
 }

gp_inline__location="../terdragon.tex:28549";
 MR71_A_vector = {[(1196)/(1369),(3354)/(1369),(6994)/(4107),(3380)/(1369)]};

gp_inline__location="../terdragon.tex:28556";
 MR71_A_factor(k) = vector_modulo(MR71_A_vector,k);

gp_inline__location="../terdragon.tex:28560";
 MR71_B_vector = {[-(491)/(5476),-(855)/(21904),(471)/(5476),-(23605)/(197136)]};

gp_inline__location="../terdragon.tex:28567";
 MR71_B_factor(k) = vector_modulo(MR71_B_vector,k);

gp_inline__location="../terdragon.tex:28571";
 MR71_C_vector = {[(299)/(5476),(3525)/(10952),(811)/(5476),(4003)/(32856)]};

gp_inline__location="../terdragon.tex:28578";
 MR71_C_factor(k) = vector_modulo(MR71_C_vector,k);

gp_inline__location="../terdragon.tex:28582";
 MR71_D_vector = {[0,(3)/(16),0,(1)/(16)]};

gp_inline__location="../terdragon.tex:28586";
 MR71_D_factor(k) = vector_modulo(MR71_D_vector,k);

gp_inline__location="../terdragon.tex:28765";
 \\ alpha = 0 is no unfold
 \\ alpha = Pi is fully unfolded to a straight line
 \\ top point p is circle radius 2/3 centred at -1/3
 path_of_unfold(alpha) = {
   my(p = -1/3 + 2/3*(-cos(alpha) + I*sin(alpha)));
   [-1, -p, p, 1];
 }

gp_inline__location="../terdragon.tex:28777";
 path_lengths(v) = vector(#v-1,i, abs(v[i] - v[i+1]));
 path_length(v) = vecsum(path_lengths(v));

gp_inline__location="../terdragon.tex:28780";
 path_lengths_totaldiff(v) = \
   v=path_lengths(v); sum(i=1,#v,v[i]-v[1]);

gp_inline__location="../terdragon.tex:28788";
 \\ "pm1" is a segment -1 to +1 of unit mass
 inertia_of_pm1 = geom_inertia_of_segment_m1(-1,1);
 Iz_of_pm1 = geom_inertia_Iz(inertia_of_pm1);
 inertia_of_unfold(alpha) = {
   my(v = path_of_unfold(alpha));
   geom_inertia_of_path_m1(v);  \\ unit mass
 }
 Iz_of_unfold(alpha) = geom_inertia_Iz(inertia_of_unfold(alpha));

gp_inline__location="../terdragon.tex:28875";
 I_exp(the) = exp(I*(Pi-the));
 I_beta(the) = 1/(2 + I_exp(the));

gp_inline__location="../terdragon.tex:28881";
 I_t(the) = abs(1 * I_beta(the));

gp_inline__location="../terdragon.tex:28888";
 I_r(the) = abs(1/2 - 1/2 * I_beta(the));

gp_inline__location="../terdragon.tex:28895";
 Iz_t_and_r(the) = 3*1/12*1/3*I_t(the)^2 + 2/3*I_r(the)^2;

gp_inline__location="../terdragon.tex:28903";
 Iz_from_beta(the) = 1/12*( abs(I_beta(the))^2 + 2*abs(1-I_beta(the))^2 );

gp_inline__location="../terdragon.tex:28918";
 Iz_sin_cos(the) = 1/12 * (1 + 2*( (1+cos(Pi-the))^2 + sin(Pi-the)^2 ) ) / ( (2+cos(Pi-the))^2 + sin(Pi-the)^2 );

gp_inline__location="../terdragon.tex:28932";
 the_60 = Pi/3;

gp_inline__location="../terdragon.tex:29218";
 Ix_line(z1,z2) = imag((z1+z2)/2)^2 \
                  + 1/12*imag(z1-z2)^2;

gp_inline__location="../terdragon.tex:29221";
 \\ Return vector of terdragon vertices,
 \\ shifted so 0 is their centroid.
 terdragon_points_at_centroid(k) = {
   my(centroid = terdragon_centroid(k));
   apply(z->(z-centroid), terdragon_points(k));
 }
 Ika_by_points(k,a) =
 {
   my(v=terdragon_points_at_centroid(k));
   my(rotate = 1/(w12_inexact^k * exp(a*I)));
   v *= rotate;
   sum(i=1,#v-1, Ix_line(v[i],v[i+1]));
 }

gp_inline__location="../terdragon.tex:29239";
 Ix_by_points(k) =
 {
   my(v=terdragon_points_at_centroid(k));
   my(rotate = 1/(w12_inexact^k));
   v *= rotate;
   sum(i=1,#v-1, Ix_line(v[i],v[i+1]));
 }

gp_inline__location="../terdragon.tex:29248";
 Iy_by_points(k) =
 {
   my(v=terdragon_points_at_centroid(k));
   my(rotate = 1/(w12_inexact^k) * I);
   v *= rotate;
   sum(i=1,#v-1, Ix_line(v[i],v[i+1]));
 }

gp_inline__location="../terdragon.tex:29257";
 I_inertia_by_points(k) =
 {
   my(v=terdragon_points_at_centroid(k));
   my(m=sum(i=1,#v-1, geom_inertia_of_segment(v[i],v[i+1])));
   geom_inertia_rotate_xydir(m, w12_times_sqrt3^k);
 }

gp_inline__location="../terdragon.tex:29279";
 I_inertia(k) = {[  Ix(k), -Ixy(k),  0;
                   -Ixy(k), Iy(k),   0;
                     0,      0,     Iz(k) ]};

gp_inline__location="../terdragon.tex:29308";
 Ix(k) = 1/84*( 2*9^k - vector_modulo([2,-3],k)*(-3)^floor(k/2) );

gp_inline__location="../terdragon.tex:29313";
 Ix_samples = {[0,(1)/(4),2,(69)/(4),156,(5625)/(4),12654,(455517)/(4)]};

gp_inline__location="../terdragon.tex:29338";
 Iy(k) = 1/84*( 5*9^k + vector_modulo([2,-3],k)*(-3)^floor(k/2) );

gp_inline__location="../terdragon.tex:29342";
 Iy_samples = {[(1)/(12),(1)/(2),(19)/(4),(87)/(2),(1563)/(4),(7029)/(2),(126531)/(4),(569403)/(2)]};

gp_inline__location="../terdragon.tex:29367";
 Ixy(k) = sqrt3 / 168 \
   * (2*9^k - vector_modulo([2,4],k)*(-3)^floor(k/2));

gp_inline__location="../terdragon.tex:29374";
 Ixy_samples = {[0,(1)/(12),1,(35)/(4),78,(2811)/(4),6327,(227763)/(4)]};

gp_inline__location="../terdragon.tex:29397";
 Iz(k) = 1/12 * 9^k;

gp_inline__location="../terdragon.tex:29400";
 Iz_samples = {[(1)/(12),(3)/(4),(27)/(4),(243)/(4),(2187)/(4),(19683)/(4)]};

gp_inline__location="../terdragon.tex:29438";
 Ika(k,a)= Ix(k)*cos(a)^2 - 2*Ixy(k)*cos(a)*sin(a) + Iy(k)*sin(a)^2;

gp_inline__location="../terdragon.tex:29531";
 xydir30 = [1/2*sqrt3; 1/2; 0];
 R30 = {[ 1/2*sqrt3,    -1/2,    0;
          1/2,       1/2*sqrt3,  0;
          0,              0,     1 ]};
 xydir_arg(p) = arg(geom_point_x(p)*1.0 + geom_point_y(p)*1.0*I);
 R90 = [0,-1,0;  1,0,0;  0,0,1];

gp_inline__location="../terdragon.tex:29547";
 xydir_minus90 = [0; -1; 0];
 Rminus90 = [0,1,0;  -1,0,0; 0,0,1];

gp_inline__location="../terdragon.tex:29587";
 I_by_parts_centroid_matrix_2x2 = {[0,0;0,1]};

gp_inline__location="../terdragon.tex:29595";
 matrix_pad_2x2_to_3x3(m) = concat([m,[0;0],[0,0,0]]);
 I_by_parts_centroid_matrix = \
   matrix_pad_2x2_to_3x3(I_by_parts_centroid_matrix_2x2); \
   I_by_parts_centroid_matrix[3,3]=1;
 I_inertia_by_parts(k) = {
   if(k==0,return([0,0,0; 0,1/12,0; 0,0,1/12]));
     2 * R30^-1 * I_inertia(k-1) * R30
   +     R30^3  * I_inertia(k-1) * R30^-3
   + 2 * 3^(k-1) * (1/2*sqrt3^(k-1))^2
       * R30 * I_by_parts_centroid_matrix * R30^-1;
 }

gp_inline__location="../terdragon.tex:29611";
 I_inertia_x1 = geom_inertia_of_point(1);
 I_inertia_symbolic = geom_inertia_of_Ix_Iy_Ixy('Ix, 'Iy, 'Ixy);
 I_inertia_by_parts_symbolic = {
     2 * R30^-1 * I_inertia_symbolic * R30
   +     R30^3  * I_inertia_symbolic * R30^-3
   + 2 * 't * (1/2)^2*'t
       * R30 * I_by_parts_centroid_matrix * R30^-1;
   \\ with 't representing 3^(k-1)
 }

gp_inline__location="../terdragon.tex:29633";
 Ix_by_mutual(k) = {
      3/2   * Ix(k-1)
    - sqrt3 * Ixy(k-1)
    + 3/2   * Iy(k-1)
    + 1/8*9^(k-1);
 }
 Ix_symbolic  = 3/2*'Ix - sqrt3*'Ixy + 3/2*'Iy + 1/8*'t^2;

gp_inline__location="../terdragon.tex:29651";
 Iy_by_mutual(k) = {
      3/2   * Ix(k-1)
    + sqrt3 * Ixy(k-1)
    + 3/2   * Iy(k-1)
    + 3/8*9^(k-1);
 }
 Iy_symbolic  = 3/2*'Ix + sqrt3*'Ixy + 3/2*'Iy + 3/8*'t^2;

gp_inline__location="../terdragon.tex:29669";
 Ixy_by_mutual(k) = {
      1/2*sqrt3   * Ix(k-1)
    - 1/2*sqrt3   * Iy(k-1)
    + 1/8*sqrt3*9^(k-1);
 }
 Ixy_symbolic = 1/2*sqrt3*'Ix - 1/2*sqrt3*'Iy + 1/8*sqrt3*'t^2;

gp_inline__location="../terdragon.tex:29677";
 Iz_symbolic = Ix_symbolic + Iy_symbolic;

gp_inline__location="../terdragon.tex:29699";
 Ixy_by_recurrence(k) = -3*Ixy(k-2) + sqrt3*9^(k-2);

gp_inline__location="../terdragon.tex:29708";
 Ixy_unsimplified(k) = {
   sqrt3*(9^k - 9^(k%2)*(-3)^floor(k/2))/(81-(-3))
   + Ixy(k%2) * (-3)^floor(k/2);
 }

gp_inline__location="../terdragon.tex:29796";
 I_d_squared_xydir(k) = [Ix(k)-Iy(k), -2*Ixy(k)];
 I_d_xydir(k) = geom_xydir_half(I_d_squared_xydir(k));

gp_inline__location="../terdragon.tex:29800";
 xydir_real_x(p) = {
   [ simplify(geom_point_x(p) * conj(geom_point_x(p))),
     geom_sqrt_as_quad(simplify(conj(geom_point_x(p))^2)
                       * simplify(geom_point_y(p)^2))
   ];
 }

gp_inline__location="../terdragon.tex:29807";
 \\ return 1 if matrix m has its non-diagonals nearly_equal to 0
 nearly_diagonal(m) = {
   for(i=1,matsize(m)[1],
     for(j=1,matsize(m)[2],
       if(i!=j && ! nearly_equal(m[i,j],0), return(0))));
   1;
 }

gp_inline__location="../terdragon.tex:29826";
 I_2arctan(k) = -2 * Ixy(k) / (Ix(k) - Iy(k));

gp_inline__location="../terdragon.tex:29833";
 I_2arctan_by_epsilon(k) = 2/sqrt3 - I_epsilon(k);

gp_inline__location="../terdragon.tex:29845";
 I_epsilon(k) = if(k%2==0, 14*sqrt3 / (9*(-27)^(k/2) + 12), 0);

gp_inline__location="../terdragon.tex:29848";
 Ix_sub_Iy(k) = \
   -1/84*( 3*9^k + vector_modulo([4,-6],k)*(-3)^floor(k/2) );

gp_inline__location="../terdragon.tex:29867";
 I_d_squared_xydir_limit = [sqrt3, 2];
 I_d_xydir_limit_inexact = \
   geom_xydir_half(I_d_squared_xydir_limit*1.0);

gp_inline__location="../terdragon.tex:29873";
 I_d_squared_xydir_limit2 = \
   simplify( I_d_squared_xydir_limit * sqrt3 );
 I_d_xydir_limit2 = geom_xydir_half(I_d_squared_xydir_limit2);

gp_inline__location="../terdragon.tex:29901";
 acos_other(c) = 2*Pi - acos(c);
 quadrant(a) = floor(a / (Pi/2)) % 4 + 1;

gp_inline__location="../terdragon.tex:29913";
 I_minimum_alpha = 1/4 * acos(-1/7);

gp_inline__location="../terdragon.tex:29916";
 I_minimum_alpha_decimal = {(24553302/1000000)};

gp_inline__location="../terdragon.tex:29940";
 I_maximum_alpha = I_minimum_alpha + Pi/2;

gp_inline__location="../terdragon.tex:29947";
 I_maximum_alpha_decimal = {(114553302/1000000)};

gp_inline__location="../terdragon.tex:30040";
 I_fractal = geom_inertia_of_Ix_Iy_Ixy(2/84, 5/84, sqrt3/84);

gp_inline__location="../terdragon.tex:30046";
 I_symbolic = geom_inertia_of_Ix_Iy_Ixy('Ix, 'Iy, 'Ixy);
 I_symbolic_rotated = geom_inertia_rotate_xydir(I_symbolic, x+y*I);

gp_inline__location="../terdragon.tex:30067";
 \\ I_fractal with unit mass, area 1/2

gp_inline__location="../terdragon.tex:30071";
 I_fractal_principal = {[ 1/24 - 1/168*sqrt21, 0, 0;
                          0, 1/24 + 1/168*sqrt21, 0;
                          0, 0, 1/12 ]};

gp_inline__location="../terdragon.tex:30120";
 \\ with centroid at origin 0
 hull_fractal_centred = apply(z->z-1/2,hull_fractal);
 hull_fractal_inertia = \
   geom_inertia_of_polygon(hull_fractal_centred);

gp_inline__location="../terdragon.tex:30134";
 HI_x = {(7261)/(884736)};

gp_inline__location="../terdragon.tex:30138";
 HI_x *= sqrt3;

gp_inline__location="../terdragon.tex:30142";
 HI_x_decimals = {(00142148/10000000)};

gp_inline__location="../terdragon.tex:30153";
 HI_y = {(58999)/(2654208)};

gp_inline__location="../terdragon.tex:30157";
 HI_y *= sqrt3;

gp_inline__location="../terdragon.tex:30160";
 HI_y_decimals = {(00385008/10000000)};

gp_inline__location="../terdragon.tex:30169";
 HI_xy = {(449)/(55296)};

gp_inline__location="../terdragon.tex:30174";
 HI_xy_decimals = {(00081199/10000000)};

gp_inline__location="../terdragon.tex:30186";
 HI_alpha_fraction = {(449)/(1163)};

gp_inline__location="../terdragon.tex:30190";
 HI_alpha_fraction *= sqrt3;

gp_inline__location="../terdragon.tex:30193";
 HI_minimum_alpha = 1/2*atan(HI_alpha_fraction);

gp_inline__location="../terdragon.tex:30196";
HI_minimum_alpha_sample = {(16885199/1000000)};

gp_inline__location="../terdragon.tex:30290";
 P4_limit_angle_z = 1/2 - P4_limit;
 P4_limit_angle = arg(P4_limit_angle_z);

gp_inline__location="../terdragon.tex:30295";
P4_limit_angle_sample = {(23413224/1000000)};

gp_inline__location="../terdragon.tex:30335";
 EndLength_samples_C = \
   [1,3,5,8,13,22,39,66,113,194,337,580,1005,1734];

gp_inline__location="../terdragon.tex:30365";
 EndLength_power_vector = {[11,19]};

gp_inline__location="../terdragon.tex:30374";
 EndLength_constant_vector = {[-3,-5,3,1]};

gp_inline__location="../terdragon.tex:30381";
 EndLength_formula(k) = {
   1/8*vector_modulo(EndLength_power_vector,k)*3^floor(k/2)
   + 1/4*k
   + 1/8*vector_modulo(EndLength_constant_vector,k);
 }
 EndLength(k) = if(k==1,3, EndLength_formula(k));

gp_inline__location="../terdragon.tex:30389";
 EndLength_samples = {[1,3,5,8,13,22,39,66,113,194]};

gp_inline__location="../terdragon.tex:30588";
 IndentV_by_mutual(h) = if(h==0,1, 3^(h-1) + IndentS(h-1));

gp_inline__location="../terdragon.tex:30592";
 IndentS_by_mutual(h) = if(h==0,0, IndentV(h-1));

gp_inline__location="../terdragon.tex:30595";
 IndentS(h) = 1/8*(3^h + vector_modulo([-1,5],h));
 IndentV(h) = IndentS(h+1);

gp_inline__location="../terdragon.tex:30605";
 IndentS_samples = {[0,1,1,4,10,31,91,274,820]};

gp_inline__location="../terdragon.tex:30624";
 IndentS_by_digits(h) = {
   my(v=vector(max(0,h-1),i, i%2));  \\ h-1 digits
   fromdigits(v,3) + if(h%2==1, 1);
 }

gp_inline__location="../terdragon.tex:30718";
 EndLengthEven_by_sum(h) = 3^h + 2*sum(j=0,h, IndentS(j));

gp_inline__location="../terdragon.tex:30757";
 EndLengthOdd_by_even(h) = 3^h + EndLengthEven_by_sum(h);

gp_inline__location="../terdragon.tex:30777";
 \\ Return a vpar of the terdragon triangle turn tree.
 \\ Vertices 1,2,3 are the connections, vertex 1 is the root.
 TT_vpar(k) = {
   if(k==0,return([]));
   if(k==1,return([0]));
   my(vpar=[0,4,4,1]);
   for(i=3,k,
       my(middle=#vpar+1,
          new_vpar=vpar_join(vpar,2,[0]),
          c2 = #new_vpar+2);  \\ 2 of appended
       new_vpar=vpar_join(new_vpar,middle,vpar);
       my(c3 = #new_vpar+2);  \\ 2 of appended
       new_vpar=vpar_join(new_vpar,middle,vpar);
       new_vpar=vpar_relabel_swap(new_vpar,2,c2);
       new_vpar=vpar_relabel_swap(new_vpar,3,c3);
       vpar=new_vpar);
   vpar;
 }

gp_inline__location="../terdragon.tex:30807";
 TT_vpar_by_replacement(k) = {
   if(k==0,return([]));
   my(v=[0]);
   for(i=2,k,v=vpar_star_replacement(v,4,0));
   v;
 }

gp_inline__location="../terdragon.tex:31511";
 TTV(k) = 1/2*(3^k-1);

gp_inline__location="../terdragon.tex:31534";
 TTDegCount0(k) = {
   k>=0 || error("TTDegCount0 is for k>=0");
   if(k==1,1, 0);
 }

gp_inline__location="../terdragon.tex:31550";
 TTDegCount1_formula(k) = 1/2*(3^(k-1) + 3);
 TTDegCount1(k) = {
   k>=0 || error("TTDegCount1 is for k>=0");
   if(k<=1,0, TTDegCount1_formula(k));
 }

gp_inline__location="../terdragon.tex:31560";
 TTDegCount1_samples = {[0,0,3,6,15,42,123,366]};

gp_inline__location="../terdragon.tex:31581";
 TTDegCount2_formula(k) = 1/2*(3^(k-1) - 3);
 TTDegCount2(k) = {
   k>=0 || error("TTDegCount2 is for k>=0");
   if(k<=1,0, TTDegCount2_formula(k));
 }

gp_inline__location="../terdragon.tex:31592";
 TTDegCount2_samples = {[0,0,0,3,12,39,120,363]};

gp_inline__location="../terdragon.tex:31614";
 TTDegCount3_formula(k) = 1/2*(3^(k-1) - 1);
 TTDegCount3(k) = {
   k>=0 || error("TTDegCount3 is for k>=0");
   if(k==0,0, TTDegCount3_formula(k));
 }

gp_inline__location="../terdragon.tex:31624";
 TTDegCount3_samples = {[0,0,1,4,13,40,121,364]};

gp_inline__location="../terdragon.tex:31631";
 TTDegCount_vector = \
   [TTDegCount0, TTDegCount1, TTDegCount2, TTDegCount3];
 TTDegCount(k,d) = \
   if(d<#TTDegCount_vector, TTDegCount_vector[d+1](k), 0);

gp_inline__location="../terdragon.tex:31693";
 TTdiameter_formula(k) = 2^k - 2;
 TTdiameter(k) = {
   k>=0 || error("TTdiameter() is for k>=0");
   if(k==0,-1,  \\ k=0 no vertices
         TTdiameter_formula(k));
 }

gp_inline__location="../terdragon.tex:31710";
 TTdiameter_samples = {[0,2,6,14,30,62,126]};

gp_inline__location="../terdragon.tex:31742";
 TTdiameterCount_formula(k) = 3*4^(k-2);
 TTdiameterCount(k) = {
   if(k==0,1,  /* k=0 one empty path */
      k==1,1,
      TTdiameterCount_formula(k));
 }

gp_inline__location="../terdragon.tex:31757";
 TTdiameterCount_samples = {[1,1,3,12,48,192,768]};

gp_inline__location="../terdragon.tex:31781";
 TTdiameterEnds_formula(k) = 3*2^(k-2);
 TTdiameterEnds(k) = if(k==0,0, k==1,1, TTdiameterEnds_formula(k));

gp_inline__location="../terdragon.tex:31792";
 TTdiameterEnds_samples = {[0,1,3,6,12,24,48]};

gp_inline__location="../terdragon.tex:31815";
 TTdiameterVertices_formula(k) = 3/4*(k-1)*2^k + 1;
 TTdiameterVertices(k) = {
   k>=0 || error("TTdiameterVertices is for k>=0");
   if(k==0,0, TTdiameterVertices_formula(k));
 }

gp_inline__location="../terdragon.tex:31825";
 TTdiameterVertices_samples = {[0,1,4,13,37,97,241]};

gp_inline__location="../terdragon.tex:32074";
 TTwidth(d) = 2^(hammingweight(d+1) - 1);
 CountOneBits(d) = hammingweight(d+1);

gp_inline__location="../terdragon.tex:32077";
 TTwidth_list(k) = \
   vector(if(k==0,0,TTdiameter(k)+1),d,d--; TTwidth(d));

gp_inline__location="../terdragon.tex:32082";
 TTwidth_samples = {[1,1,2,1,2,2,4,1,2,2,4,2,4,4,8]};

gp_inline__location="../terdragon.tex:32896";
 \\ v is a vecper [ [digit,digit, ..., digit], [ digit,digit, ... ] ]
 \\ which fixed and periodic part digits of fractional ternary.
 \\     f = 0.aaaaa (ppppp)repeat
 \\
 \\ Return a similar vector suitably mangled for a terdragon curve
 \\ point when taken in base b=1+w6 by vecper_frac_fromdigits().
 \\
 vecper_ternary_to_terdragon(v) = {
   my(debug=0);
   vecper_apply_state((a,d)->[ terdragon_digit(a) * w3^lift(d),
                               d+(a==1) ],
                      v,
                      Mod(0,3));  \\ state = direction mod 3
 }

gp_inline__location="../terdragon.tex:32913";
 \\ f is a rational fraction 0 <= f <= 1
 \\ Return complex number z location in terdragon fractal.
 terdragon_fpoint(f) = {
   my(v=vecper_frac_digits(f,3));
   v=vecper_ternary_to_terdragon(v);
   vecper_frac_fromdigits(v,b);
 }

gp_inline__location="../terdragon.tex:32943";
 fpoint_by_limit(f,k) = terdragon_point(floor(f * 3^k))/b^k;

gp_inline__location="../terdragon.tex:32967";
 fBpred_hullstouch_state_table = {[2,3,4;2,5,6;7,8,9;10,11,4;
   7,8,12;13,14,15;16,17,18;19,20,21;22,23,24;25,26,13;27,8,9;
   22,23,28;29,20,30;27,19,20;30,14,15;16,17,15;7,19,20;30,14,18;
   19,20,20;20,20,20;20,20,21;22,26,29;20,21,9;25,23,24;25,26,29;
   20,21,12;31,17,18;25,23,28;29,20,20;20,20,30;31,17,15]};
 fNonRpred_hullstouch_accepting = {[9,12,20,21,22,23,24,25,26,28,29
   ]};
 fNonLpred_hullstouch_accepting = {[7,14,15,16,17,18,19,20,27,30,31
   ]};
 fNonBpred_hullstouch_accepting = {[20]};
 fNonRpred_hullstouch_counts = [0,0,1,9,43,165,571,1869,5923,18405,56491,172029,521203,1573845,4742011,14266989,42882883,128812485,386765131,1160950749,3484162963,10455110325,31370573851,94122207309,282387593443,847204723365,2541698056171,7625261940669,22876121366323,68629035187605,205888447740091,617668027574829,1853009451433603];
 fNonLpred_hullstouch_counts = [0,0,1,9,43,165,571,1869,5923,18405,56491,172029,521203,1573845,4742011,14266989,42882883,128812485,386765131,1160950749,3484162963,10455110325,31370573851,94122207309,282387593443,847204723365,2541698056171,7625261940669,22876121366323,68629035187605,205888447740091,617668027574829,1853009451433603];
 fNonBpred_hullstouch_counts = [0,0,0,1,15,97,423,1561,5295,17137,53943,166921,510975,1553377,4701063,14185081,42719055,128484817,386109783,1159640041,3481541535,10449867457,31360088103,94101235801,282345650415,847120837297,2541530284023,7624926396361,22875450277695,68627693010337,205885763385543,617662658865721,1852998714015375];
 fNonRpred_hullstouch_minimized_size = 6;
 fNonLpred_hullstouch_minimized_size = 6;
 fNonBpred_hullstouch_minimized_size = 16;
 fNonBpred_hullstouch_contains = {[
   [],
   [],
   [],
   [[1,1,1]],
   [[0,1,1,1],[0,2,0,1],[0,2,1,2],[1,0,1,2],[1,1,0,1],[1,1,0,2],[1,1,1,0],[1,1,1,1],[1,1,1,2],[1,1,2,0],[1,1,2,1],[1,2,1,0],[2,0,1,0],[2,0,2,1],[2,1,1,1]]
 ]};

gp_inline__location="../terdragon.tex:32991";
 fBpred_hullsaround_state_table = {[2,3,4;2,5,6;7,8,9;10,11,4;
   12,13,14;15,16,17;18,19,20;21,22,23;24,25,26;27,28,29;30,31,32;
   18,19,20;33,34,23;35,36,37;38,39,40;41,42,43;44,16,17;18,19,45;
   12,46,47;44,48,49;50,51,52;53,54,55;56,57,58;35,59,60;61,62,32;
   63,25,26;27,28,60;43,64,65;66,67,68;69,70,49;21,71,72;24,25,26;
   50,51,52;53,54,55;35,59,60;56,73,32;74,36,37;38,39,43;43,43,43;
   43,67,68;69,70,49;50,51,52;43,43,43;43,43,40;44,16,17;50,75,47;
   43,43,43;41,42,43;44,48,49;50,51,52;43,67,55;43,43,43;43,43,43;
   43,43,43;43,43,43;43,43,43;53,39,43;56,57,58;43,64,65;66,43,43;
   43,43,43;61,76,58;27,28,60;56,57,58;35,36,37;38,39,43;43,43,43;
   43,67,68;69,70,77;12,78,52;53,54,55;56,57,58;61,76,58;27,28,60;
   43,67,55;53,39,43;44,16,17;50,75,47]};
 fNonRpred_hullsaround_eventually_accepting = {[9,14,22,23,24,25,
   26,27,28,32,34,35,36,37,38,39,43,47,51,52,53,54,55,56,57,58,59,
   60,61,62,63,64,65,66,67,71,72,73,74,75,76]};
 fNonLpred_hullsaround_eventually_accepting = {[7,12,16,17,18,19,
   20,21,22,30,33,34,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,
   54,55,56,57,61,67,68,69,70,71,75,76,77,78]};
 fNonBpred_hullsaround_eventually_accepting = {[22,34,39,43,47,51,
   52,53,54,55,56,57,61,67,71,75,76]};
 fNonRpred_hullsaround_eventually_counts = [0,0,1,9,43,165,571,1869,5923,18405,56491,172029,521203,1573845,4742011,14266989,42882883,128812485,386765131,1160950749,3484162963,10455110325,31370573851,94122207309,282387593443,847204723365,2541698056171,7625261940669,22876121366323,68629035187605,205888447740091,617668027574829,1853009451433603];
 fNonLpred_hullsaround_eventually_counts = [0,0,1,9,43,165,571,1869,5923,18405,56491,172029,521203,1573845,4742011,14266989,42882883,128812485,386765131,1160950749,3484162963,10455110325,31370573851,94122207309,282387593443,847204723365,2541698056171,7625261940669,22876121366323,68629035187605,205888447740091,617668027574829,1853009451433603];
 fNonBpred_hullsaround_eventually_counts = [0,0,0,1,15,97,423,1561,5295,17137,53943,166921,510975,1553377,4701063,14185081,42719055,128484817,386109783,1159640041,3481541535,10449867457,31360088103,94101235801,282345650415,847120837297,2541530284023,7624926396361,22875450277695,68627693010337,205885763385543,617662658865721,1852998714015375];

gp_inline__location="../terdragon.tex:33223";
 fRpred_state_table = {[ 1,2,3;    \\ R = 1
                         1,4,6;    \\ M = 2
                         5,2,3;    \\ E = 3
                         4,6,6;    \\ M2 = 4
                         6,6,5;    \\ E2 = 5
                         6,6,6 ]}; \\ non = 6
 fRpred_R = 1;
 fRpred_M = 2;
 fRpred_E = 3;
 fRpred_M2 = 4;
 fRpred_E2 = 5;
 fRpred_non = 6;
 fRpred_transition(state,digit) = fRpred_state_table[state,digit+1];
 fRpred_transitions(state,v) = \
   for(i=1,#v, state=fRpred_transition(state,v[i])); state;
 fRpred_by_states_of_vecper(v) = {
   v=vecper_apply_state((digit,state)->
                          state=fRpred_transition(state,digit);
                          [state!=fRpred_non,state],
                        v,
                        fRpred_R); \\ initial state
   vecper_is_equal(v, [[],[1]]);  \\ always accepting
 }
 fRpred_by_states_of_frac(f) = \
   fRpred_by_states_of_vecper(vecper_frac_digits(f,3));

gp_inline__location="../terdragon.tex:33624";
 hullsnontouch_min_distance = 0.21650635094611;

gp_inline__location="../terdragon.tex:33683";
 fBpred_apply_absent(z,d) = apply(o->z+d*o, hull_fractal);
 fBpred_surround_absent_points = {
   [ fBpred_apply_absent(-w6, w3),  \\ bottom left
     fBpred_apply_absent(-w6, 1),
     fBpred_apply_absent(-w3, 1),
     fBpred_apply_absent(2, w3),    \\ 4
     fBpred_apply_absent(2, w3^2),  \\ 5
     fBpred_apply_absent(w6, 1),
     fBpred_apply_absent(w3, 1),
     fBpred_apply_absent(w3, w3^2) ]; \\ 8
 };
 fBpred_max_distance_from_pos = -1;
 fBpred_max_distance_from(v) = {
   vecmax(apply(h-> vecmin(apply(z->geom_abs(z-h)*1.0,v),
                           &fBpred_max_distance_from_pos),
                hull_fractal));
 }
 fBpred_min_distance_from(v) = {
   vecmin(apply(h-> vecmin(apply(z->geom_abs(z-h)*1.0,v)),
                hull_fractal));
 }

gp_inline__location="../terdragon.tex:33937";
 vecper_is_exact(v,base=10) = {
   v=vecper_periodic(v);
   my(all_0=1, all_9=1);
   for(i=1,#v,
       if(v[i]!=0, all_0=0);
       if(v[i]!=base-1, all_9=0));
   all_0 || all_9;
 }

gp_inline__location="../terdragon.tex:34330";
 fRpred_of_vecper(v) = fRpred_by_states_of_vecper(v);
 fNonRpred_of_vecper(v) = !fRpred_of_vecper(v);

gp_inline__location="../terdragon.tex:34333";
 fVisits_is_R_2_of_vecper(v) = {
   ! vecper_is_exact(v,3)
   && fNonRpred_of_vecper(v)
   && fRpred_of_vecper([[], vecper_periodic(v)]);
 }

gp_inline__location="../terdragon.tex:34341";
 flip12_vecper(v) = vecper_apply(d->2-d,v);
 fLpred_of_vecper(v) = \
   fRpred_by_states_of_vecper(flip12_vecper(v));
 fNonLpred_of_vecper(v) = !fLpred_of_vecper(v);

gp_inline__location="../terdragon.tex:34350";
 fVisits_is_L_2_of_vecper(v) = {
   ! vecper_is_exact(v,3)
   && fNonLpred_of_vecper(v)
   && fLpred_of_vecper([[],vecper_periodic(v)]);
 }

gp_inline__location="../terdragon.tex:34356";
 fOther_R_vecper_by_runs(fv) = {
   my(pv=vecper_periodic(fv));
   fv=vecper_fixed(fv);
   if(#pv==0,error());
   my(out_fv=fv, out_pv=pv, prev=pv[1]);
   forstep(i=#pv,1,-1,
     if(Rpred_pair_is_disallowed(10*pv[i]+prev),error());
     out_pv[i]=if(pv[i]==0, if(prev==0,2,1), 0);
     prev=pv[i]);
   forstep(i=#fv,1,-1,
     if(Rpred_pair_is_disallowed(10*fv[i]+prev),
        fv[i]==1 || fv[i]==2 || error();
        out_fv[i]=3-fv[i];  \\ flip 1<->2
        return([out_fv,out_pv]));
     out_fv[i]=if(fv[i]==0, if(prev==0,2,1), 0);
     prev=fv[i]);
   error("no Rpred pair");
 }

gp_inline__location="../terdragon.tex:34376";
 \\ Check fOther formed by fvfunc.
 \\ fv is a vecper.
 \\ Only those which fvpred(fv) returns non-0 are considered.
 \\ Call otherfv = fvfunc(fv) gives another vecper.
 \\ fv and otherfv are checked to be different fractions f but at
 \\ same terdragon_fpoint() location.
 fOther_2_check(fvpred,fvfunc) = {
   my(debug=0,
      bad=0,
      count=0);
   forvec(v=vector(7,i,[0,2]),
   for(len=0,#v-1,
       my(fv=[v[1..len],v[len+1..#v]]);
       if(debug,print("fv="fv));
       fvpred(fv) || next();
       count++;
       if(debug,print("  count "count));
       my(f         = vecper_frac_fromdigits(fv,3),
          fOther_fv = fvfunc(fv),
          fOther    = vecper_frac_fromdigits(fOther_fv,3));
       if(f==fOther,
           error("oops, f==fOther, fv=",fv));
       my(z=terdragon_fpoint(f),
          fOther_z=terdragon_fpoint(fOther));
       if(z!=fOther_z,
          print("different location fv="fv" at "z);
          print("            fOther_fv="fOther_fv" at "fOther_z);
          if(bad++>=2, break(2)))));
   \\ print(count);
   bad==0;
 }

gp_inline__location="../terdragon.tex:34409";
 fOther_L_vecper_by_runs(fv) = {
   my(pv=vecper_periodic(fv));
   fv=vecper_fixed(fv);
   if(#pv==0,error());
   my(out_fv=fv, out_pv=pv, prev=pv[1]);
   forstep(i=#pv,1,-1,
     if(Lpred_is_pair_disallowed(10*pv[i]+prev),error());
     out_pv[i]=if(pv[i]==2, if(prev==2,0,1), 2);
     prev=pv[i]);
   forstep(i=#fv,1,-1,
     if(Lpred_is_pair_disallowed(10*fv[i]+prev),
        fv[i]==0 || fv[i]==1 || error();
        out_fv[i]=1-fv[i];  \\ flip 0<->1
        return([out_fv,out_pv]));
     out_fv[i]=if(fv[i]==2, if(prev==2,0,1), 2);
     prev=fv[i]);
   error("no Lpred pair");
 }

gp_inline__location="../terdragon.tex:34509";
 fOther_R_output_matrix = {[ 2,1,1;
                             0,2,2;
                             1,0,0 ]};
 fOther_R_reset_matrix = [ 0,0,0; 0,1,1; 1,0,0 ];
 fOther_L_output_matrix = {[ 2,2,1;
                             0,0,2;
                             1,1,0 ]};
 fOther_L_reset_matrix = [ 0,0,1; 1,1,0; 0,0,0 ];

gp_inline__location="../terdragon.tex:34518";
 fOther_R_output(h,l) = fOther_R_output_matrix[h+1,l+1];
 fOther_R_reset(h,l) = fOther_R_reset_matrix[h+1,l+1];
 fOther_R_vecper_by_pairs(fv) = {
   my(pv=vecper_periodic(fv));
   fv=vecper_fixed(fv);
   if(#pv==0,error());
   my(out_fv=fv,out_pv=pv);
   for(i=1,#fv,
       my(h=fv[i], l=if(i==#fv,pv[1],fv[i+1]));
       if(fOther_R_reset(h,l),out_fv=fv);
       out_fv[i]=fOther_R_output(h,l));
   for(i=1,#pv,
       my(h=pv[i], l=if(i==#pv,pv[1],pv[i+1]));
       if(fOther_R_reset(h,l), return('none));
       out_pv[i]=fOther_R_output(h,l));
   [out_fv,out_pv];
 }

gp_inline__location="../terdragon.tex:34539";
 fOther_R(f) = {
   my(fv=vecper_frac_digits(f,3));
   fv=fOther_vecper(fv);
   if(fv=='none,fv,vecper_frac_fromdigits(fv,b));
 }

gp_inline__location="../terdragon.tex:34561";
 fOther_L_output(h,l) = fOther_L_output_matrix[h+1,l+1];
 fOther_L_reset(h,l) = fOther_L_reset_matrix[h+1,l+1];
 fOther_L_vecper_by_pairs(fv) = {
   my(pv=vecper_periodic(fv));
   fv=vecper_fixed(fv);
   if(#pv==0,error());
   my(out_fv=fv,out_pv=pv);
   for(i=1,#fv,
       my(h=fv[i], l=if(i==#fv,pv[1],fv[i+1]));
       if(fOther_L_reset(h,l),out_fv=fv);
       out_fv[i]=fOther_L_output(h,l));
   for(i=1,#pv,
       my(h=pv[i], l=if(i==#pv,pv[1],pv[i+1]));
       if(fOther_L_reset(h,l), return('none));
       out_pv[i]=fOther_L_output(h,l));
   [out_fv,out_pv];
 }

gp_inline__location="../terdragon.tex:34580";
 fOther_L(f) = {
   my(fv=vecper_frac_digits(f,3));
   fv=fOther_vecper(fv);
   if(fv=='none,fv,vecper_frac_fromdigits(fv,b));
 }

gp_inline__location="../terdragon.tex:34759";
 fOther_R_vector(v) = {
   my(out_v=vector(#v-1));
   for(i=1,#v-1,
       my(h=v[i], l=v[i+1]);
       if(fOther_R_reset(h,l), error());
       out_v[i]=fOther_R_output(h,l));
   out_v;
 }

gp_inline__location="../terdragon.tex:35253";
 AltTurn(n) = {
   n>=1 || error();
   if((CountLowZeros(n) + LowestNonZero(n))%2==1, 1, -1);
 }

gp_inline__location="../terdragon.tex:35272";
 AltTurn_samples_str = \
 "+ -- + - ++ - ++ -- + - ++ -- + -- + - ++ -- + -- + - ++";
 AltTurn_samples = {[
   1, -1,-1, 1, -1, 1,1, -1, 1,1, -1,-1, 1, -1,
   1,1, -1,-1, 1, -1,-1, 1, -1, 1,1, -1
 ]};

gp_inline__location="../terdragon.tex:35294";
 CountLowZeros_samples = {[0,0,1,0,0,1,0,0,2,0,0,1,0,0]};

gp_inline__location="../terdragon.tex:35307";
 A007949(n) = {
   n>=1 || error("A007949() is for n>=1");
   valuation(n,3);
 }

gp_inline__location="../terdragon.tex:35328";
 next_AltTurn(n) = {
   n>=0 || error("next_AltTurn() is for n>=0");
   if((LowestNonTwo(n) + CountLowTwos(n))%2 == 0, 1, -1);
 }

gp_inline__location="../terdragon.tex:35381";
 Base9LowestNon0(n) = {
   n>=0||error();
   (n/9^valuation(n,9)) % 9;
 }
 AltTurn_by_base9(n) = {
   my(t=Base9LowestNon0(n));
   if(t==1 || t==4 || t==6 || t==7, 1, -1);
 }

gp_inline__location="../terdragon.tex:35393";
 Base9LowestNon0_samples = {[1,2,3,4,5,6,7,8,1,1,2,3,4]};

gp_inline__location="../terdragon.tex:35428";
 AltTurnLpred(n) = n>=1 && AltTurn(n)==1;

gp_inline__location="../terdragon.tex:35431";
 AltTurnLpred_samples = {[1,0,0,1,0,1,1,0,1,1,0,0,1,0,1,1,0]};

gp_inline__location="../terdragon.tex:35447";
 AltTurnLpred_at_n_samples = {[1,4,6,7,9,10,13,15,16,19,22,24]};

gp_inline__location="../terdragon.tex:35464";
 AltTurnRpred(n) = n>=1 && AltTurn(n)==-1;

gp_inline__location="../terdragon.tex:35467";
 AltTurnRpred_samples = {[0,1,1,0,1,0,0,1,0,0,1,1,0,1,0,0,1]};

gp_inline__location="../terdragon.tex:35481";
 \\ 0,1 as ternary lowest non-0 and its position
 A156595(n) = {
   n>=0 || error("A156595() is for n>=0");
   my(ret=0); while(n%3==2, ret=!ret; n\=3); (ret+(n%3))%2;
 }

gp_inline__location="../terdragon.tex:35518";
 AltTurnRpred_at_n_samples = {[2,3,5,8,11,12,14,17,18,20,21,23]};

gp_inline__location="../terdragon.tex:35529";
 \\ A064990, parity number of ternary 2s
 MephistoWaltz(n) = my(v=digits(n,3)); sum(i=1,#v, v[i]==2)%2;

gp_inline__location="../terdragon.tex:35534";
 \\ per A156595 making Sierpinski triangle by 120deg turns
 A156595_gasket_points(n) = {
   my(v=vector(n), z=0, dz=1);
   for(i=0,n-1,
     v[i+1]=z; z+=dz;
     if(A156595(i)==0, dz*=if(i%2==0,w3,conj(w3))));
   v;
 }

gp_inline__location="../terdragon.tex:35565";
 gAltTurnLpred_term(x,k) = \
   x^(vector_modulo([1,2],k) * 3^k) / (1 - x^(3^(k+1)));
 gAltTurnLpred(x,k) = sum(j=0,k, gAltTurnLpred_term(x,j));

gp_inline__location="../terdragon.tex:35575";
 gAltTurnRpred_term(x,k) = \
   x^(vector_modulo([2,1],k) * 3^k) / (1 - x^(3^(k+1)));
 gAltTurnRpred(x,k) = sum(j=0,k, gAltTurnRpred_term(x,j));

gp_inline__location="../terdragon.tex:35613";
 gAltTurn_term(x,k) = \
   (-1)^k * (x^(3^k) - x^(2*3^k)) / (1 - x^(3^(k+1)));
 gAltTurn(x,k) = sum(j=0,k, gAltTurn_term(x,j));

gp_inline__location="../terdragon.tex:35625";
 gAltTurnS_term(x,k) = (-1)^k * x^(3^k) / (1 + x^(3^k) + x^(2*3^k));
 gAltTurnS(x,k) = sum(j=0,k, gAltTurnS_term(x,j));

gp_inline__location="../terdragon.tex:35668";
 AltDir(n) = {
   my(v=digits(n,3));
   sum(i=0,#v-1, if(v[#v-i]==1, if(i%2==0, 1, -1)));
 }

gp_inline__location="../terdragon.tex:35673";
 AltDir_by_division2(n) = \
   my(ret=0); while(n, ret+=(n%3==1);n\=3; ret-=(n%3==1);n\=3); ret;
 AltDir_by_division3(n) = \
   my(ret=0); while(n, ret+=[0,1,0,-1,0,-1,0,1,0][n%9+1]; n\=9);ret;
 AltDir_by_division(n) = \
   my(s=1,ret=0); while(n, if(n%3==1,ret+=s); s=-s; n\=3); ret;

gp_inline__location="../terdragon.tex:35682";
 AltDir_by_digits(n) = \
  my(v=digits(n,3)); sum(i=1,#v, if(v[i]==1, (-1)^(#v-i)));

gp_inline__location="../terdragon.tex:35692";
 AltDir_by_base9(n) = {
   my(v=digits(n,9));
     sum(i=1,#v, v[i]==1 || v[i]==7)
   - sum(i=1,#v, v[i]==3 || v[i]==5);
 }

gp_inline__location="../terdragon.tex:35707";
 AltDir_samples = {[0,1,0,-1,0,-1,0,1,0,1,2,1,0,1,0,1,2,1]};

gp_inline__location="../terdragon.tex:35717";
 AltDir_is_0(n) = {
   my(v=Vecrev(digits(n,3)),count=[0,0]);
   for(i=1,#v, count[(i%2)+1] += (v[i]==1));
   count[1]==count[2];
 }

gp_inline__location="../terdragon.tex:35748";
 AltDir_max(k) = ceil(k/2);
 AltDir_min(k) = -floor(k/2);

gp_inline__location="../terdragon.tex:35772";
 AltTurnsL_by_sum(n) = sum(j=1,n,AltTurnLpred(j));

gp_inline__location="../terdragon.tex:35774";
 AltTurnsL_samples = {[1,1,1,2,2,3,4,4,5,6,6,6,7,7,8,9,9,9]};

gp_inline__location="../terdragon.tex:35785";
 AltTurnsR_by_sum(n) = sum(j=1,n,AltTurnRpred(j));

gp_inline__location="../terdragon.tex:35787";
 AltTurnsR_samples = {[0,1,2,2,3,3,3,4,4,4,5,6,6,7,7,7,8,9]};

gp_inline__location="../terdragon.tex:35799";
 AltTurnsR_by_division(n) = \
   my(s=-1,ret=n); while(n, if(n%3==1,ret+=s); s=-s; n\=3); ret/2;

gp_inline__location="../terdragon.tex:35804";
 AltTurnsR_by_digits(n) = \
  my(v=digits(n,3)); (n - sum(i=1,#v, if(v[i]==1, (-1)^(#v-i))) )/2;

gp_inline__location="../terdragon.tex:35830";
 AltTurnsL(n) = 1/2*(   n +         AltDir(n) );

gp_inline__location="../terdragon.tex:35837";
 AltTurnsR(n) = 1/2*     ( n - AltDir(n) );

gp_inline__location="../terdragon.tex:35843";
 \\ A189717 starts n=1 with A189717(0)=0, though OFFSET=1
 A189717(n) = if(n==0,0, (n+1)\3 + n\3 - A189717(n\3));

gp_inline__location="../terdragon.tex:35935";
 AltEnd(k) = vector_modulo([1,b],k)*3^floor(k/2);

gp_inline__location="../terdragon.tex:35950";
 AltEnd_samples = [1, 1+w6, 3, 3+3*w6, 9, 9+9*w6];

gp_inline__location="../terdragon.tex:35996";
 AltPoints(k) = {
   my(v=[0]);
   for(i=0,k-1,
     my(e=AltEnd(i),
        er=e*if(i%2==0,w6,conj(w6)),
        r=if(i%2==0,w3,conj(w3)));
     v=concat([v, apply(z->e+z*r,v), apply(z->z+er,v)]));
   concat(v,[AltEnd(k)]);
 }

gp_inline__location="../terdragon.tex:36025";
 AltPoint(n) = {
   if(n==0,return(0));
   my(a=n%3); n\=3;
   b*conj(AltPoint(n)) + terdragon_digit(a)*w3^AltDir(3*n);
 }

gp_inline__location="../terdragon.tex:36115";
 repetitions_histogram(v) = {
   v=vecsort(v,cmp);
   v=vector_run_lengths(v);
   my(counts=vector(vecmax(v)));
   for(i=1,#v, counts[v[i]]++);
   counts;
 }

gp_inline__location="../terdragon.tex:36212";
 AltRpred_disallowed_pairs = Set([10,21,22]);
 AltRpred_k(n,k) = {
   my(v=FlipOdd_k_vector(n,k));
   for(i=1,#v-1,
     my(pair=v[i]*10 + v[i+1]);
     if(setsearch(AltRpred_disallowed_pairs,pair),
        return(0)));
   1;
 }

gp_inline__location="../terdragon.tex:36228";
 FlipOdd_k_vector(n,k) = {
   my(v=ternary_padded(n,k));
   forstep(i=#v-1,1,-2, v[i]=2-v[i]);  \\ odd positions
   v;
 }
 FlipOdd_k(k,n) = fromdigits(FlipOdd_k_vector(k,n),3);

gp_inline__location="../terdragon.tex:36327";
 AltRpred_HtoL_state_table = {[ 6,5,4;   \\ 1 = Re
                                6,5,7;   \\ 2 = Me
                                7,7,4;   \\ 3 = Ee
                                1,2,3;   \\ 4 = Ro
                                7,2,3;   \\ 5 = Mo
                                1,7,7;   \\ 6 = Eo
                                7,7,7 ]}; \\ 7 = non
 AltRpred_HtoL_transition(state,digit) = \
   AltRpred_HtoL_state_table[state,digit+1];
 AltRpred_HtoL_transitions(state,v) = \
   for(i=1,#v, state=AltRpred_HtoL_transition(state,v[i])); state;
 AltRpred_HtoL_state(n,k) = \
   AltRpred_HtoL_transitions(if(k%2==0,1,4), ternary_padded(n,k));
 AltRpred_by_HtoL(n,k) = AltRpred_HtoL_state(n,k) != 7;

gp_inline__location="../terdragon.tex:36466";
 AltRpred3_LtoH_state_table = {[ 2,3,3;   \\ 1 = start
                                 4,6,5;   \\ 2 = o0
                                 6,4,5;   \\ 3 = o12
                                 2,3,6;   \\ 4 = e01
                                 2,6,3;   \\ 5 = e2
                                 6,6,6 ]}; \\ 6 = non
 AltRpred3_LtoH_transition(state,digit) = \
   AltRpred3_LtoH_state_table[state,digit+1];
 AltRpred3_LtoH_transitions(state,v) = \
   for(i=1,#v, state=AltRpred3_LtoH_transition(state,v[i])); state;
 AltRpred3_LtoH_state(n,k) = \
   AltRpred3_LtoH_transitions(1, Vecrev(ternary_padded(n,k)));
 AltRpred_by_LtoH(n,k) = AltRpred3_LtoH_state(n,k) != 6;

gp_inline__location="../terdragon.tex:36572";
 AltRpred9_state_table = {[ 1,5,5,5,2,3,1,2,3;    \\ 1=R
                            1,5,5,5,2,3,5,5,5;    \\ 2=M
                            5,5,5,5,5,5,1,2,3;    \\ 3=E
                            1,2,3,9,9,9,9,9,9;    \\ 4=O
                            5,5,5,5,5,5,5,5,5 ]}; \\ 5=non
 AltRpred9_transition(state,digit) = \
   AltRpred9_state_table[state,digit+1];
 AltRpred9_transitions(state,v) = \
   for(i=1,#v, state=AltRpred9_transition(state,v[i])); state;
 AltRpred9_state_by_high_to_low(n,k) = {
   AltRpred9_transitions(if(k%2==0,1,4),
                         digits_padded(n,ceil(k/2),9));
 }
 AltRpred9_by_HtoL(n,k) = \
   AltRpred9_state_by_high_to_low(n,k) != 5;

gp_inline__location="../terdragon.tex:36692";
 AltLpred_k(n,k) = {
   my(v=FlipEven_k_vector(n,k));
   for(i=1,#v-1,
     my(pair=v[i]*10 + v[i+1]);
     if(setsearch(AltRpred_disallowed_pairs,pair),
        return(0)));
   1;
 }

gp_inline__location="../terdragon.tex:36707";
 FlipEven_k_vector(n,k) = {
   my(v=ternary_padded(n,k));
   forstep(i=#v,1,-2, v[i]=2-v[i]);  \\ even positions
   v;
 }

gp_inline__location="../terdragon.tex:36731";
 AltRpred_inf(n) = AltRpred_k(n, #digits(n,3)+1);

gp_inline__location="../terdragon.tex:36733";
 AltRpred_inf_samples = {[1,0,0,0,1,1,1,1,1,0,0,0]};

gp_inline__location="../terdragon.tex:36740";
 AltRpred_inf_at_n_samples = {[0,4,5,6,7,8,36,40,41]};

gp_inline__location="../terdragon.tex:36752";
 AltLpred_inf(n) = AltLpred_k(n, #digits(n,3)+1);

gp_inline__location="../terdragon.tex:36754";
 AltLpred_inf_samples = {[1,1,1,0,0,0,0,0,0,0,0,0]};

gp_inline__location="../terdragon.tex:36761";
 AltLpred_inf_at_n_samples = {[0,1,2,12,13,17,18,19,20]};

gp_inline__location="../terdragon.tex:36800";
 AltRsides_k(n,k) = {
   my(state=AltRpred_HtoL_state(n,k));
   if(state==1 || state==4,                           1,
      state==2 || state==3 || state==5 || state==6,   2,
      state==7,                                       3,
      error("oops, unknown AltRpred_HtoL_state"));
 }

gp_inline__location="../terdragon.tex:36816";
 AltRsides_by_Rpred_arithmetically(n,k) = \
   3 - AltRpred_k(n,k)*vector_modulo([2,1,1],n);

gp_inline__location="../terdragon.tex:36821";
 AltRsides_by_AltRpred_and_low(n,k) = \
   if(AltRpred_k(n,k), if(n%3==0,1,2), 3);

gp_inline__location="../terdragon.tex:36830";
 AltRsides_inf(n) = AltRsides_k(n, #digits(n,3)+1);

gp_inline__location="../terdragon.tex:36832";
 AltRsides_inf_samples = {[1,3,3,3,2,2,1,2,2,3,3,3]};

gp_inline__location="../terdragon.tex:36847";
 \\ return a vector of all AltRpred segment numbers in level k
 AltRpred_k_list(k) = select(n->AltRpred_k(n,k), [0..3^k-1]);

gp_inline__location="../terdragon.tex:36875";
 gen_AltRTS_total_samples = [1,2,4,8,16,32,64,128,256,512,1024];
 gen_AltRTS_by_d_samples = {[
   1,1,2,3,6,11,22,43,86,171,342;
   0,0,1,2,5,10,21,42,85,170,341;
   0,1,1,3,5,11,21,43,85,171,341 ]};
 gen_AltSD_total_samples = [0,2,6,14,30,62,126,254,510,1022,2046];
 gen_AltSD_by_d_samples = {[
   0,0,2,4,10,20,42,84,170,340,682;
   0,0,2,4,10,20,42,84,170,340,682;
   0,2,2,6,10,22,42,86,170,342,682 ]};
 gen_AltLines_samples = [1,3,7,15,31,63,127,255,511,1023,2047];
 gen_AltLines_by_d_samples = {[
   1,2,3,6,11,22,43,86,171,342,683;
   0,1,2,5,10,21,42,85,170,341,682;
   0,0,2,4,10,20,42,84,170,340,682 ]};
 \\ gen_AltLines_lengths_by_d_samples[d+1,k+1][len]
 \\ is count how many lines of length "len"
 gen_AltLines_lengths_by_d_samples = {[
   [0,1], [0,2], [0,2,0,1], [0,2,2,2], [0,4,0,4,2,0,0,0,0,1], [0,6,2,4,2,0,2,2,2,2], [0,12,0,8,4,0,0,0,0,12,0,0,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,1], [0,20,4,12,6,0,2,2,2,12,0,0,4,2,0,0,0,0,2,2,4,2,2,0,2,2,2,2], [0,40,4,24,12,0,0,0,0,24,0,0,8,4,0,0,0,0,0,0,0,0,0,0,4,0,0,32,0,0,0,0,0,0,0,0,12,0,0,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1], [0,70,18,40,20,0,8,2,2,36,0,0,12,6,0,0,0,0,2,2,4,2,2,0,6,2,2,32,0,0,0,0,0,0,0,0,12,0,0,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,4,2,4,0,4,4,4,2,2,2,2,2,0,0,0,0,2,2,4,2,2,0,2,2,2,2], [0,140,32,80,40,0,10,0,2,72,0,0,24,12,0,0,0,0,0,0,0,0,0,0,8,0,0,64,0,0,0,0,0,0,0,0,24,0,0,8,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,10,0,2,0,0,0,8,0,0,84,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,32,0,0,0,0,0,0,0,0,12,0,0,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1];
   [], [0,1], [0,2], [0,2,2,1], [0,2,4,2,2], [0,4,4,2,2,4,2,2,0,1], [0,4,10,2,2,4,6,2,2,2,2,2,2,2], [0,12,12,6,4,4,6,2,2,2,2,2,2,2,8,4,4,0,2,2,2,2,2,0,0,0,0,1], [0,14,32,6,4,4,20,2,6,2,2,2,2,2,8,4,4,0,12,2,4,2,2,0,4,0,2,2,2,2,2,2,4,2,2,0,2,2,2,2,2], [0,44,44,22,12,4,24,2,8,14,2,2,6,4,8,4,4,0,12,2,4,2,2,0,4,0,2,2,2,2,2,2,4,2,2,0,2,2,2,2,2,16,8,8,0,4,4,4,4,4,0,0,0,0,2,2,2,2,2,4,2,2,0,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,1], [0,60,114,26,14,4,72,2,20,14,2,2,6,4,8,6,4,0,48,2,8,2,2,0,12,0,6,2,2,2,2,2,4,2,2,0,2,2,2,2,2,16,8,8,0,4,4,4,4,4,0,2,0,0,28,2,4,2,2,4,6,2,2,2,2,2,2,2,0,0,0,0,10,0,2,0,0,0,4,0,2,2,2,2,2,2,4,2,2,0,2,2,2,2,2,8,4,4,0,2,2,2,2,2,0,0,0,0,2,2,2,2,2,4,2,2,0,2,2,2,2,2];
   [], [], [0,2], [0,2,2], [0,2,4,2,2], [0,2,6,2,4,0,6], [0,4,10,2,4,0,8,2,2,2,2,2,2,2], [0,4,20,2,4,0,16,0,2,2,4,2,4,6,0,2,0,0,16], [0,14,32,6,6,0,24,2,4,2,4,2,4,6,0,2,0,0,18,2,4,2,2,0,2,2,2,2,2,2,2,4,0,2,2,2,2,2,2,2,2], [0,18,70,6,6,0,52,0,8,2,4,2,4,6,0,4,0,0,42,0,2,0,0,0,4,0,2,2,4,2,4,8,0,2,2,2,4,6,4,6,8,0,2,0,0,6,0,0,0,0,0,4,0,0,42], [0,60,114,26,16,0,82,2,12,14,4,2,8,8,0,6,0,0,60,2,6,2,2,0,6,2,4,2,4,2,4,8,0,2,2,2,4,6,4,6,8,0,2,0,0,6,0,0,0,0,0,4,0,0,44,2,4,2,4,0,4,4,4,2,2,2,2,2,0,0,0,0,2,2,4,2,2,0,2,2,2,2,2,2,2,4,0,2,2,2,2,4,2,4,6,0,0,0,0,2,2,4,2,2,0,2,2,2,2,2,2,2,4,0,2,2,2,2,2,2,2,2] ]};

gp_inline__location="../terdragon.tex:36901";
 gen_AltLines_length = matsize(gen_AltLines_samples)[2];
 gen_AltLines_max_k = gen_AltLines_length - 1;

gp_inline__location="../terdragon.tex:37006";
 \\ FIXME: pending AltUnpoint
 AltRTS_dir(n,k) = {
   my(s=AltRsides_k(n,k));
   if(s==3, return(-1));
   my(d=dir(n)%3);
   if(s==1, return(d));
   my(next_z=AltPoint(n+1));
   my(next_n_and_arm=AltUnpoint(next_z,d-1));
   if(next_n_and_arm[2]!=0,return(-1)); \\ second side of 2-side
   (d+1)%3;
 }

gp_inline__location="../terdragon.tex:37018";
 AltRTS_by_count(k,d) = sum(n=0,3^k-1, AltRTS_dir(n)==d);

gp_inline__location="../terdragon.tex:37032";
 AltLines_by_direction_0(k) = \
   1/3*(2^(k+1) + vector_modulo([1,2],k));

gp_inline__location="../terdragon.tex:37036";
 AltLines_by_direction_0_samples = {[1,2,3,6,11,22,43,86,171]};

gp_inline__location="../terdragon.tex:37051";
 AltLines_by_direction_1(k) = \
   1/3*(2^(k+1) - vector_modulo([2,1],k));

gp_inline__location="../terdragon.tex:37054";
 AltLines_by_direction_1_samples = {[0,1,2,5,10,21,42,85,170]};

gp_inline__location="../terdragon.tex:37069";
 AltLines_by_direction_2(k) = \
   1/3*(2^(k+1) - vector_modulo([2,4],k));

gp_inline__location="../terdragon.tex:37072";
 AltLines_by_direction_2_samples = {[0,0,2,4,10,20,42,84,170]};

gp_inline__location="../terdragon.tex:37086";
 AltLines_by_direction_functions = {
   [ AltLines_by_direction_0,
     AltLines_by_direction_1,
     AltLines_by_direction_2 ];
 }
 AltLines_by_direction(k,d) = \
   vector_modulo(AltLines_by_direction_functions,d)(k);

gp_inline__location="../terdragon.tex:37139";
 AltRTS(k,d) = {
   if(d%3==0, 1/3*(2^k + vector_modulo([2,1],k)),
      d%3==1, 1/3*(2^k + vector_modulo([-1,-2],k)),
      d%3==2, 1/3*(2^k + vector_modulo([-1,1],k)),
      error());
 }

gp_inline__location="../terdragon.tex:37154";
 AltRTS_0_samples = {[1,1,2,3,6,11,22,43,86,171]};

gp_inline__location="../terdragon.tex:37166";
 AltRTS_1_samples = {[0,0,1,2,5,10,21,42,85,170]};

gp_inline__location="../terdragon.tex:37183";
 AltRTS_2_samples = {[0,1,1,3,5,11,21,43,85,171]};

gp_inline__location="../terdragon.tex:37204";
 AltSD(k,d) = 2*sum(j=0,k-1,AltRTS(j, d + (-1)^j));

gp_inline__location="../terdragon.tex:37223";
 AltSD_0_samples = {[0,0,2,4,10,20,42,84,170,340]};

gp_inline__location="../terdragon.tex:37237";
 AltSD_2_samples = {[0,2,2,6,10,22,42,86,170,342]};

gp_inline__location="../terdragon.tex:37263";
 AltLines_by_AltSD(k,d) = \
   1/2*(AltSD(k,d+1) + AltSD(k,d+2) + if(d%3==0,2));

gp_inline__location="../terdragon.tex:37303";
 vector_first_nonzero_index(v) = \
   for(i=1,#v, if(v[i],return(i))); 0;

gp_inline__location="../terdragon.tex:37317";
 gen_alternate_hull_samples = {[
   /* 0 */ [ 0,1 ],
   /* 1 */ [ 0,1,2+w3,1+w3 ],
   /* 2 */ [ 0,1-1*w3,2-1*w3,3,2+w3,1+w3 ],
   /* 3 */ [ 0,1-1*w3,2-1*w3,6+3*w3,5+4*w3,4+4*w3 ],
   /* 4 */ [ 0,4-4*w3,5-4*w3,9,5+4*w3,4+4*w3 ],
   /* 5 */ [ 0,4-4*w3,5-4*w3,18+9*w3,14+13*w3,13+13*w3 ],
   /* 6 */ [ 0,13-13*w3,14-13*w3,27,14+13*w3,13+13*w3 ],
   /* 7 */ [ 0,13-13*w3,14-13*w3,54+27*w3,41+40*w3,40+40*w3 ],
   /* 8 */ [ 0,40-40*w3,41-40*w3,81,41+40*w3,40+40*w3 ],
   /* 9 */ [ 0,40-40*w3,41-40*w3,162+81*w3,122+121*w3,121+121*w3 ],
   /* 10 */ [ 0,121-121*w3,122-121*w3,243,122+121*w3,121+121*w3 ],
   /* 11 */ [ 0,121-121*w3,122-121*w3,486+243*w3,365+364*w3,364+364*w3 ],
   /* 12 */ [ 0,364-364*w3,365-364*w3,729,365+364*w3,364+364*w3 ],
   /* 13 */ [ 0,364-364*w3,365-364*w3,1458+729*w3,1094+1093*w3,1093+1093*w3 ],
   /* 14 */ [ 0,1093-1093*w3,1094-1093*w3,2187,1094+1093*w3,1093+1093*w3 ],
   /* 15 */ [ 0,1093-1093*w3,1094-1093*w3,4374+2187*w3,3281+3280*w3,3280+3280*w3 ],
   /* 16 */ [ 0,3280-3280*w3,3281-3280*w3,6561,3281+3280*w3,3280+3280*w3 ],
   /* 17 */ [ 0,3280-3280*w3,3281-3280*w3,13122+6561*w3,9842+9841*w3,9841+9841*w3 ],
   /* 18 */ [ 0,9841-9841*w3,9842-9841*w3,19683,9842+9841*w3,9841+9841*w3 ],
   /* 19 */ [ 0,9841-9841*w3,9842-9841*w3,39366+19683*w3,29525+29524*w3,29524+29524*w3 ],
   /* 20 */ [ 0,29524-29524*w3,29525-29524*w3,59049,29525+29524*w3,29524+29524*w3 ]
 ]};

gp_inline__location="../terdragon.tex:37511";
 AltP1(k) = 1/2*conj(b)*(3^floor(k/2) - 1);

gp_inline__location="../terdragon.tex:37518";
 AltP1dash(k) = AltP2dash(k) + 1;

gp_inline__location="../terdragon.tex:37522";
 AltP2(k) = AltP1(k) + 1;

gp_inline__location="../terdragon.tex:37532";
 AltP2dash(k) = 1/2*w6*(3^ceil(k/2) - 1);

gp_inline__location="../terdragon.tex:37719";
 AltPC(k) = 1/2*conj(b) * 3^floor(k/2);

gp_inline__location="../terdragon.tex:37730";
 AltPCdash(k) = 1/2*w6 * 3^ceil(k/2);

gp_inline__location="../terdragon.tex:37748";
 alt_hull_side1_n_list(k) = {
   my(l=List([]));
   for(n=0,3^k,
     if(z_is_hull_side1(AltPoint(n)), listput(l,n)));
   Vec(l);
 }

gp_inline__location="../terdragon.tex:37780";
 alt_hull_side2dash_n_list(k) = {
   my(l=List([]));
   for(n=0,3^k,
     if(z_is_alt_hull_side2dash(AltPoint(n)), listput(l,n)));
   Vec(l);
 }

gp_inline__location="../terdragon.tex:37883";
 z_is_hull_side1(z) = imag(z*w12_times_sqrt3)==0;
 z_is_alt_hull_side2dash(z) = imag(z/w6)==0;

gp_inline__location="../terdragon.tex:37886";
 alt_hull_side1_num_touches(k) = {
   my(v=AltPoints(k));
   sum(i=1,#v, z_is_hull_side1(v[i]));
 }

gp_inline__location="../terdragon.tex:37893";
 alt_hull_side2dash_num_touches(k) = {
   my(v=AltPoints(k));
   sum(i=1,#v, z_is_alt_hull_side2dash(v[i]));
 }

gp_inline__location="../terdragon.tex:37911";
 \\ inertia tensor matrix for level k rotated so X axis endpoints
 AltI_inertia_by_points(k) =
 {
   my(v=AltPoints(k),
      c=AltEnd(k)/2);
   v = apply(z->z-c, v);
   my(m=sum(i=1,#v-1, geom_inertia_of_segment(v[i],v[i+1])));
   geom_inertia_rotate_xydir(m, c);
 }

gp_inline__location="../terdragon.tex:37950";
 AltI_inertia(k) = {[  AltIx(k), -AltIxy(k),  0;
                      -AltIxy(k), AltIy(k),   0;
                       0,      0,           Iz(k) ]};

gp_inline__location="../terdragon.tex:37978";
 AltIx(k) = 1/156*( 5*9^k - vector_modulo([5,6],k)*3^floor(k/2) );

gp_inline__location="../terdragon.tex:37983";
 AltIx_samples = {[0,(1)/(4),(5)/(2),(93)/(4),210,(7569)/(4),(34065)/(2)]};

gp_inline__location="../terdragon.tex:38006";
 AltIy(k) = 1/156*( 8*9^k + vector_modulo([5,6],k)*3^floor(k/2) );

gp_inline__location="../terdragon.tex:38013";
 AltIy_samples = {[(1)/(12),(1)/(2),(17)/(4),(75)/(2),(1347)/(4),(6057)/(2),(109017)/(4)]};

gp_inline__location="../terdragon.tex:38038";
 AltIxy(k) = - (-1)^k * sqrt3 / 156 \
   * (2*9^k - vector_modulo([2,5],k)*3^floor(k/2));

gp_inline__location="../terdragon.tex:38045";
 AltIxy_samples = {[0,(1)/(12),-1,(37)/(4),-84,(3027)/(4),-6813]};

gp_inline__location="../terdragon.tex:38077";
 AltIx_by_mutual(k) = {
      3/2   * AltIx(k-1)
    + (-1)^k * sqrt3 * AltIxy(k-1)
    + 3/2   * AltIy(k-1)
    + 1/8*9^(k-1);
 }

gp_inline__location="../terdragon.tex:38092";
 AltIy_by_mutual(k) = {
      3/2   * AltIx(k-1)
    - (-1)^k * sqrt3 * AltIxy(k-1)
    + 3/2   * AltIy(k-1)
    + 3/8*9^(k-1);
 }

gp_inline__location="../terdragon.tex:38111";
 AltIxy_by_mutual(k) = {
   (-1)^k * (
    - 1/2*sqrt3   * AltIx(k-1)
    + 1/2*sqrt3   * AltIy(k-1)
    - 1/8*sqrt3*9^(k-1)
   );
 }

gp_inline__location="../terdragon.tex:38127";
 AltI_d_squared_xydir(k) = [AltIx(k)-AltIy(k), -2*AltIxy(k)];
 AltI_d_xydir(k) = geom_xydir_half(AltI_d_squared_xydir(k));

gp_inline__location="../terdragon.tex:38144";
 AltI_2arctan(k) = -2 * AltIxy(k) / (AltIx(k) - AltIy(k));

gp_inline__location="../terdragon.tex:38153";
 AltI_2arctan_by_epsilon(k) = \
   - (-1)^k * 4/sqrt3  -  AltI_epsilon(k);

gp_inline__location="../terdragon.tex:38165";
 AltI_epsilon(k) = {
    26 * vector_modulo([-2,3],k) * sqrt3 * 3^floor(k/2)
    /( 3*( 3*9^k + vector_modulo([10,12],k)*3^floor(k/2) ));
 }

gp_inline__location="../terdragon.tex:38170";
 AltIx_sub_AltIy(k) = \
   -1/156*( 3*9^k + vector_modulo([10,12],k)*3^floor(k/2) );

gp_inline__location="../terdragon.tex:38202";
 AltI_minimum_alpha = -1/2 * atan(4/sqrt3);

gp_inline__location="../terdragon.tex:38205";
 AltI_minimum_alpha_decimal = {-(33293387/1000000)};

gp_inline__location="../terdragon.tex:38219";
 AltI_maximum_alpha = AltI_minimum_alpha + Pi/2;

gp_inline__location="../terdragon.tex:38222";
 AltI_maximum_alpha_decimal = {(56706612/1000000)};

gp_inline__location="../terdragon.tex:38233";
 AltIka(k,a) = \
 AltIx(k)*cos(a)^2 - 2*AltIxy(k)*cos(a)*sin(a) + AltIy(k)*sin(a)^2;

gp_inline__location="../terdragon.tex:38338";
 AltI_fractal = geom_inertia_of_Ix_Iy_Ixy(5/156, 8/156, -sqrt3/78);

gp_inline__location="../terdragon.tex:38346";
 \\ I_fractal with unit mass, area 1/2

gp_inline__location="../terdragon.tex:38350";
 AltI_fractal_principal = {[ 1/24 - 1/312*sqrt57, 0, 0;
                             0, 1/24 + 1/312*sqrt57, 0;
                             0, 0, 1/12 ]};

gp_inline__location="../terdragon.tex:38508";
 AltDiameter(k) = if(k%2==0, 3^floor(k/2), 2*3^floor(k/2)+1);

gp_inline__location="../terdragon.tex:38510";
 AltDiameter_samples = {[1,3,3,7,9,19,27,55,81,163]};

gp_inline__location="../terdragon.tex:38522";
 \\ from devel/terdragon-nauty.c
 AltDiameter_samples_C = [1, 3, 3, 7, 9, 19, 27, 55, 81, 163];

gp_inline__location="../terdragon.tex:38546";
 AltDiameterEndpoints_formula(k) = 5*2^(k/2-1);
 AltDiameterEndpoints(k) = {
   if(k==0 || k%2==1,   2,
      k==2,             6,
      AltDiameterEndpoints_formula(k));
 }

gp_inline__location="../terdragon.tex:38557";
 AltDiameterEndpoints_samples = {[2,2,6,2,10,2,20,2,40]};

gp_inline__location="../terdragon.tex:38764";
 gen_AltDiameter_half_num_edges = [0,1,4,13,40,121,364,1093];
 gen_AltDiameter_half_num_vertices = [0,2,4,9,22,57,154,429];
 gen_AltDiameter_half_diameters = [0,1,2,3,6,10,18,31];

gp_inline__location="../terdragon.tex:38787";
 AltDiameter_half(k) = {
   if(k<0, error("AltDiameter_half() is for k>=0"));
   if(k <= 4, gen_AltDiameter_half_diameters[k+1],
      3*AltDiameter_half(k-2)+4);
 }

kill(gp_inline__location);
